#ifndef __RESIZE__
#define __RESIZE__ 1

#define RESIZE_FLAG_NOCHANGE_WIDTH 0
#define RESIZE_FLAG_FIXED_WIDTH 1			// refWidthControl = width in pixels
#define RESIZE_FLAG_SAME_DISTANCE_CONTROL_POS_LEFT_WIDTH 4
#define RESIZE_FLAG_SAME_DISTANCE_CONTROL_POS_RIGHT_WIDTH 8
#define RESIZE_FLAG_SAME_AS_CONTROL_WIDTH_WIDTH RESIZE_FLAG_SAME_DISTANCE_CONTROL_POS_LEFT_WIDTH|RESIZE_FLAG_SAME_DISTANCE_CONTROL_POS_RIGHT_WIDTH
#define RESIZE_FLAG_RELATIVE_TO_WIDTH_WIDTH 16
#define RESIZE_FLAG_RELATIVE_TO_POS_LEFT_WIDTH 32
#define RESIZE_FLAG_RELATIVE_TO_POS_RIGHT_WIDTH 64
#define RESIZE_FLAG_SAME_DISTANCE_CONTROL_MIDDLE_WIDTH 128
#define RESIZE_MASK_WIDTH_NEED_REF (RESIZE_FLAG_SAME_DISTANCE_CONTROL_POS_LEFT_WIDTH|RESIZE_FLAG_SAME_DISTANCE_CONTROL_POS_RIGHT_WIDTH|RESIZE_FLAG_RELATIVE_TO_WIDTH_WIDTH|RESIZE_FLAG_RELATIVE_TO_POS_LEFT_WIDTH|RESIZE_FLAG_RELATIVE_TO_POS_RIGHT_WIDTH|RESIZE_FLAG_SAME_DISTANCE_CONTROL_MIDDLE_WIDTH)

#define RESIZE_FLAG_NOCHANGE_HEIGHT 0
#define RESIZE_FLAG_FIXED_HEIGHT 0x100
#define RESIZE_FLAG_SAME_DISTANCE_CONTROL_POS_TOP_HEIGHT 0x400
#define RESIZE_FLAG_SAME_DISTANCE_CONTROL_POS_BOTTOM_HEIGHT 0x800
#define RESIZE_FLAG_SAME_AS_CONTROL_HEIGHT_HEIGHT RESIZE_FLAG_SAME_DISTANCE_CONTROL_POS_TOP_HEIGHT|RESIZE_FLAG_SAME_DISTANCE_CONTROL_POS_BOTTOM_HEIGHT
#define RESIZE_FLAG_RELATIVE_TO_HEIGHT_HEIGHT 0x1000
#define RESIZE_FLAG_RELATIVE_TO_POS_TOP_HEIGHT 0x2000
#define RESIZE_FLAG_RELATIVE_TO_POS_BOTTOM_HEIGHT 0x4000
#define RESIZE_FLAG_SAME_DISTANCE_CONTROL_MIDDLE_HEIGHT 0x8000
#define RESIZE_MASK_HEIGHT_NEED_REF (RESIZE_FLAG_SAME_DISTANCE_CONTROL_POS_TOP_HEIGHT|RESIZE_FLAG_SAME_DISTANCE_CONTROL_POS_BOTTOM_HEIGHT|RESIZE_FLAG_RELATIVE_TO_HEIGHT_HEIGHT|RESIZE_FLAG_RELATIVE_TO_POS_TOP_HEIGHT|RESIZE_FLAG_RELATIVE_TO_POS_BOTTOM_HEIGHT|RESIZE_FLAG_SAME_DISTANCE_CONTROL_MIDDLE_HEIGHT)

#define RESIZE_FLAG_NOCHANGE_POS_X 0
#define RESIZE_FLAG_FIXED_POS_X 0x10000
#define RESIZE_FLAG_SAME_DISTANCE_CONTROL_POS_LEFT_POS_X 0x20000
#define RESIZE_FLAG_SAME_DISTANCE_CONTROL_POS_RIGHT_POS_X 0x40000
#define RESIZE_FLAG_RELATIVE_TO_CONTROL_POS_LEFT_POS_X 0x80000
#define RESIZE_FLAG_RELATIVE_TO_CONTROL_POS_RIGHT_POS_X 0x100000
#define RESIZE_FLAG_SAME_DISTANCE_CONTROL_MIDDLE_POS_X 0x200000
#define RESIZE_MASK_POSX_NEED_REF (RESIZE_FLAG_SAME_DISTANCE_CONTROL_POS_LEFT_POS_X|RESIZE_FLAG_SAME_DISTANCE_CONTROL_POS_RIGHT_POS_X|RESIZE_FLAG_RELATIVE_TO_CONTROL_POS_LEFT_POS_X|RESIZE_FLAG_RELATIVE_TO_CONTROL_POS_RIGHT_POS_X|RESIZE_FLAG_SAME_DISTANCE_CONTROL_MIDDLE_POS_X)

#define RESIZE_FLAG_NOCHANGE_POS_Y 0
#define RESIZE_FLAG_FIXED_POS_Y 0x1000000
#define RESIZE_FLAG_SAME_DISTANCE_CONTROL_POS_TOP_POS_Y 0x2000000
#define RESIZE_FLAG_SAME_DISTANCE_CONTROL_POS_BOTTOM_POS_Y 0x4000000
#define RESIZE_FLAG_RELATIVE_TO_CONTROL_POS_TOP_POS_Y 0x8000000
#define RESIZE_FLAG_RELATIVE_TO_CONTROL_POS_BOTTOM_POS_Y 0x10000000
#define RESIZE_FLAG_SAME_DISTANCE_CONTROL_MIDDLE_POS_Y 0x20000000
#define RESIZE_MASK_POSY_NEED_REF (RESIZE_FLAG_SAME_DISTANCE_CONTROL_POS_TOP_POS_Y|RESIZE_FLAG_SAME_DISTANCE_CONTROL_POS_BOTTOM_POS_Y|RESIZE_FLAG_RELATIVE_TO_CONTROL_POS_TOP_POS_Y|RESIZE_FLAG_RELATIVE_TO_CONTROL_POS_BOTTOM_POS_Y|RESIZE_FLAG_SAME_DISTANCE_CONTROL_MIDDLE_POS_Y)

typedef struct resize_info_t
{	int ctrlId;
	int refWidthControl;
	int refHeightControl;
	int refPosXControl;
	int refPosYControl;
	RECT reference;
	DWORD flags;
} resize_info_t;

void resizeDialogControls(HWND hDlg,resize_info_t *resizeInfo,int mindidth,int minheight);
void resizeChildDialog(HWND hParent,HWND hChild,resize_info_t *resizeInfo);
void scrollChildren(HWND hDlg,int amountx,int amounty);
void scrollBack(HWND hDlg);
int translateScroll(HWND hDlg,DWORD scrCode,int scrType);
#endif
