#ifndef __LANGUAGE_H
#define __LANGUAGE_H 1

#define LANGUAGE_FLAG_ENUMERATING_LANGUAGES 1
#define LANGUAGE_FLAG_UPDATING_COMBOBOXES 2

#include <windows.h>
#include <commdlg.h>
#include <commctrl.h>

typedef struct lang_str_info
{	int index;
	char *langStr;
} lang_str_info;

char *get_lang_str(int x);
int LangSetDlgItemText(HWND hDlg,int item,int langId);
int SetDlgItemTextL(HWND hDlg,int item,LPCTSTR lpString);
int SetWindowTextL(HWND hDlg,int langId);
int LangSetWindowText(HWND hDlg,LPCTSTR lpString);
int LangSetWindowText2(HWND hDlg,LPCTSTR lpString);
void LangInsertColumn(HWND hDlg,int item,int width,int langId,int subItem,int format);
void LangSetColumn(HWND hDlg,int item,int width,int langId,int subItem);
void LangSetLVItem(HWND hDlg,int listcontrol,int item,int subitem,char *langstr);
void LangAppendMenu(HMENU hMenu,UINT uFlags,UINT item,int langId);
void LangAppendMenuStr(HMENU hMenu,UINT uFlags,UINT item,LPCTSTR lpLangStr);
void LangInsertMenuStr(HMENU hMenu,UINT uPosition,UINT uFlags,UINT item,LPCTSTR lpLangStr);
int LangCbAddString(HWND hDlg,UINT combo,int langId);
int LangLbAddString(HWND hDlg,UINT listbox,int langId);
int LangMessageBox(HWND hDlg,char *message,int titleId,UINT uType);
int LangGetLanguage(void);
int LangGetLanguageType(void);
int LangGetSelText(HWND hDlg,char *replText);
void LangGetDlgItemText(HWND hDlg,int item,char *utfStr,int nChars);
void LangReplaceSel(char *replacement,HWND hDlg);
void LangClearText(HWND hDlg);
void LangDebugScroll(HWND hDlg);
void LangInitCriticalSection(void);
void LangDeleteCriticalSection(void);
void LangEnterCriticalSection(void);
void LangLeaveCriticalSection(void);
void enumLanguages(HWND hCombo,char *selected);
void verify_lng(char *file);
int load_lng(char *file);
void unload_languages(void);
char *get_utf(LPWSTR str);
char *get_utf_n(LPWSTR str,int strsize);
LPWSTR get_unicode(char *str);
struct lang_str_info *plugin_load_lng(char *dllname,int *maxdefs,char *language,char **lngfile);

#define LANG_STR_ABOUT_LNG 0
#define LANG_RESERVED_1 1
#define LANG_COLUMN_HS_1 2
#define LANG_COLUMN_HS_2 3
#define LANG_COLUMN_HS_3 4
#define LANG_COLUMN_HS_4 5
#define LANG_COLUMN_EXIT_1 6
#define LANG_COLUMN_EXIT_2 7
#define LANG_COLUMN_EXIT_3 8
#define LANG_COLUMN_EXIT_4 9
#define LANG_MENU_INTERCEPT 10
#define LANG_MENU_CLEAR_LIST 11
#define LANG_MENU_COPY 12
#define LANG_MENU_SHOW_WINDOW 13
#define LANG_MENU_FORCE_TOR 14
#define LANG_MENU_QUICK_START 15
#define LANG_MENU_RELEASE 16
#define LANG_MENU_NEW_IDENTITY 17
#define LANG_MENU_SELECT_IP 18
#define LANG_MENU_START_TOR 19
#define LANG_MENU_SAVE_SETTINGS 20
#define LANG_MENU_EXIT 21
#define LANG_CB_DEBUG 22
#define LANG_CB_INFO 23
#define LANG_CB_PROXY 24
#define LANG_CB_NOTICE 25
#define LANG_CB_WARNING 26
#define LANG_CB_ERROR 27
#define LANG_CB_RANDOM_COUNTRY 28
#define LANG_CB_NO_EXIT 29
#define LANG_MB_ERROR 30
#define LANG_MB_WRITE_ERROR 31
#define LANG_MB_ERROR_SEED 32
#define LANG_MB_SAVE_SETTINGS 33
#define LANG_MB_OPTIONS_SAVED 34
#define LANG_MB_NEW_IDENTITY 35
#define LANG_MB_IDENTITY_DIFFERENT_IP 36
#define LANG_MB_IDENTITY_NO_EXIT 37
#define LANG_MB_RELEASE 38
#define LANG_MB_PID_RELEASED 39
#define LANG_MB_RELEASE_ERROR 40
#define LANG_MB_FAVORITES 41
#define LANG_MB_FAV_ADDED 42
#define LANG_MB_BANS 43
#define LANG_MB_BAN_ADDED 44
#define LANG_MB_CMDLINE_HELP 45
#define LANG_MB_HELP 46
#define LANG_LB_PROXY 47
#define LANG_LB_AUTHORITIES 48
#define LANG_LB_ROUTER_RESTRICTIONS 49
#define LANG_LB_BANNED_ADDRESSES 50
#define LANG_LB_CONNECTIONS 51
#define LANG_LB_HIDDEN_SERVICES 52
#define LANG_LB_SYSTEM 53
#define LANG_LB_HOSTED_SERVICES 54
#define LANG_LB_SERVER 55
#define LANG_LB_DEBUG 56
#define LANG_LB_ABOUT 57
#define LANG_LB_BRIDGES 58
#define LANG_LB_NETSTAT 59
#define LANG_LB_PLUGINS 60
#define LANG_LB_HTTP_HEADERS 61
#define LANG_DLG_START_TOR 62
#define LANG_DLG_NEW_IDENTITY 63
#define LANG_DLG_SAVE_SETTINGS 64
#define LANG_DLG_ALWAYS_ON_TOP 65
#define LANG_DLG_MINIMIZE_TO_TRAY 66
#define LANG_DLG_EXIT 67
#define LANG_DLG_SAVE_TO_LOG 68
#define LANG_DLG_AUTO_REFRESH 69
#define LANG_DLG_CLEAR_WINDOW 70
#define LANG_DLG_BANDWIDTH_RATE 71
#define LANG_DLG_BANDWIDTH_BURST 72
#define LANG_DLG_ADVERTISED_BANDWIDTH 73
#define LANG_DLG_RELAY_BW_RATE 74
#define LANG_DLG_RELAY_BW_BURST 75
#define LANG_DLG_ISP_LIMIT 76
#define LANG_DLG_ISP_LIMIT_AVAIL 77
#define LANG_DLG_MAX_CONNECTIONS 78
#define LANG_DLG_BUFFER_SIZE 79
#define LANG_DLG_KEEPALIVE 80
#define LANG_DLG_CONN_IP 81
#define LANG_DLG_FIREWALL_RESTRICTIONS 82
#define LANG_DLG_ADVERTISED_OS 83
#define LANG_DLG_ADVERTISED_TORVER 84
#define LANG_DLG_START_AUTOMATICALLY 85
#define LANG_DLG_MINIMIZE_AT_STARTUP 86
#define LANG_DLG_START_WITH_WINDOWS 87
#define LANG_DLG_USE_HW_ACCEL 88
#define LANG_DLG_FLASH_MEM 89
#define LANG_DLG_CONTROL_PORT 90
#define LANG_DLG_CONTROL_ADDRESS 91
#define LANG_DLG_CONTROL_PASSWORD 92
#define LANG_DLG_DEBUG_FILTER 93
#define LANG_DLG_FAKE_LOCAL_TIME 94
#define LANG_DLG_RESOLVE_TO_FAKE_IPS 95
#define LANG_DLG_DISALLOW_NON_TCP 96
#define LANG_DLG_CHANGE_PROCESS_ICON 97
#define LANG_DLG_FAKE_LOCAL_ADDRESS 98
#define LANG_DLG_RUN_INTERCEPTED 99
#define LANG_DLG_FORCE_TOR_RESERVED1 100
#define LANG_DLG_FORCE_TOR_RESERVED2 101
#define LANG_DLG_FORCE_TOR_RESERVED3 102
#define LANG_DLG_FORCE_TOR_RESERVED4 103
#define LANG_DLG_FORCE_TOR_RESERVED5 104
#define LANG_DLG_FORCE_TOR_RESERVED6 105
#define LANG_DLG_FORCE_TOR_RESERVED7 106
#define LANG_DLG_FORCE_TOR_RESERVED8 107
#define LANG_DLG_FORCE_TOR_RESERVED9 108
#define LANG_DLG_LOCAL_PROXY_PORT 109
#define LANG_DLG_LOCAL_PROXY_ADDR 110
#define LANG_DLG_IP_RESTRICTIONS 111
#define LANG_DLG_HANDSHAKE_TIMEOUT 112
#define LANG_DLG_DISALLOW_DNS_RESOLVE 113
#define LANG_DLG_ALLOW_NON_RFC953 114
#define LANG_DLG_DISALLOWED_CONNECTIONS 115
#define LANG_DLG_BANNED_PORTS 116
#define LANG_DLG_BANNED_HOSTS 117
#define LANG_DLG_CIRCUIT_BUILD_TIMEOUT 118
#define LANG_DLG_CIRCUIT_IDLE_TIMEOUT 119
#define LANG_DLG_LONG_RUNNING_CONNECTIONS 120
#define LANG_DLG_CIRCUIT_BUILD_PERIOD 121
#define LANG_DLG_CIRCUIT_EXPIRATION 122
#define LANG_DLG_CIRCUIT_TIMEOUT_EXIT 123
#define LANG_DLG_USE_BRIDGES 124
#define LANG_DLG_UPDATE_BRIDGES 125
#define LANG_DLG_ENTRY_GUARDS_USE 126
#define LANG_DLG_ENTRY_GUARDS_REINIT 127
#define LANG_DLG_FORCED_EXIT_HOSTS 128
#define LANG_DLG_NODE_FAMILIES 129
#define LANG_DLG_TRACKED_HOSTS 130
#define LANG_DLG_TRACKED_HOSTS_EXPIRE 131
#define LANG_DLG_ALLOWED_INVALID 132
#define LANG_DLG_ALLOWED_INVALID_ENTRY 133
#define LANG_DLG_ALLOWED_INVALID_EXIT 134
#define LANG_DLG_ALLOWED_INVALID_MIDDLE 135
#define LANG_DLG_ALLOWED_INVALID_RENDEZVOUS 136
#define LANG_DLG_ALLOWED_INVALID_INTRODUCTION 137
#define LANG_DLG_AVOID_SAME_SUBNETS 138
#define LANG_DLG_FAST_CIRCUITS 139
#define LANG_DLG_DOWNLOAD_EXTRA_INFO 140
#define LANG_DLG_USE_ONLY_ENTRIES_FROM_FAVORITES 141
#define LANG_DLG_USE_ONLY_EXITS_FROM_FAVORITES 142
#define LANG_DLG_BANNED_NODES 143
#define LANG_DLG_FAVORITE_NODES 144
#define LANG_DLG_TEST_NODES 145
#define LANG_DLG_SERVER_PORT 146
#define LANG_DLG_SERVER_ADDR 147
#define LANG_DLG_SERVER_NICK 148
#define LANG_DLG_SERVER_MAIL 149
#define LANG_DLG_SERVER_ADV_ADDR 150
#define LANG_DLG_SERVER_SELF_TEST 151
#define LANG_DLG_SERVER_ACT_AS_BRIDGE 152
#define LANG_DLG_SERVER_GEOIP_STATS 153
#define LANG_DLG_SERVER_MAX_ONIONSKINS 154
#define LANG_DLG_SERVER_CPUS 155
#define LANG_DLG_SERVER_MSG_EXIT 156
#define LANG_DLG_SERVER_ACCEPT_POLICY 157
#define LANG_DLG_SERVER_REJECT_POLICY 158
#define LANG_DLG_SERVER_PUBLISH 159
#define LANG_DLG_SERVER_PUBLISH_NOW 160
#define LANG_DLG_DIR_LIST 161
#define LANG_DLG_DIR_STATUS 162
#define LANG_DLG_DIR_RANDOM 163
#define LANG_DLG_DIR_PRIVATE 164
#define LANG_DLG_DIR_CONSENSUS_EXP 165
#define LANG_DLG_DIR_REFRESH_NOW 166
#define LANG_DLG_DIR_RESOLUTION_TIMEOUT 167
#define LANG_DLG_DIR_WAIT_DESCRIPTORS 168
#define LANG_DLG_DIR_FAKE_TIME 169
#define LANG_DLG_DIR_RANDOMIZE_DELTA 170
#define LANG_DLG_DIR_RANDOMIZE_DELTA_UNITS 171
#define LANG_DLG_DIR_ROUTER_TIME 172
#define LANG_DLG_DIR_MAX_DL_FAILURES 173
#define LANG_DLG_DIR_REMOVE_CONSENSUS 174
#define LANG_DLG_DIR_REMOVE_CONSENSUS_UNITS 175
#define LANG_DLG_HS_REAL_PORT 176
#define LANG_DLG_HS_REAL_ADDR 177
#define LANG_DLG_HS_SELECT_PORT 178
#define LANG_DLG_HS_VIRTUAL_PORT 179
#define LANG_DLG_HS_ONION_ADDR 180
#define LANG_DLG_HS_ADD 181
#define LANG_DLG_HS_DELETE 182
#define LANG_DLG_HS_PUBLISH_NOW 183
#define LANG_DLG_HS_INTRO 184
#define LANG_DLG_HS_BUILD_PERIOD 185
#define LANG_DLG_HS_MAX_INTRO 186
#define LANG_DLG_HS_MAX_REND_FAIL 187
#define LANG_DLG_HS_REND_TIMEOUT 188
#define LANG_DLG_HS_PUBLISH_PERIOD 189
#define LANG_DLG_HS_VERSION_0 190
#define LANG_DLG_HS_VERSION_2 191
#define LANG_DLG_HS_VERSION_ALL 192
#define LANG_DLG_SAVE_TO_OTHER_LOG 193
#define LANG_DLG_CIRCUIT_LENGTH_ROUTERS 194
#define LANG_DLG_LANGUAGE 195
#define LANG_DLG_RESERVED_01 196
#define LANG_DLG_RESERVED_02 197
#define LANG_DLG_RESERVED_03 198
#define LANG_DLG_RESERVED_04 199
#define LANG_DLG_RESERVED_05 200
#define LANG_DLG_RESERVED_06 201
#define LANG_DLG_RESERVED_07 202
#define LANG_DLG_RESERVED_08 203
#define LANG_DLG_RESERVED_09 204
#define LANG_DLG_RESERVED_10 205
#define LANG_DLG_RESERVED_11 206
#define LANG_DLG_RESERVED_12 207
#define LANG_DLG_RESERVED_13 208
#define LANG_DLG_RESERVED_14 209
#define LANG_DLG_RESERVED_15 210
#define LANG_DLG_RESERVED_16 211
#define LANG_DLG_RESERVED_17 212
#define LANG_DLG_RESERVED_18 213
#define LANG_DLG_RESERVED_19 214
#define LANG_EXIT_DLG_TITLE 215
#define LANG_EXIT_DLG_COUNTRY 216
#define LANG_EXIT_DLG_SELECT 217
#define LANG_EXIT_DLG_ADD_FAV 218
#define LANG_EXIT_DLG_SET_BAN 219
#define LANG_EXIT_DLG_CANCEL 220
#define LANG_PF_DLG_TITLE 221
#define LANG_PF_DLG_HELP 222
#define LANG_PF_DLG_FORCE 223
#define LANG_PF_DLG_CANCEL 224
#define LANG_OFN_DLG_CMDLINE 225
#define LANG_OFN_DLG_REMEMBER 226
#define LANG_OFN_DLG_PROGNAME 227
#define LANG_OFN_RESERVED_1 228
#define LANG_OFN_RESERVED_2 229

#define LANG_LOG_BUFFERS_CLEAN_FREELIST 230
#define LANG_LOG_BUFFERS_FREELISTS 231
#define LANG_LOG_BUFFERS_CHUNKS 232
#define LANG_LOG_BUFFERS_ALLOCATIONS 233
#define LANG_LOG_BUFFERS_WSAENOBUFS 234
#define LANG_LOG_BUFFERS_EOF 235
#define LANG_LOG_BUFFERS_READ_INBUF 236
#define LANG_LOG_BUFFERS_WSAENOBUFS_SEND 237
#define LANG_LOG_BUFFERS_WSAEWOULDBLOCK 238
#define LANG_LOG_BUFFERS_FLUSH 239
#define LANG_LOG_BUFFERS_HTTP_HEADERS_TOO_LONG 240
#define LANG_LOG_BUFFERS_HTTP_HEADERS_INCOMPLETE 241
#define LANG_LOG_BUFFERS_HTTP_HEADERLEN 242
#define LANG_LOG_BUFFERS_HTTP_HEADERS_LARGER 243
#define LANG_LOG_BUFFERS_HTTP_BODYLEN_LARGER 244
#define LANG_LOG_BUFFERS_HTTP_CONTENTLENGTH_INVALID 245
#define LANG_LOG_BUFFERS_HTTP_GOT_CONNECTION 246
#define LANG_LOG_BUFFERS_HTTP_BODY_INCOMPLETE 247
#define LANG_LOG_BUFFERS_HTTP_BODYLEN_REDUCED 248
#define LANG_LOG_BUFFERS_SOCKS_NO_METHODS 249
#define LANG_LOG_BUFFERS_SOCKS_METHOD_E0 250
#define LANG_LOG_BUFFERS_SOCKS_METHOD_00 251
#define LANG_LOG_BUFFERS_SOCKS_CHECKING_REQUEST 252
#define LANG_LOG_BUFFERS_SOCKS_UNKNOWN_COMMAND 253
#define LANG_LOG_BUFFERS_SOCKS_IPV4 254
#define LANG_LOG_BUFFERS_SOCKS_IP_BUFFER_ERROR 255
#define LANG_LOG_BUFFERS_SOCKS_IP_WARN 256
#define LANG_LOG_BUFFERS_SOCKS_FQDN 257
#define LANG_LOG_BUFFERS_SOCKS_RESOLVE_PTR_HOSTNAME 258
#define LANG_LOG_BUFFERS_SOCKS_HOSTNAME_TOO_BIG 259
#define LANG_LOG_BUFFERS_SOCKS_MALFORMED_HOSTNAME 260
#define LANG_LOG_BUFFERS_SOCKS_HOSTNAME_OK 261
#define LANG_LOG_BUFFERS_SOCKS_UNSUPPORTED_ADDR 262
#define LANG_LOG_BUFFERS_SOCKS4_INVALID_COMMAND 263
#define LANG_LOG_BUFFERS_SOCKS4_INVALID_ADDR 264
#define LANG_LOG_BUFFERS_SOCKS4_DESTIP 265
#define LANG_LOG_BUFFERS_SOCKS4_ADDR_TOO_LONG 266
#define LANG_LOG_BUFFERS_SOCKS4_DESTIP_SUCCESS 267
#define LANG_LOG_BUFFERS_SOCKS4_UNAME_TOO_LONG 268
#define LANG_LOG_BUFFERS_SOCKS4_UNAME_INCOMPLETE 269
#define LANG_LOG_BUFFERS_SOCKS4_IP_WARN 270
#define LANG_LOG_BUFFERS_SOCKS4_INCOMPLETE_DESTADDR 271
#define LANG_LOG_BUFFERS_SOCKS4_DESTADDR_TOO_LONG 272
#define LANG_LOG_BUFFERS_SOCKS4_DESTADDR_INCOMPLETE 273
#define LANG_LOG_BUFFERS_SOCKS4_DESTADDR_TOO_LONG_2 274
#define LANG_LOG_BUFFERS_SOCKS4_HOSTNAME_OK 275
#define LANG_LOG_BUFFERS_SOCKS4_SUCCESS 276
#define LANG_LOG_BUFFERS_SOCKS4_MALFORMED_HOSTNAME 277
#define LANG_LOG_BUFFERS_INTERCEPTED_BYPASS 278
#define LANG_LOG_BUFFERS_APP_INTERCEPTED_BYPASS 279
#define LANG_LOG_BUFFERS_NOT_A_PROXY_REQUEST 280
#define LANG_LOG_BUFFERS_SOCKS_VERSION_ERROR 281

#define LANG_LOG_CIRCUITBUILD_CHOSEN_CIRCID 282
#define LANG_LOG_CIRCUITBUILD_CIRCUIT_BUILT 283
#define LANG_LOG_CIRCUITBUILD_CIRCUIT_OPEN_SUCCESS 284
#define LANG_LOG_CIRCUITBUILD_CIRCUIT_SEND_NEXT_ONIONSKIN_FAILED 285
#define LANG_LOG_CIRCUITBUILD_CIRCUIT_TYPE 286
#define LANG_LOG_CIRCUITBUILD_CONN_OPEN 287
#define LANG_LOG_CIRCUITBUILD_CONNECT_TO_FIRSTHOP_FAILED 288
#define LANG_LOG_CIRCUITBUILD_CPATH_HOP_FAIL 289
#define LANG_LOG_CIRCUITBUILD_FIRST_HOP_CELL_SENT 290
#define LANG_LOG_CIRCUITBUILD_FIRST_SKIN_CREATE_CELL 291
#define LANG_LOG_CIRCUITBUILD_IN_PROGRESS 292
#define LANG_LOG_CIRCUITBUILD_LOOKING_FOR_FIRSTHOP 293
#define LANG_LOG_CIRCUITBUILD_NEXT_ROUTER_IS 294
#define LANG_LOG_CIRCUITBUILD_NO_UNUSED_CIRC_IDS 295
#define LANG_LOG_CIRCUITBUILD_OR_CONN_FAILED 296
#define LANG_LOG_CIRCUITBUILD_OR_CONN_STATUS 297
#define LANG_LOG_CIRCUITBUILD_SEND_CREATE_CELL 298
#define LANG_LOG_CIRCUITBUILD_SEND_NEXT_ONIONSKIN_FAILED 299
#define LANG_LOG_CIRCUITBUILD_SENDING_SUBSEQUENT_SKIN 300
#define LANG_LOG_CIRCUITBUILD_TEST_REACHABILITY 301
#define LANG_LOG_CIRCUITBUILD_UNIQUE_CIRCID_FAIL 302
#define LANG_LOG_CIRCUITBUILD_ONION_SKIN_CREATE_FAILED 303
#define LANG_LOG_CIRCUITBUILD_EXTEND_TO_NON_IPV4 304
#define LANG_LOG_CIRCUITBUILD_ONION_SKIN_CREATE_FAILED_2 305
#define LANG_LOG_CIRCUITBUILD_SENDING_EXTEND_RELAY_CELL 306
#define LANG_LOG_CIRCUITBUILD_YOUR_SYSTEM_CLOCK 307
#define LANG_LOG_CIRCUITBUILD_N_CONN_ALREADY_SET 308
#define LANG_LOG_CIRCUITBUILD_CONN_ALREADY_LAUNCHED 309
#define LANG_LOG_CIRCUITBUILD_CLIENT_GOT_EXTEND_CELL 310
#define LANG_LOG_CIRCUITBUILD_WRONG_LENGTH_ON_EXTEND_CELL 311
#define LANG_LOG_CIRCUITBUILD_EXTEND_TO_ZERO_ADDR 312
#define LANG_LOG_CIRCUITBUILD_EXTEND_WITHOUT_DIGEST 313
#define LANG_LOG_CIRCUITBUILD_EXTEND_BACK 314
#define LANG_LOG_CIRCUITBUILD_NEXT_ROUTER 315
#define LANG_LOG_CIRCUITBUILD_LAUNCHING_N_CONN_FAILED 316
#define LANG_LOG_CIRCUITBUILD_N_CONN_IS 317
#define LANG_LOG_CIRCUITBUILD_FORWARD_CIPHER_INIT_FAIL 318
#define LANG_LOG_CIRCUITBUILD_BACKWARD_CIPHER_INIT_FAIL 319
#define LANG_LOG_CIRCUITBUILD_EXTEND_AFTER_CIRC_BUILT 320
#define LANG_LOG_CIRCUITBUILD_ONION_SKIN_HANDSHAKE_FAILED 321
#define LANG_LOG_CIRCUITBUILD_FAST_CLIENT_HANDSHAKE_FAILED 322
#define LANG_LOG_CIRCUITBUILD_CREATED_DID_NOT_MATCH_CREATE 323
#define LANG_LOG_CIRCUITBUILD_FINISHED_BUILDING_FIRST_HOP 324
#define LANG_LOG_CIRCUITBUILD_KILLING_A_LAYER_OF_CPATH 325
#define LANG_LOG_CIRCUITBUILD_MARKING_STREAM_FOR_CLOSE 326
#define LANG_LOG_CIRCUITBUILD_FINISHED 327
#define LANG_LOG_CIRCUITBUILD_INIT_DIGEST_FORWARD 328
#define LANG_LOG_CIRCUITBUILD_CIRCUIT_INIT_FAILED 329
#define LANG_LOG_CIRCUITBUILD_FINISHED_SENDING_CREATED_CELL 330
#define LANG_LOG_CIRCUITBUILD_CHOSEN_ROUTE_LENGTH 331
#define LANG_LOG_CIRCUITBUILD_INSUFFICIENT_ACCEPTABLE_ROUTERS 332
#define LANG_LOG_CIRCUITBUILD_INSUFFICIENT_ROUTERS 333
#define LANG_LOG_CIRCUITBUILD_CHOOSING_EXIT_NODE 334
#define LANG_LOG_CIRCUITBUILD_SKIPPING_SELF 335
#define LANG_LOG_CIRCUITBUILD_SKIPPING_INVALID 336
#define LANG_LOG_CIRCUITBUILD_SKIPPING_REJECT_ALL 337
#define LANG_LOG_CIRCUITBUILD_N_SUPPORTED 338
#define LANG_LOG_CIRCUITBUILD_WOULD_REJECT_THIS 339
#define LANG_LOG_CIRCUITBUILD_NEW_BEST 340
#define LANG_LOG_CIRCUITBUILD_FOUND_SERVERS_THAT_MIGHT_SUPPORT 341
#define LANG_LOG_CIRCUITBUILD_NO_LIVE_ROUTERS 342
#define LANG_LOG_CIRCUITBUILD_ALL_ROUTERS_ARE_DOWN 343
#define LANG_LOG_CIRCUITBUILD_TRY_NEW_POSSIBILITY 344
#define LANG_LOG_CIRCUITBUILD_CHOSEN_EXIT_SERVER 345
#define LANG_LOG_CIRCUITBUILD_NO_RUNNING_EXITS 346
#define LANG_LOG_CIRCUITBUILD_UNHANDLED_PURPOSE 347
#define LANG_LOG_CIRCUITBUILD_USING_BANNED_NODE 348
#define LANG_LOG_CIRCUITBUILD_LAUNCHING_ONE_HOP_DIR_TUNNEL 349
#define LANG_LOG_CIRCUITBUILD_USING_REQUESTED_EXIT 350
#define LANG_LOG_CIRCUITBUILD_FAILED_TO_CHOOSE_AN_EXIT 351
#define LANG_LOG_CIRCUITBUILD_COULDNT_EXTEND_CIRCUIT 352
#define LANG_LOG_CIRCUITBUILD_CONTEMPLATING 353
#define LANG_LOG_CIRCUITBUILD_NOPE_DIR_SAYS_NOT_RUNNING 354
#define LANG_LOG_CIRCUITBUILD_NOPE_DIR_SAYS_INVALID 355
#define LANG_LOG_CIRCUITBUILD_I_LIKE_NOW 356
#define LANG_LOG_CIRCUITBUILD_CONTEMPLATING_INTERMEDIATE_HOP 357
#define LANG_LOG_CIRCUITBUILD_PATH_IS_COMPLETE 358
#define LANG_LOG_CIRCUITBUILD_PATH_LENGTH 359
#define LANG_LOG_CIRCUITBUILD_FAILED_TO_FIND_NODE_FOR_HOP 360
#define LANG_LOG_CIRCUITBUILD_CHOSE_ROUTER_FOR_HOP 361
#define LANG_LOG_CIRCUITBUILD_ENTRY_GUARD_UNUSABLE 362
#define LANG_LOG_CIRCUITBUILD_ENTRY_GUARD_NOW_USABLE 363
#define LANG_LOG_CIRCUITBUILD_ENTRY_GUARD_NEW 364
#define LANG_LOG_CIRCUITBUILD_ENTRY_GUARD_REPLACE 365
#define LANG_LOG_CIRCUITBUILD_ENTRY_GUARD_REMOVE_OFFLINE 366
#define LANG_LOG_CIRCUITBUILD_ENTRY_GUARD_SUMMARY 367
#define LANG_LOG_CIRCUITBUILD_ENTRY_GUARD_STATS 368
#define LANG_LOG_CIRCUITBUILD_ENTRY_GUARD_REACHABLE_AGAIN 369
#define LANG_LOG_CIRCUITBUILD_ENTRY_GUARD_BAD_NEW 370
#define LANG_LOG_CIRCUITBUILD_ENTRY_GUARD_CONNECT_FAILED 371
#define LANG_LOG_CIRCUITBUILD_ENTRY_GUARD_NOT_REACHABLE_YET 372
#define LANG_LOG_CIRCUITBUILD_ENTRY_GUARD_CONNECTED_NEW 373
#define LANG_LOG_CIRCUITBUILD_USING_ENTRYNODES 374
#define LANG_LOG_CIRCUITBUILD_ADDING_ENTRYNODES 375
#define LANG_LOG_CIRCUITBUILD_ENTRYGUARDADDEDBY_TOO_SHORT 376
#define LANG_LOG_CIRCUITBUILD_ENTRYGUARDADDEDBY_NOT_HEX_DIGEST 377
#define LANG_LOG_CIRCUITBUILD_ENTRY_GUARD_UNEXPECTED_KEY 378
#define LANG_LOG_CIRCUITBUILD_ENTRYGUARDADDEDBY_TIMESTAMP_ERROR 379
#define LANG_LOG_CIRCUITBUILD_BRIDGE_ASK_DIRECTLY 380
#define LANG_LOG_CIRCUITBUILD_BRIDGE_UNREACHABLE 381
#define LANG_LOG_CIRCUITBUILD_BRIDGE_ASKING_AUTHORITY 382
#define LANG_LOG_CIRCUITBUILD_BRIDGE_SKIPPING 383
#define LANG_LOG_CIRCUITBUILD_BRIDGE_FETCHING_INFO 384
#define LANG_LOG_CIRCUITBUILD_BRIDGE_NEW_DESCRIPTOR 385
#define LANG_LOG_CIRCUITBUILD_BRIDGE_FOUND 386
#define LANG_LOG_CIRCUITBUILD_BRIDGE_STATS 387

#define LANG_LOG_CIRCUITLIST_OR_CONN_PENDING 388
#define LANG_LOG_CIRCUITLIST_UNKNOWN_CIRCUIT_STATE 389
#define LANG_LOG_CIRCUITLIST_DUMP_DETAILS 390
#define LANG_LOG_CIRCUITLIST_CIRCUIT_NOT_IN_HASH_TABLE 391
#define LANG_LOG_CIRCUITLIST_CIRCUIT_NOT_IN_HASH_TABLE_N 392
#define LANG_LOG_CIRCUITLIST_FIND_OPEN_CIRCUIT 393
#define LANG_LOG_CIRCUITLIST_DUPLICATE_CLOSE 394
#define LANG_LOG_CIRCUITLIST_INVALID_REASON 395
#define LANG_LOG_CIRCUITLIST_REASON_OUT_OF_RANGE 396
#define LANG_LOG_CIRCUITLIST_FAILED_INTRO_CIRC 397
#define LANG_LOG_CIRCUITLIST_UNEXPECTED_STATE 398

#define LANG_LOG_CIRCUITUSE_UNKNOWN_ROUTER 399
#define LANG_LOG_CIRCUITUSE_SKIPPING_ONE_HOP_CIRCUIT 400
#define LANG_LOG_CIRCUITUSE_INTRO_TOO_OLD 401
#define LANG_LOG_CIRCUITUSE_INTRO_TIMEOUT 402
#define LANG_LOG_CIRCUITUSE_CONSIDERING_CIRCUIT 403
#define LANG_LOG_CIRCUITUSE_CONSIDERING_DIRTY_CIRCUIT 404
#define LANG_LOG_CIRCUITUSE_ABANDONING_CIRC 405
#define LANG_LOG_CIRCUITUSE_ABANDONING_CIRC_2 406
#define LANG_LOG_CIRCUITUSE_PORT_ALREADY_HANDLED 407
#define LANG_LOG_CIRCUITUSE_PORT_NOT_HANDLED 408
#define LANG_LOG_CIRCUITUSE_NEED_ANOTHER_EXIT 409
#define LANG_LOG_CIRCUITUSE_HS_NEED_ANOTHER_INTERNAL_CIRC 410
#define LANG_LOG_CIRCUITUSE_HS_NEED_ANOTHER_HIDSERV_CIRC 411
#define LANG_LOG_CIRCUITUSE_CREATING_NEW_TESTING_CIRCUIT 412
#define LANG_LOG_CIRCUITUSE_EDGE_NOT_FOUND 413
#define LANG_LOG_CIRCUITUSE_CLOSING_N_CIRC_ID 414
#define LANG_LOG_CIRCUITUSE_CLOSING_UNUSED_CIRCUIT 415
#define LANG_LOG_CIRCUITUSE_TEST_CIRCUIT_FAILED 416
#define LANG_LOG_CIRCUITUSE_FIRST_HOP_TIMEOUT 417
#define LANG_LOG_CIRCUITUSE_CONNECTION_FAILED_USING_REND 418
#define LANG_LOG_CIRCUITUSE_CANCELING_CIRCUIT_LAUNCH 419
#define LANG_LOG_CIRCUITUSE_CANNIBALIZE_CIRCUIT 420
#define LANG_LOG_CIRCUITUSE_UNEXPECTED_PURPOSE 421
#define LANG_LOG_CIRCUITUSE_FAILURES_SO_FAR 422
#define LANG_LOG_CIRCUITUSE_N_CIRCUIT_FAILURES_NOW 423
#define LANG_LOG_CIRCUITUSE_APPLICATION_REQUEST_ON_IDLE 424
#define LANG_LOG_CIRCUITUSE_APPLICATION_REQUEST_ON_IDLE_GET_DIR 425
#define LANG_LOG_CIRCUITUSE_NO_SERVER_ALLOWS_EXIT 426
#define LANG_LOG_CIRCUITUSE_REQUESTED_EXIT_WOULD_REFUSE 427
#define LANG_LOG_CIRCUITUSE__TRYING_OTHERS 428
#define LANG_LOG_CIRCUITUSE__CLOSING 429
#define LANG_LOG_CIRCUITUSE_ONE_ON_THE_WAY 430
#define LANG_LOG_CIRCUITUSE_REFETCHING_SERVICE_DESCRIPTOR 431
#define LANG_LOG_CIRCUITUSE_CHOSE_INTRO_POINT 432
#define LANG_LOG_CIRCUITUSE_CONSIDERING_EXIT 433
#define LANG_LOG_CIRCUITUSE_BROKEN_EXIT_DIGEST 434
#define LANG_LOG_CIRCUITUSE_BROKEN_ADDRESS 435
#define LANG_LOG_CIRCUITUSE_REQUESTED_EXIT_IS_NOT_KNOWN 436
#define LANG_LOG_CIRCUITUSE_NO_SAFE_CIRCUIT 437
#define LANG_LOG_CIRCUITUSE_ATTACHING_NEW_CONN 438
#define LANG_LOG_CIRCUITUSE_REGISTERING_NEW_TRACKED_EXIT 439
#define LANG_LOG_CIRCUITUSE_CONNECTION_TIMEOUT_GIVING_UP 440
#define LANG_LOG_CIRCUITUSE_ATTACHING_APCONN_TO_CIRC 441
#define LANG_LOG_CIRCUITUSE_REND_JOINED_CIRC 442
#define LANG_LOG_CIRCUITUSE_PENDING_JOIN_ALREADY_HERE 443
#define LANG_LOG_CIRCUITUSE_INTRO_CIRC_PRESENT_AWAITING_ACK 444
#define LANG_LOG_CIRCUITUSE_CLOSING_INTRO_CIRCUIT_BUILT_IN_PARALLEL 445
#define LANG_LOG_CIRCUITUSE_READY_REND_CIRC_ALREADY_HERE 446
#define LANG_LOG_CIRCUITUSE_FOUND_OPEN_INTRO_CIRC 447
#define LANG_LOG_CIRCUITUSE_INTRO_AND_REND_NOT_BOTH_READY 448

#define LANG_LOG_COMMAND_CALL_DURATION 449
#define LANG_LOG_COMMAND_TIME_MACHINE 450
#define LANG_LOG_COMMAND_STATS_SECOND 451
#define LANG_LOG_COMMAND_UNKNOWN_CELL_TYPE 452
#define LANG_LOG_COMMAND_STATS_SECOND_VERSIONS 453
#define LANG_LOG_COMMAND_UNKNOWN_CELL_TYPE_VAR_LENGTH 454
#define LANG_LOG_COMMAND_RECEIVED_CREATE_ON_SHUTDOWN 455
#define LANG_LOG_COMMAND_CLIENT_RECEIVED_CREATE_CELL 456
#define LANG_LOG_COMMAND_RECEIVED_CREATE_WITH_UNEXPECTED_CIRC_ID 457
#define LANG_LOG_COMMAND_RECEIVED_CREATE_FOR_KNOWN_CIRC 458
#define LANG_LOG_COMMAND_ROUTER_DETAILS 459
#define LANG_LOG_COMMAND_FAILED_TO_HAND_OFF_ONIONSKIN 460
#define LANG_LOG_COMMAND_SUCCESS_HANDED_OFF_ONIONSKIN 461
#define LANG_LOG_COMMAND_FAILED_TO_GENERATE_KEY_MATERIAL 462
#define LANG_LOG_COMMAND_FAILED_TO_REPLY_TO_CREATE_FAST 463
#define LANG_LOG_COMMAND_UNKNOWN_CIRCID 464
#define LANG_LOG_COMMAND_GOT_CREATED_FROM_CLIENT 465
#define LANG_LOG_COMMAND_AT_OP_FINISHING_HANDSHAKE 466
#define LANG_LOG_COMMAND_CIRCUIT_HANDSHAKE_FAILED 467
#define LANG_LOG_COMMAND_MOVING_TO_NEXT_SKIN 468
#define LANG_LOG_COMMAND_CIRCUIT_SEND_NEXT_ONIONSKIN_FAILED 469
#define LANG_LOG_COMMAND_CONVERTING_CREATED_TO_EXTENDED 470
#define LANG_LOG_COMMAND_UNKNOWN_CIRC_ON_CONN 471
#define LANG_LOG_COMMAND_CIRCUIT_IN_CREATE_WAIT 472
#define LANG_LOG_COMMAND_RECEIVED_INBOUND_RELAY_EARLY 473
#define LANG_LOG_COMMAND_RECEIVED_TOO_MANY_RELAY_EARLY 474
#define LANG_LOG_COMMAND_CIRCUIT_RECEIVE_RELAY_CELL_FAILED 475
#define LANG_LOG_COMMAND_RECEIVED_FOR_CIRCID 476
#define LANG_LOG_COMMAND_DELIVERING_TRUNCATED_BACK 477
#define LANG_LOG_COMMAND_RECEIVED_VERSIONS_TWICE 478
#define LANG_LOG_COMMAND_NO_COMMON_VERSION 479
#define LANG_LOG_COMMAND_VERSIONS_FOR_V1 480
#define LANG_LOG_COMMAND_NEGOTIATED_VERSION 481
#define LANG_LOG_COMMAND_RECEIVED_NETINFO 482
#define LANG_LOG_COMMAND_RECEIVED_NETINFO_ON_NON_HANDSHAKING 483
#define LANG_LOG_COMMAND_NETINFO_ADDRESSES_TOO_LONG 484
#define LANG_LOG_COMMAND_NETINFO_BAD_ADDRESS 485
#define LANG_LOG_COMMAND_NETINFO_SKEWED_TIME 486
#define LANG_LOG_COMMAND__AHEAD 487
#define LANG_LOG_COMMAND__BEHIND 488
#define LANG_LOG_COMMAND_NETINFO_CELL_GOOD 489

#define LANG_LOG_CONFIG_ACTING_ON_CONFIG_FAILED 490
#define LANG_LOG_CONFIG_CANNOT_SET_DIRSERVERS_AND_ALTERNATE_AUTHORITY 491
#define LANG_LOG_CONFIG_WARNING_AUTHORITY 492
#define LANG_LOG_CONFIG_CLOSING_OLD_CONNECTIONS 493
#define LANG_LOG_CONFIG_CLOSING_LISTENER 494
#define LANG_LOG_CONFIG_ERROR_ADDING_BRIDGE 495
#define LANG_LOG_CONFIG_ERROR_ADDING_HIDDEN_SERVICE 496
#define LANG_LOG_CONFIG_ERROR_ADDING_HS_AUTH 497
#define LANG_LOG_CONFIG_ERROR_PARSING_POLICY 498
#define LANG_LOG_CONFIG_ALLOWINVALID_NODES_UNRECOGNIZED_VALUE 499
#define LANG_LOG_CONFIG_ERROR_CREATING_COOKIE_FILE 500
#define LANG_LOG_CONFIG_ERROR_LOADING_RENDEZVOUS_KEYS 501
#define LANG_LOG_CONFIG_ERROR_IN_ACCOUNTING_OPTIONS 502
#define LANG_LOG_CONFIG_SWITCHING_TO_ENTRY_GUARDS 503
#define LANG_LOG_CONFIG_BRIDGE_STATUS_CHANGED 504
#define LANG_LOG_CONFIG_ROTATING_WORKERS 505
#define LANG_LOG_CONFIG_ERROR_INITIALIZING_KEYS 506
#define LANG_LOG_CONFIG_DEFAULT_NICKNAME_ERROR 507
#define LANG_LOG_CONFIG_DEFAULT_NICKNAME_CHOSEN 508
#define LANG_LOG_CONFIG_DIRPORTFRONTPAGE_FILE_NOT_FOUND 509
#define LANG_LOG_CONFIG_OPTION_DEPRECATED 510
#define LANG_LOG_CONFIG_SYNTAX_ERROR_SELECT_EXIT 511
#define LANG_LOG_CONFIG_COMMANDLINE_PARSED_KEYWORD 512
#define LANG_LOG_CONFIG_ABBREVIATION_DEPRECATED 513
#define LANG_LOG_CONFIG_OBSOLETE_OPTION 514
#define LANG_LOG_CONFIG_UNRECOGNIZED_OPTION 515
#define LANG_LOG_CONFIG_OPTION_WITH_NO_VALUE 516
#define LANG_LOG_CONFIG_UNKNOWN_OPTION 517
#define LANG_LOG_CONFIG_OBSOLETE_OPTION_VALUE 518
#define LANG_LOG_CONFIG_CANT_RETURN_LINELIST 519
#define LANG_LOG_CONFIG_OPTION_TYPE_UNKNOWN 520
#define LANG_LOG_CONFIG_DEFAULT_FAILED 521
#define LANG_LOG_CONFIG_HOSTNAME_ERROR 522
#define LANG_LOG_CONFIG_HOSTNAME_OK 523
#define LANG_LOG_CONFIG_LOCAL_ADDR_RESOLVE_FAILED 524
#define LANG_LOG_CONFIG_GUESSED_ADDR_RESOLVE_FAILED 525
#define LANG_LOG_CONFIG_COULD_NOT_GET_LOCAL_IP 526
#define LANG_LOG_CONFIG_GOT_LOCAL_IP 527
#define LANG_LOG_CONFIG_LOCAL_IP_PRIVATE_ADDR 528
#define LANG_LOG_CONFIG_COULD_NOT_GET_LOCAL_IP_2 529
#define LANG_LOG_CONFIG_INTERFACE_IP_PRIVATE 530
#define LANG_LOG_CONFIG_ADDR_RESOLVES_TO_PRIVATE_IP 531
#define LANG_LOG_CONFIG_ADDR_RESOLVES_TO_PRIVATE_IP_2 532
#define LANG_LOG_CONFIG_RESOLVED_ADDRESS_TO 533
#define LANG_LOG_CONFIG_YOUR_IP_CHANGED 534
#define LANG_LOG_CONFIG_CONFIG_GET_ASSIGNED_OPTION_ERROR 535
#define LANG_LOG_CONFIG_DEFAULT_CONFIG_VALIDATION_FAILED 536
#define LANG_LOG_CONFIG_INTERNAL_ERROR_WRITING_OPTION_VALUE 537
#define LANG_LOG_CONFIG_INTERNAL_ERROR_WRITING_OPTION_VALUE_2 538
#define LANG_LOG_CONFIG_YOU_SPECIFIED_A_PUBLIC_ADDRESS 539
#define LANG_LOG_CONFIG_NOPUBLISH_IS_OBSOLETE 540
#define LANG_LOG_CONFIG_FAILED_TO_RESOLVE_LOCAL_ADDRESS 541
#define LANG_LOG_CONFIG_NO_PORTS_DEFINED 542
#define LANG_LOG_CONFIG_DIR_SERVERS_CANT_SET_USEENTRYGUARDS 543
#define LANG_LOG_CONFIG_SETTING_DOWNLOADEXTRAINFO 544
#define LANG_LOG_CONFIG_CONVERTING_FIREWALL_OPTIONS 545
#define LANG_LOG_CONFIG_MINUPTIME_MUST_BE_AT_LEAST_0 546
#define LANG_LOG_CONFIG_RENDPOSTPERIOD_TOO_SHORT 547
#define LANG_LOG_CONFIG_RENDPOSTPERIOD_TOO_LARGE 548
#define LANG_LOG_CONFIG_CIRCUITBUILDTIMEOUT_TOO_SHORT 549
#define LANG_LOG_CONFIG_MAXCIRCUITDIRTINESS_TOO_SHORT 550
#define LANG_LOG_CONFIG_ACCOUNTING_PARSE_FAILED 551
#define LANG_LOG_CONFIG_CONTROL_NO_AUTH 552
#define LANG_LOG_CONFIG_CONTROL_NOT_LOCAL 553
#define LANG_LOG_CONFIG_CONTROLPORT_NO_AUTH 554
#define LANG_LOG_CONFIG_TESTINGTORNETWORK_IS_SET 555
#define LANG_LOG_CONFIG_DUPLICATE_F_OPTIONS 556
#define LANG_LOG_CONFIG_OPENING_CONFIG_FILE 557
#define LANG_LOG_CONFIG_CONFIG_FILE_MISSING 558
#define LANG_LOG_CONFIG_CONFIG_FILE_OPEN_ERROR 559
#define LANG_LOG_CONFIG_UNPARSEABLE_BW_HISTORY 560
#define LANG_LOG_CONFIG_INVALID_MAPADDRESS_ARGUMENT 561
#define LANG_LOG_CONFIG_EXTRA_MAPADDRESS_ARGUMENTS 562
#define LANG_LOG_CONFIG_TOO_FEW_MAPADDRESS_ARGUMENTS 563
#define LANG_LOG_CONFIG_TOO_FEW_BRIDGE_ARGUMENTS 564
#define LANG_LOG_CONFIG_INVALID_BRIDGE_ADDRESS 565
#define LANG_LOG_CONFIG_MISSING_PORT_IN_BRIDGE_ADDRESS 566
#define LANG_LOG_CONFIG_INVALID_BRIDGE_KEY 567
#define LANG_LOG_CONFIG_ERROR_DECODING_BRIDGE_KEY 568
#define LANG_LOG_CONFIG_BRIDGE_AT 569
#define LANG_LOG_CONFIG_NO_BRIDGE_KEY 570
#define LANG_LOG_CONFIG_DIRSERVER_NO_ARGUMENTS 571
#define LANG_LOG_CONFIG_DIRSERVER_INVALID_ORPORT 572
#define LANG_LOG_CONFIG_DIRSERVER_BAD_V3_DIGEST 573
#define LANG_LOG_CONFIG_DIRSERVER_UNRECOGNIZED_FLAG 574
#define LANG_LOG_CONFIG_DIRSERVER_TOO_FEW_ARGUMENTS 575
#define LANG_LOG_CONFIG_DIRSERVER_ADDR_ERROR 576
#define LANG_LOG_CONFIG_DIRSERVER_MISSING_PORT 577
#define LANG_LOG_CONFIG_DIRSERVER_KEY_ERROR 578
#define LANG_LOG_CONFIG_DIRSERVER_KEY_DECODE_ERROR 579
#define LANG_LOG_CONFIG_DIRSERVER_TRUSTED 580
#define LANG_LOG_CONFIG_CONFIG_FILE_NOT_A_FILE 581
#define LANG_LOG_CONFIG_CONFIG_STRING_ERROR 582
#define LANG_LOG_CONFIG_TOR_SNPRINTF_FAILED 583
#define LANG_LOG_CONFIG_CONFIG_FILE_RENAME 584
#define LANG_LOG_CONFIG_CONFIG_FILE_RENAME_ERROR 585
#define LANG_LOG_CONFIG_UNKNOWN_UNIT 586
#define LANG_LOG_CONFIG_INTERVAL_TOO_LONG 587
#define LANG_LOG_CONFIG_LIBEVENT_FN_NOT_IMPLEMENTED 588
#define LANG_LOG_CONFIG_LIBEVENT_VERSION_MISMATCH 589
#define LANG_LOG_CONFIG_CRASH_WARN_1 590
#define LANG_LOG_CONFIG_CRASH_WARN_2 591
#define LANG_LOG_CONFIG_CRASH_WARN_3 592
#define LANG_LOG_CONFIG_LIBEVENT_HEADERS_MISMATCH_1 593
#define LANG_LOG_CONFIG_LIBEVENT_HEADERS_MISMATCH_2 594
#define LANG_LOG_CONFIG_LIBEVENT_INIT_OK 595
#define LANG_LOG_CONFIG_LIBEVENT_TOO_OLD 596
#define LANG_LOG_CONFIG_LIBEVENT_UNSAFE 597
#define LANG_LOG_CONFIG_LIBEVENT_BUGGY_1 598
#define LANG_LOG_CONFIG_LIBEVENT_BUGGY_2 599
#define LANG_LOG_CONFIG_LIBEVENT_TOO_SLOW 600
#define LANG_LOG_CONFIG_OBSOLETE_FILE_REMOVE 601
#define LANG_LOG_CONFIG_STRICTEXITNODES_WITHOUT_EXITNODES 602
#define LANG_LOG_CONFIG_STRICTENTRYNODES_WITHOUT_ENTRYNODES 603
#define LANG_LOG_CONFIG_CONSTRAINED_SOCKET_BUFFERS 604
#define LANG_LOG_CONFIG_V3AUTHVOTINGINTERVAL_IS_NOT_DAYS 605
#define LANG_LOG_CONFIG_TESTINGAUTHDIRTIMETOLEARNREACHABILITY_TOO_HIGH 606
#define LANG_LOG_CONFIG_TESTINGESTIMATEDDESCRIPTORPROPAGATIONTIME_TOO_HIGH 607
#define LANG_LOG_CONFIG_ORPORT_OUT_OF_BOUNDS 608
#define LANG_LOG_CONFIG_ORLISTEN_WITHOUT_ORPORT 609
#define LANG_LOG_CONFIG_DIRLISTENADDRESS_WITHOUT_DIRPORT 610
#define LANG_LOG_CONFIG_DNSLISTENADDRESS_WITHOUT_DNSPORT 611
#define LANG_LOG_CONFIG_CONTROLLISTENADDRESS_WITHOUT_CONTROLPORT 612
#define LANG_LOG_CONFIG_TRANSLISTENADDRESS_WITHOUT_TRANSPORT 613
#define LANG_LOG_CONFIG_NATDLISTENADDRESS_WITHOUT_NATDPORT 614
#define LANG_LOG_CONFIG_SOCKSPORT_OUT_OF_BOUNDS 615
#define LANG_LOG_CONFIG_DNSPORT_OUT_OF_BOUNDS 616
#define LANG_LOG_CONFIG_TRANSPORT_OUT_OF_BOUNDS 617
#define LANG_LOG_CONFIG_NATDPORT_OUT_OF_BOUNDS 618
#define LANG_LOG_CONFIG_CONTROLPORT_OUT_OF_BOUNDS 619
#define LANG_LOG_CONFIG_DIRPORT_OUT_OF_BOUNDS 620
#define LANG_LOG_CONFIG_TRANSPORT_DISABLED 621
#define LANG_LOG_CONFIG_IPS_IN_ENTRYNODES 622
#define LANG_LOG_CONFIG_AUTH_DIR_MUST_SET_CONTACTINFO 623
#define LANG_LOG_CONFIG_AUTH_DIR_WITHOUT_RECOMMENDEDVERSIONS 624
#define LANG_LOG_CONFIG_VERSIONING_AUTH_WITHOUT_RECOMMENDEDVERSIONS 625
#define LANG_LOG_CONFIG_AUTHDIR_WITHOUT_TYPE 626
#define LANG_LOG_CONFIG_AUTH_DIR_WITHOUT_DIRPORT 627
#define LANG_LOG_CONFIG_AUTH_DIR_WITHOUT_ORPORT 628
#define LANG_LOG_CONFIG_AUTH_DIR_WITH_CLIENTONLY 629
#define LANG_LOG_CONFIG_HSAUTHORITYRECORDSTATS_WITHOUT_HS_AUTH 630
#define LANG_LOG_CONFIG_SERVER_WITH_FASCIST_FIREWALL 631
#define LANG_LOG_CONFIG_SERVER_WITH_USEBRIDGES 632
#define LANG_LOG_CONFIG_KEEPALIVE_NEGATIVE 633
#define LANG_LOG_CONFIG_RELAYBANDWIDTHBURST_LESS_THAN_RELAYBANDWIDTHRATE 634
#define LANG_LOG_CONFIG_BANDWIDTHBURST_LESS_THAN_BANDWIDTHRATE 635
#define LANG_LOG_CONFIG_HTTPPROXY_PARSE_FAILED 636
#define LANG_LOG_CONFIG_HTTPPROXYAUTHENTICATOR_TOO_LONG 637
#define LANG_LOG_CONFIG_HTTPSPROXY_PARSE_FAILED 638
#define LANG_LOG_CONFIG_HTTPSPROXYAUTHENTICATOR_TOO_LONG 639
#define LANG_LOG_CONFIG_HASHEDCONTROLPASSWORD_BAD 640
#define LANG_LOG_CONFIG_HASHEDCONTROLSESSIONPASSWORD_BAD 641
#define LANG_LOG_CONFIG_USEENTRYGUARDS_WITHOUT_NUMENTRYGUARDS 642
#define LANG_LOG_CONFIG_DIR_AUTH_LINE_PARSE_FAILED 643
#define LANG_LOG_CONFIG_USEBRIDGES_WITHOUT_BRIDGES 644
#define LANG_LOG_CONFIG_USEBRIDGES_WITHOUT_TUNNELDIRCONS 645
#define LANG_LOG_CONFIG_BRIDGE_LINE_PARSE_FAILED 646
#define LANG_LOG_CONFIG_CONSTRAINEDSOCKSIZE_INVALID 647
#define LANG_LOG_CONFIG_V3AUTHVOTINGINTERVAL_TOO_LOW 648
#define LANG_LOG_CONFIG_V3AUTHVOTEDELAY_TOO_LOW 649
#define LANG_LOG_CONFIG_V3AUTHDISTDELAY_TOO_LOW 650
#define LANG_LOG_CONFIG_V3AUTHNINTERVALSVALID_TOO_LOW 651
#define LANG_LOG_CONFIG_V3AUTHVOTINGINTERVAL_TOO_LOW_2 652
#define LANG_LOG_CONFIG_V3AUTHVOTINGINTERVAL_TOO_HIGH 653
#define LANG_LOG_CONFIG_RENDEZVOUS_CONFIG_FAILED 654
#define LANG_LOG_CONFIG_RENDEZVOUS_AUTH_CONFIG_FAILED 655
#define LANG_LOG_CONFIG_PREFERTUNNELDIRCONNS_WITHOUT_TUNNELDIRCONNS 656
#define LANG_LOG_CONFIG_TESTINGTORNETWORK_WITH_DEFAULT_DIRSERVERS 657
#define LANG_LOG_CONFIG_TESTINGV3AUTHINITIALVOTINGINTERVAL_WITHOUT_TESTINGTORNETWORK 658
#define LANG_LOG_CONFIG_TESTINGV3AUTHINITIALVOTINGINTERVAL_TOO_LOW 659
#define LANG_LOG_CONFIG_TESTINGV3AUTHINITIALVOTINGINTERVAL_MUST_DIVIDE_TO_30_MIN 660
#define LANG_LOG_CONFIG_TESTINGV3AUTHINITIALVOTEDLEAY_WITHOUT_TESTINGTORNETWORK 661
#define LANG_LOG_CONFIG_TESTINGV3AUTHINITIALVOTEDELAY_TOO_LOW 662
#define LANG_LOG_CONFIG_TESTINGV3AUTHINITIALDISTDELAY_WITHOUT_TESTINGTORNETWORK 663
#define LANG_LOG_CONFIG_TESTINGV3AUTHINITIALDISTDELAY_TOO_LOW 664
#define LANG_LOG_CONFIG_TESTINGV3AUTHINITIALVOTINGINTERVAL_TOO_LOW_2 665
#define LANG_LOG_CONFIG_TESTINGAUTHDIRTIMETOLEARNREACHABILITY_WITHOUT_TESTINGTORNETWORK 666
#define LANG_LOG_CONFIG_TESTINGAUTHDIRTIMETOLEARNREACHABILITY_NEGATIVE 667
#define LANG_LOG_CONFIG_TESTINGESTIMATEDDESCRIPTORPROPAGATIONTIME_WITHOUT_TESTINGTORNETWORK 668
#define LANG_LOG_CONFIG_TESTINGESTIMATEDDESCRIPTORPROPAGATIONTIME_NEGATIVE 669
#define LANG_LOG_CONFIG_INVALID_INT 670
#define LANG_LOG_CONFIG_INTERNAL_ERROR 671
#define LANG_LOG_CONFIG_INVALID_INTERVAL 672
#define LANG_LOG_CONFIG_INVALID_VALUE 673
#define LANG_LOG_CONFIG_INVALID_BOOLEAN 674
#define LANG_LOG_CONFIG_INVALID_KEYWORD_TYPE 675
#define LANG_LOG_CONFIG_INVALID_EXIT_LIST 676
#define LANG_LOG_CONFIG_INVALID_PORT 677
#define LANG_LOG_CONFIG_VIRTUAL_OPTION_VALUE 678
#define LANG_LOG_CONFIG_INVALID_NICKNAME 679
#define LANG_LOG_CONFIG_PUBLISHSERVERDESCRIPTOR_INVALID 680
#define LANG_LOG_CONFIG_BANDWIDTHRATE_TOO_LOW 681
#define LANG_LOG_CONFIG_MAXADVERTISEDBANDWIDTH_TOO_LOW 682
#define LANG_LOG_CONFIG_RELAYBANDWIDTHRATE_TOO_LOW 683
#define LANG_LOG_CONFIG_INVALID_NICKNAME_IN_LINE 684
#define LANG_LOG_CONFIG_CONFIG_PARSE_FAILED 685

#define LANG_LOG_CONNECTION_UNKNOWN_CONNECTION_TYPE 686
#define LANG_LOG_CONNECTION_UNKNOWN_CONNECTION_STATE 687
#define LANG_LOG_CONNECTION_ERROR_REMOVING_READ_EVENT 688
#define LANG_LOG_CONNECTION_ERROR_REMOVING_WRITE_EVENT 689
#define LANG_LOG_CONNECTION_FREEING_LINKED_CONNECTION 690
#define LANG_LOG_CONNECTION_COULD_NOT_UNLINK 691
#define LANG_LOG_CONNECTION_CLOSING_FD 692
#define LANG_LOG_CONNECTION_CALLED_OR_CONN_WITH_IDENTITY_DIGEST 693
#define LANG_LOG_CONNECTION_CALLED_WITH_LINKED_CONN_SET 694
#define LANG_LOG_CONNECTION_EDGE_CONNECTION_HASNT_SENT_END 695
#define LANG_LOG_CONNECTION_CLOSING_WITHOUT_REPLYING 696
#define LANG_LOG_CONNECTION_CLOSING_WITHOUT_END_REASON 697
#define LANG_LOG_CONNECTION_CLOSING_WITHOUT_DNS_REPLY 698
#define LANG_LOG_CONNECTION_CLOSING_ALREADY_CLOSED 699
#define LANG_LOG_CONNECTION_CONN_STATS 700
#define LANG_LOG_CONNECTION_DUPLICATE_CONNECTION_MARK_FOR_CLOSE 701
#define LANG_LOG_CONNECTION_WRITE_TIMEOUT_BEFORE_CLOSE 702
#define LANG_LOG_CONNECTION_ERROR_PARSING_LISTENADDRESS 703
#define LANG_LOG_CONNECTION_UNIX_SOCKETS_NOT_SUPPORTED 704
#define LANG_LOG_CONNECTION_TOO_MANY_CONNS 705
#define LANG_LOG_CONNECTION_OPENING_LISTENER 706
#define LANG_LOG_CONNECTION_SOCKET_CREATION_FAILED 707
#define LANG_LOG_CONNECTION_COULD_NOT_BIND_TO 708
#define LANG_LOG_CONNECTION_COULD_NOT_LISTEN_ON 709
#define LANG_LOG_CONNECTION_OPENING_LISTENER_2 710
#define LANG_LOG_CONNECTION_COULD_NOT_UNLINK_2 711
#define LANG_LOG_CONNECTION_SOCKET_CREATION_FAILED_2 712
#define LANG_LOG_CONNECTION_COULD_NOT_BIND_TO_2 713
#define LANG_LOG_CONNECTION_COULD_NOT_LISTEN_ON_2 714
#define LANG_LOG_CONNECTION_UNEXPECTED_ADDRESS_FAMILY 715
#define LANG_LOG_CONNECTION_ADDING_LISTENER_FAILED 716
#define LANG_LOG_CONNECTION_LISTENER_ADDED 717
#define LANG_LOG_CONNECTION_UNEXPECTED_ADDRESS_LENGTH 718
#define LANG_LOG_CONNECTION_UNEXPECTED_PORT_VALUE 719
#define LANG_LOG_CONNECTION_UNEXPECTED_AF 720
#define LANG_LOG_CONNECTION_ACCEPT_FAILED 721
#define LANG_LOG_CONNECTION_ACCEPT_OK 722
#define LANG_LOG_CONNECTION_ACCEPT_UNEXPECTED_ADDRESS 723
#define LANG_LOG_CONNECTION_GETSOCKNAME_FAILED 724
#define LANG_LOG_CONNECTION_UNEXPECTED_SOCKADDR 725
#define LANG_LOG_CONNECTION_DENYING_CONNECTION 726
#define LANG_LOG_CONNECTION_DENYING_DIR_CONNECTION 727
#define LANG_LOG_CONNECTION_BANNED_ADDRESS 728
#define LANG_LOG_CONNECTION_CONNECTION_REQUEST 729
#define LANG_LOG_CONNECTION_RESOLVE_REQUEST 730
#define LANG_LOG_CONNECTION_RESOLVE_REQUEST_2 731
#define LANG_LOG_CONNECTION_ERROR_CREATING_SOCKET 732
#define LANG_LOG_CONNECTION_OUTBOUNDBINDADDRESS_PARSE_FAILED 733
#define LANG_LOG_CONNECTION_ERROR_BINDING_SOCKET 734
#define LANG_LOG_CONNECTION_CONNECTING_TO 735
#define LANG_LOG_CONNECTION_CONNECT_FAILED 736
#define LANG_LOG_CONNECTION_CONNECT_OK 737
#define LANG_LOG_CONNECTION_IN_PROGRESS 738
#define LANG_LOG_CONNECTION_ESTABLISHED 739
#define LANG_LOG_CONNECTION_CLOSING_UNCONFIGURED 740
#define LANG_LOG_CONNECTION_ALREADY_HAVE 741
#define LANG_LOG_CONNECTION_RATE_OUT_OF_RANGE 742
#define LANG_LOG_CONNECTION_WAKING_UP_CONN_FOR_READ 743
#define LANG_LOG_CONNECTION_WAKING_UP_CONN_FOR_WRITE 744
#define LANG_LOG_CONNECTION_READ_STATS 745
#define LANG_LOG_CONNECTION_TLS_CONNECTION_CLOSED 746
#define LANG_LOG_CONNECTION_CLEANLY 747
#define LANG_LOG_CONNECTION_NOT_SET 748
#define LANG_LOG_CONNECTION_TLS_ERROR 749
#define LANG_LOG_CONNECTION_READING_PENDING_BYTES_FAILED 750
#define LANG_LOG_CONNECTION_AFTER_TLS_READ 751
#define LANG_LOG_CONNECTION_MOVED_BYTES_ON_INTERNAL_LINK 752
#define LANG_LOG_CONNECTION_CALLED_RECURSIVELY 753
#define LANG_LOG_CONNECTION_GETSOCKOPT_FAILED 754
#define LANG_LOG_CONNECTION_IN_PROGRESS_CONNECT_FAILED 755
#define LANG_LOG_CONNECTION_TLS_ERROR_2 756
#define LANG_LOG_CONNECTION_TLS_ERROR_3 757
#define LANG_LOG_CONNECTION_TLS_CONNECTION_CLOSED_ON_FLUSH 758
#define LANG_LOG_CONNECTION_TLS_CLOSED 759
#define LANG_LOG_CONNECTION_WANTED_WRITE 760
#define LANG_LOG_CONNECTION_WANTED_READ 761
#define LANG_LOG_CONNECTION_AFTER_TLS_WRITE 762
#define LANG_LOG_CONNECTION_WRITE_TO_BUF_FAILED 763
#define LANG_LOG_CONNECTION_WRITE_TO_BUF_FAILED_2 764
#define LANG_LOG_CONNECTION_UNHANDLED_ERROR 765
#define LANG_LOG_CONNECTION_GETSOCKNAME_FAILED_2 766
#define LANG_LOG_CONNECTION_IP_CHANGED 767
#define LANG_LOG_CONNECTION_SETSOCKOPT_FAILED 768
#define LANG_LOG_CONNECTION_SETSOCKOPT_FAILED_2 769
#define LANG_LOG_CONNECTION_UNEXPECTED_CONN_TYPE 770
#define LANG_LOG_CONNECTION_BUFFER_STATS 771
#define LANG_LOG_CONNECTION_CONNECTION_STATS 772

#define LANG_LOG_EDGE_TWO_SOCKS_REPLIES 773
#define LANG_LOG_EDGE_CONN_REACHED_EOF 774
#define LANG_LOG_EDGE_RECEIVED_DATA_IN_UNEXPECTED_STATE 775
#define LANG_LOG_EDGE_UNEXPECTED_STATE 776
#define LANG_LOG_EDGE_CIRCID_AT_AN_EDGE 777
#define LANG_LOG_EDGE_CONNECTION_EDGE_END_ON_ALREADY_ENDED 778
#define LANG_LOG_EDGE_CALLED_ON_CONN_MARKED_FOR_CLOSE 779
#define LANG_LOG_EDGE_SENDING_END_ON_CONN 780
#define LANG_LOG_EDGE_NO_CIRC_TO_SEND_END 781
#define LANG_LOG_EDGE_CALLED_IN_UNEXPECTED_STATE 782
#define LANG_LOG_EDGE_EXIT_CONNECTION_ESTABLISHED 783
#define LANG_LOG_EDGE_CONNECTION_TIMEOUT 784
#define LANG_LOG_EDGE_CONN_LOST_CIRC 785
#define LANG_LOG_EDGE_REND_TIMEOUT 786
#define LANG_LOG_EDGE_CONNECTION_TIMEOUT_2 787
#define LANG_LOG_EDGE_CLOSING_STREAM_FAILED 788
#define LANG_LOG_EDGE_GIVING_UP_ON_ENCLAVE_EXIT 789
#define LANG_LOG_EDGE_TRACKHOSTEXITS_CLEAR_ENTRY 790
#define LANG_LOG_EDGE_ADDRESSMAP_REWRITE_ADDRESS 791
#define LANG_LOG_EDGE_ADDRESSMAP_REWRITTEN_TOO_MUCH 792
#define LANG_LOG_EDGE_ADDRESSMAP_REWRITE_REVDNS 793
#define LANG_LOG_EDGE_ADDRESSMAP_ADDR_ALREADY_MAPPED 794
#define LANG_LOG_EDGE_ADDRESSMAP_REMAPPED_ADDR 795
#define LANG_LOG_EDGE_ADDRESS_HAS_RESOLVE_FAILURES 796
#define LANG_LOG_EDGE_ADDRS_AVAILABLE 797
#define LANG_LOG_EDGE_OUT_OF_VIRTUAL_ADDRESSES 798
#define LANG_LOG_EDGE_UNSUPPORTED_ADDRESS_TYPE 799
#define LANG_LOG_EDGE_INTERNAL_CONFUSION 800
#define LANG_LOG_EDGE_ADDRESSMAP_REGISTERING_NEW 801
#define LANG_LOG_EDGE_ADDRESSMAP_MAP_OK 802
#define LANG_LOG_EDGE_UNENCRYPTED_PROTOCOL 803
#define LANG_LOG_EDGE_CLOSING 804
#define LANG_LOG_EDGE_REJECTPLAINTEXTPORTS 805
#define LANG_LOG_EDGE_CLIENT_ASKED_FOR 806
#define LANG_LOG_EDGE_AUTOMAPPING 807
#define LANG_LOG_EDGE_ADDRESSMAP_MISSING_MAPPING 808
#define LANG_LOG_EDGE_INVALID_HOSTNAME 809
#define LANG_LOG_EDGE_MALFORMED_EXIT 810
#define LANG_LOG_EDGE_UNRECOGNIZED_EXIT 811
#define LANG_LOG_EDGE_INVALID_HOSTNAME_2 812
#define LANG_LOG_EDGE_ADDRESS_TOO_LARGE 813
#define LANG_LOG_EDGE_CONNECT_TO_PORT_0 814
#define LANG_LOG_EDGE_REDIRECTING_TO_EXIT 815
#define LANG_LOG_EDGE_RESOLVE_TO_HIDDEN_SERVICE 816
#define LANG_LOG_EDGE_ATTACHSTREAM_NOT_SUPPORTED_FOR_ONION 817
#define LANG_LOG_EDGE_HS_REQUEST 818
#define LANG_LOG_EDGE_INVALID_HS_NAME 819
#define LANG_LOG_EDGE_USING_PREVIOUS_AUTH 820
#define LANG_LOG_EDGE_FETCHING_UNKNOWN_DESCRIPTOR 821
#define LANG_LOG_EDGE_DESCRIPTOR_NEW 822
#define LANG_LOG_EDGE_FETCHING_STALE_DESCRIPTOR 823
#define LANG_LOG_EDGE_GETSOCKOPT_FAILED 824
#define LANG_LOG_EDGE_GETSOCKNAME_FAILED 825
#define LANG_LOG_EDGE_GETSOCKNAME_UNEXPECTED_AF 826
#define LANG_LOG_EDGE_CONNECTION_AP_GET_ORIGINAL_DESTINATION 827
#define LANG_LOG_EDGE_CONNECTION_AP_PROCESS_SOCKS 828
#define LANG_LOG_EDGE_HANDSHAKE_INCOMPLETE 829
#define LANG_LOG_EDGE_SOCKS_USING_REPLY 830
#define LANG_LOG_EDGE_SOCKS_HANDSHAKE_FAILED 831
#define LANG_LOG_EDGE_CONNECTION_AP_PROCESS_TRANSPARENT 832
#define LANG_LOG_EDGE_FETCHING_ORIGINAL_DESTINATION_FAILED 833
#define LANG_LOG_EDGE_CONNECTION_AP_PROCESS_NATD 834
#define LANG_LOG_EDGE_NATD_HANDSHAKE_FAILED 835
#define LANG_LOG_EDGE_NATD_HANDSHAKE_FAILED_2 836
#define LANG_LOG_EDGE_NATD_HANDSHAKE_FAILED_3 837
#define LANG_LOG_EDGE_NO_UNUSED_STREAM_ID 838
#define LANG_LOG_EDGE_BEGIN_STREAM 839
#define LANG_LOG_EDGE_HANDSHAKE_ADDR_SENT 840
#define LANG_LOG_EDGE_INVALID_REVDNS 841
#define LANG_LOG_EDGE_REVDNS_ERROR 842
#define LANG_LOG_EDGE_REVDNS_ADDR_SENT 843
#define LANG_LOG_EDGE_MAKE_INTERNAL_TUNNEL 844
#define LANG_LOG_EDGE_DIRECT 845
#define LANG_LOG_EDGE_ANONYMIZED 846
#define LANG_LOG_EDGE_AP_CONN_CREATED 847
#define LANG_LOG_EDGE_DUPLICATE_HANDSHAKE_SOCKS_REPLY 848
#define LANG_LOG_EDGE_RELAY_BEGIN_AT_NON_SERVER 849
#define LANG_LOG_EDGE_RELAY_BEGIN_ERROR 850
#define LANG_LOG_EDGE_RELAY_BEGIN_ERROR_2 851
#define LANG_LOG_EDGE_RELAY_BEGIN_ERROR_3 852
#define LANG_LOG_EDGE_OPEN_STREAM_ON_FIRST_HOP 853
#define LANG_LOG_EDGE_UNEXPECTED_COMMAND 854
#define LANG_LOG_EDGE_EXIT_CONNECTION_NEW 855
#define LANG_LOG_EDGE_REND_CONFIGURING_STREAM 856
#define LANG_LOG_EDGE_REND_SERVICE_NOT_FOUND 857
#define LANG_LOG_EDGE_FINISHED_ASSIGNING_ADDR_PORT 858
#define LANG_LOG_EDGE_STARTING_DNS_RESOLVE 859
#define LANG_LOG_EDGE_CONNECTION_EXIT_CONNECT 860
#define LANG_LOG_EDGE_EXIT_POLICY 861
#define LANG_LOG_EDGE_CONNECTING 862
#define LANG_LOG_EDGE_NEW_CONNECTION_HAD_DATA 863
#define LANG_LOG_EDGE_DIR_EXIT_NEW_CONN 864

#define LANG_LOG_CONN_OR_ERROR_REMOVING_DIGEST 865
#define LANG_LOG_CONN_OR_EOF 866
#define LANG_LOG_CONN_OR_HTTPS_OVERSIZED_RESPONSE 867
#define LANG_LOG_CONN_OR_HTTPS_INCOMPLETE_RESPONSE 868
#define LANG_LOG_CONN_OR_PROXY_RESPONSE_PARSE_FAILED 869
#define LANG_LOG_CONN_OR_NO_REASON 870
#define LANG_LOG_CONN_OR_HTTPS_OK 871
#define LANG_LOG_CONN_OR_HTTPS_STATUS_ERROR 872
#define LANG_LOG_CONN_OR_CONNECT_SENT 873
#define LANG_LOG_CONN_OR_FINISHED_FLUSHING_UNEXPECTED 874
#define LANG_LOG_CONN_OR_FINISHED_CONNECTING 875
#define LANG_LOG_CONN_OR_HTTPS_AUTH_ENCODING_FAILED 876
#define LANG_LOG_CONN_OR_CONN_TOO_OLD 877
#define LANG_LOG_CONN_OR_CONN_TOO_OLD_2 878
#define LANG_LOG_CONN_OR_CONN_TOO_OLD_3 879
#define LANG_LOG_CONN_OR_CONN_TOO_OLD_4 880
#define LANG_LOG_CONN_OR_REFUSING_SELF_CONN 881
#define LANG_LOG_CONN_OR_TOR_TLS_NEW_FAILED 882
#define LANG_LOG_CONN_OR_TLS_HANDSHAKE_START 883
#define LANG_LOG_CONN_OR_NO_CERT_FROM_ROUTER 884
#define LANG_LOG_CONN_OR_NO_CERT_FROM_CONN 885
#define LANG_LOG_CONN_OR_INVALID_CERT_FROM_ROUTER 886
#define LANG_LOG_CONN_OR_INVALID_CERT_FROM_CONN 887
#define LANG_LOG_CONN_OR_CERT_OK 888
#define LANG_LOG_CONN_OR_CONNECTED_WITHOUT_KEY 889
#define LANG_LOG_CONN_OR_UNEXPECTED_KEY_FROM_ROUTER 890
#define LANG_LOG_CONN_OR_TLS_HANDSHAKE_DONE 891
#define LANG_LOG_CONN_OR_RETRY_EARLIER_ENTRYGUARDS 892
#define LANG_LOG_CONN_OR_PROCESS_CELLS_FROM_INBUF 893
#define LANG_LOG_CONN_OR_SENDING_DESTROY 894

#define LANG_LOG_CONTROL_STRING_FORMAT_ERROR 895
#define LANG_LOG_CONTROL_EVENT_FORMAT_ERROR 896
#define LANG_LOG_CONTROL_CONFIG_FORMAT_ERROR 897
#define LANG_LOG_CONTROL_CONFIG_DID_NOT_VALIDATE 898
#define LANG_LOG_CONTROL_CONFIG_FILE_DID_NOT_VALIDATE 899
#define LANG_LOG_CONTROL_AUTH_COOKIE_ERROR_1 900
#define LANG_LOG_CONTROL_AUTH_COOKIE_ERROR_2 901
#define LANG_LOG_CONTROL_HASHEDCONTROLPASSWORD_ERROR 902
#define LANG_LOG_CONTROL_BAD_PASSWORD 903
#define LANG_LOG_CONTROL_AUTHENTICATED 904
#define LANG_LOG_CONTROL_MAPADDRESS_ALLOCATION_ERROR 905
#define LANG_LOG_CONTROL_MAPADDRESS_WRONG_NUMBER_OF_ITEMS 906
#define LANG_LOG_CONTROL_GETINFO 907
#define LANG_LOG_CONTROL_STREAM_IN_UNKNOWN_STATE 908
#define LANG_LOG_CONTROL_OBSOLETE_ADDR_MAPPING 909
#define LANG_LOG_CONTROL_DEPRECATED 910
#define LANG_LOG_CONTROL_UNKNOWN_OPTION 911
#define LANG_LOG_CONTROL_RESOLVE_WITHOUT_ADDRMAP 912
#define LANG_LOG_CONTROL_CONTROLLER_EOF 913
#define LANG_LOG_CONTROL_UNRECOGNIZED_STATUS_CODE 914
#define LANG_LOG_CONTROL_UNRECOGNIZED_STATUS_TYPE 915
#define LANG_LOG_CONTROL_UNRECOGNIZED_STATUS_SEVERITY 916
#define LANG_LOG_CONTROL_FORMAT_STRING_TOO_LONG 917
#define LANG_LOG_CONTROL_ERROR_WRITING_AUTH_COOKIE 918
#define LANG_LOG_CONTROL_BOOTSTRAPPED 919
#define LANG_LOG_CONTROL_BOOTSTRAPPING_STUCK 920
#define LANG_LOG_CONTROL_BS_UNDEFINED 921
#define LANG_LOG_CONTROL_BS_STARTING 922
#define LANG_LOG_CONTROL_BS_CONN_DIR 923
#define LANG_LOG_CONTROL_BS_FINISHING_HANDSHAKE 924
#define LANG_LOG_CONTROL_BS_FINISHING_DIR_HANDSHAKE 925
#define LANG_LOG_CONTROL_BS_ESTABLISHING_ENCRYPTED_DIR_CONN 926
#define LANG_LOG_CONTROL_BS_ASKING_FOR_CONSENSUS 927
#define LANG_LOG_CONTROL_BS_LOADING_CONSENSUS 928
#define LANG_LOG_CONTROL_BS_LOADING_CERTS 929
#define LANG_LOG_CONTROL_BS_ASKING_FOR_DESCRIPTORS 930
#define LANG_LOG_CONTROL_BS_LOADING_DESCRIPTORS 931
#define LANG_LOG_CONTROL_BS_CONNECTING 932
#define LANG_LOG_CONTROL_BS_HANDSHAKE_FIRST_HOP 933
#define LANG_LOG_CONTROL_BS_ESTABLISHING_CIRCUIT 934
#define LANG_LOG_CONTROL_BS_CONNECTED 935

#define LANG_LOG_WORKER_READ_EOF 936
#define LANG_LOG_WORKER_ABANDONING_CIRC 937
#define LANG_LOG_WORKER_DECODING_FAILED 938
#define LANG_LOG_WORKER_CIRC_GONE 939
#define LANG_LOG_WORKER_ONIONSKIN_ANSWER_FAILED 940
#define LANG_LOG_WORKER_ONIONSKIN_ANSWER_OK 941
#define LANG_LOG_WORKER_CONN_CLOSED 942
#define LANG_LOG_WORKER_CONN_ERROR 943
#define LANG_LOG_WORKER_READ_TAG_FAILED 944
#define LANG_LOG_WORKER_READ_QUESTION_FAILED 945
#define LANG_LOG_WORKER_ONION_SKIN_SERVER_HANDSHAKE_FAILED 946
#define LANG_LOG_WORKER_ONION_SKIN_SERVER_HANDSHAKE_SUCCEEDED 947
#define LANG_LOG_WORKER_WRITING_RESPONSE_FAILED 948
#define LANG_LOG_WORKER_FINISHED_WRITING_RESPONSE 949
#define LANG_LOG_WORKER_SOCKETPAIR_ERROR 950
#define LANG_LOG_WORKER_NEW 951
#define LANG_LOG_WORKER_CONNECTION_ADD_FAILED 952
#define LANG_LOG_WORKER_FAILED_NEW 953
#define LANG_LOG_WORKER_ASSIGN_FAILED 954
#define LANG_LOG_WORKER_CLOSING_WEDGED_WORKER 955
#define LANG_LOG_WORKER_QUEUE_NEW 956
#define LANG_LOG_WORKER_FAILING_CIRC 957

#define LANG_LOG_DIR_UNKNOWN_PURPOSE 958
#define LANG_LOG_DIR_P_HS_FETCH 959
#define LANG_LOG_DIR_P_DESCRIPTOR_UPLOAD 960
#define LANG_LOG_DIR_P_HS_DESC_UPLOAD 961
#define LANG_LOG_DIR_P_VOTE_UPLOAD 962
#define LANG_LOG_DIR_P_CONSENSUS_SIGNATURE_UPLOAD 963
#define LANG_LOG_DIR_P_NETWORKSTATUS_FETCH 964
#define LANG_LOG_DIR_P_SERVER_DESC_FETCH 965
#define LANG_LOG_DIR_P_EXTRA_INFO_FETCH 966
#define LANG_LOG_DIR_P_CONSENSUS_NETWORKSTATUS_FETCH 967
#define LANG_LOG_DIR_P_AUTH_CERT_FETCH 968
#define LANG_LOG_DIR_P_STATUS_VOTE_FETCH 969
#define LANG_LOG_DIR_P_CONSENSUS_SIGNATURE_FETCH 970
#define LANG_LOG_DIR_P_HSV2_DESC_FETCH 971
#define LANG_LOG_DIR_P_HSV2_DESC_UPLOAD 972
#define LANG_LOG_DIR_P_UNKNOWN 973
#define LANG_LOG_DIR_UPLOADING_EXTRAINFO 974
#define LANG_LOG_DIR_NO_AUTH_SUPPORT 975
#define LANG_LOG_DIR_UNEXPECTED_PURPOSE 976
#define LANG_LOG_DIR_NO_BRIDGE_NODES_AVAIL 977
#define LANG_LOG_DIR_ALL_AUTHORITIES_IN_USE 978
#define LANG_LOG_DIR_NO_ROUTER_FOUND 979
#define LANG_LOG_DIR_NO_RUNNING_DIRSERVERS 980
#define LANG_LOG_DIR_REQUEST_NOT_ANONYMIZED 981
#define LANG_LOG_DIR_REQUEST_FAILED_1 982
#define LANG_LOG_DIR_REQUEST_FAILED_2 983
#define LANG_LOG_DIR_REQUEST_FAILED_3 984
#define LANG_LOG_DIR_CONN_INIT 985
#define LANG_LOG_DIR_TUNNEL_TO_DIRSERVER_FAILED 986
#define LANG_LOG_DIR_UNABLE_TO_ADD_CONNECTION 987
#define LANG_LOG_DIR_HTTP_ENCODING_FAILED 988
#define LANG_LOG_DIR_DOWNLOADING_CONSENSUS 989
#define LANG_LOG_DIR_URL_TOO_BIG 990
#define LANG_LOG_DIR_SKIPPING_OVER_HOSTNAME_STRING 991
#define LANG_LOG_DIR_IGNORING_UNRECOGNIZED_IP 992
#define LANG_LOG_DIR_HTTP_HEADER_PARSE_FAILED 993
#define LANG_LOG_DIR_HTTP_UNRECOGNIZED_ENCODING 994
#define LANG_LOG_DIR_FETCH_RESPONSE_TOO_LARGE 995
#define LANG_LOG_DIR_FETCH_RESPONSE_INCOMPLETE 996
#define LANG_LOG_DIR_HTTP_UNPARSEABLE_HEADERS 997
#define LANG_LOG_DIR_RESPONSE_RECEIVED 998
#define LANG_LOG_DIR_NEW_TIMESTAMP_DELTA 999
#define LANG_LOG_DIR_RECEIVED_SKEWED_TIME 1000
#define LANG_LOG_DIR_RECEIVED_SKEWED_TIME_2 1001
#define LANG_LOG_DIR_HTTP_ERROR 1002
#define LANG_LOG_DIR_HTTP_503 1003
#define LANG_LOG_DIR_HTTP_COMPRESSION_MISMATCH 1004
#define LANG_LOG_DIR_E_DEFLATED 1005
#define LANG_LOG_DIR_E_GZIPPED 1006
#define LANG_LOG_DIR_E_UNCOMPRESSED 1007
#define LANG_LOG_DIR_E_UNKNOWN 1008
#define LANG_LOG_DIR_E1_DEFLATED 1009
#define LANG_LOG_DIR_E1_GZIPPED 1010
#define LANG_LOG_DIR_E1_UNKNOWN 1011
#define LANG_LOG_DIR_E1_UNCOMPRESSED 1012
#define LANG_LOG_DIR_E_TRYING_BOTH 1013
#define LANG_LOG_DIR_HTTP_DECOMPRESS_FAILED 1014
#define LANG_LOG_DIR_RECEIVED_NETWORKSTATUS 1015
#define LANG_LOG_DIR_HTTP_ERROR_2 1016
#define LANG_LOG_DIR_RECEIVED_UNREQUESTED_NETWORKSTATUS 1017
#define LANG_LOG_DIR_HTTP_ERROR_3 1018
#define LANG_LOG_DIR_RECEIVED_CONSENSUS 1019
#define LANG_LOG_DIR_CONSENSUS_LOAD_ERROR 1020
#define LANG_LOG_DIR_CONSENSUS_LOAD_OK 1021
#define LANG_LOG_DIR_HTTP_ERROR_4 1022
#define LANG_LOG_DIR_RECEIVED_CERTS 1023
#define LANG_LOG_DIR_CERT_PARSE_FAILED 1024
#define LANG_LOG_DIR_CERTS_LOADED 1025
#define LANG_LOG_DIR_RECEIVED_VOTES 1026
#define LANG_LOG_DIR_HTTP_ERROR_5 1027
#define LANG_LOG_DIR_VOTE_ADD_ERROR 1028
#define LANG_LOG_DIR_VOTE_ADD_OK 1029
#define LANG_LOG_DIR_RECEIVED_SIGNATURES 1030
#define LANG_LOG_DIR_HTTP_ERROR_6 1031
#define LANG_LOG_DIR_SIGNATURES_ADD_ERROR 1032
#define LANG_LOG_DIR_RECEIVED_INFO 1033
#define LANG_LOG_DIR_HTTP_ERROR_7 1034
#define LANG_LOG_DIR_RECEIVED_DESC 1035
#define LANG_LOG_DIR_DESCRIPTOR_REJECTED 1036
#define LANG_LOG_DIR_DESCRIPTOR_ACCEPTED 1037
#define LANG_LOG_DIR_HTTP_ERROR_8 1038
#define LANG_LOG_DIR_HTTP_ERROR_9 1039
#define LANG_LOG_DIR_VOTE_UPLOADED 1040
#define LANG_LOG_DIR_HTTP_ERROR_10 1041
#define LANG_LOG_DIR_HTTP_ERROR_11 1042
#define LANG_LOG_DIR_SIGNATURE_UPLOADED 1043
#define LANG_LOG_DIR_HTTP_ERROR_12 1044
#define LANG_LOG_DIR_HTTP_ERROR_13 1045
#define LANG_LOG_DIR_REND_DESC_RECEIVED 1046
#define LANG_LOG_DIR_REND_DESC_PARSE_FAILED 1047
#define LANG_LOG_DIR_HTTP_ERROR_14 1048
#define LANG_LOG_DIR_HTTP_ERROR_15 1049
#define LANG_LOG_DIR_REND_FETCH_FAILED 1050
#define LANG_LOG_DIR_REND_DESC_V2_RECEIVED_1 1051
#define LANG_LOG_DIR_REND_DESC_V2_RECEIVED_2 1052
#define LANG_LOG_DIR_HTTP_ERROR_16 1053
#define LANG_LOG_DIR_HTTP_ERROR_17 1054
#define LANG_LOG_DIR_REND_DESC_UPLOADED 1055
#define LANG_LOG_DIR_REND_DESC_UPLOADED_OK 1056
#define LANG_LOG_DIR_HTTP_ERROR_18 1057
#define LANG_LOG_DIR_HTTP_ERROR_19 1058
#define LANG_LOG_DIR_HTTP_ERROR_20 1059
#define LANG_LOG_DIR_HTTP_EOF 1060
#define LANG_LOG_DIR_RECEIVED_TOO_MUCH 1061
#define LANG_LOG_DIR_RECEIVED_DATA 1062
#define LANG_LOG_DIR_STATUS_LINE_TOO_LONG 1063
#define LANG_LOG_DIR_AUTH_DIGEST_DECODE_FAILED 1064
#define LANG_LOG_DIR_RECEIVED_GET 1065
#define LANG_LOG_DIR_URL_REWRITTEN 1066
#define LANG_LOG_DIR_HTTP_SEND_503 1067
#define LANG_LOG_DIR_HTTP_SEND_503_BUSY 1068
#define LANG_LOG_DIR_HTTP_SEND_DIR 1069
#define LANG_LOG_DIR_COMPRESSED 1070
#define LANG_LOG_DIR_HTTP_SEND_503_3 1071
#define LANG_LOG_DIR_HTTP_SEND_503_4 1072
#define LANG_LOG_DIR_HTTP_SEND_503_5 1073
#define LANG_LOG_DIR_RECEIVED_REND_V2_REQUEST 1074
#define LANG_LOG_DIR_HANDLING_REND_GET 1075
#define LANG_LOG_DIR_RECEIVED_POST 1076
#define LANG_LOG_DIR_REJECT_REND_V2 1077
#define LANG_LOG_DIR_REJECT_REND_V2_2 1078
#define LANG_LOG_DIR_ACCEPT_REND_POST 1079
#define LANG_LOG_DIR_ROUTER_DESC_ERROR 1080
#define LANG_LOG_DIR_REJECT_ROUTER_DESC 1081
#define LANG_LOG_DIR_HANDLING_REND_POST 1082
#define LANG_LOG_DIR_REJECT_REND_DESC 1083
#define LANG_LOG_DIR_SIGNATURE_STORE_FAILED 1084
#define LANG_LOG_DIR_INVALID_INPUT 1085
#define LANG_LOG_DIR_COMMAND_INCOMPLETE 1086
#define LANG_LOG_DIR_HTTP_UNKNOWN_COMMAND 1087
#define LANG_LOG_DIR_CLIENT_FINISHED_SENDING_COMMAND 1088
#define LANG_LOG_DIR_FINISHED_WRITING_SERVER_RESPONSE 1089
#define LANG_LOG_DIR_UNEXPECTED_STATE 1090
#define LANG_LOG_DIR_CONNECTION_ESTABLISHED 1091
#define LANG_LOG_DIR_BAD_FINGERPRINT 1092
#define LANG_LOG_DIR_BAD_FINGERPRINT_2 1093
#define LANG_LOG_DIR_BAD_FINGERPRINT_3 1094
#define LANG_LOG_DIR_BAD_FINGERPRINT_4 1095
#define LANG_LOG_DIR_BAD_FINGERPRINT_5 1096
#define LANG_LOG_DIR_BAD_FINGERPRINT_6 1097
#define LANG_LOG_DIR_BAD_FINGERPRINT_7 1098
#define LANG_LOG_DIR_INCREMENT_FAILURES_1 1099
#define LANG_LOG_DIR_INCREMENT_FAILURES_2 1100
#define LANG_LOG_DIR_INCREMENT_FAILURES_3 1101
#define LANG_LOG_DIR_STATUS_NET_ERROR 1102
#define LANG_LOG_DIR_STATUS_DL_ERROR 1103
#define LANG_LOG_DIR_STATUS_DESC_DL_ERROR 1104
#define LANG_LOG_DIR_STATUS_CERT_DL_ERROR 1105
#define LANG_LOG_DIR_STATUS_SEND_REQUEST 1106
#define LANG_LOG_DIR_STATUS_URL 1107
#define LANG_LOG_DIR_STATUS_DOWNLOADING 1108
#define LANG_LOG_DIR_STATUS_EOF 1109
#define LANG_LOG_DIR_STATUS_CONN_ESTABLISHED 1110

#define LANG_LOG_DIRSERV_FINGERPRINT_DECODE_FAILED 1111
#define LANG_LOG_DIRSERV_MAPPING_FOR_RESERVED_NICKNAME 1112
#define LANG_LOG_DIRSERV_FINGERPRINT_CREATE_FAILED 1113
#define LANG_LOG_DIRSERV_FINGERPRINT_RELOAD 1114
#define LANG_LOG_DIRSERV_FINGERPRINT_RELOAD_ERROR_1 1115
#define LANG_LOG_DIRSERV_FINGERPRINT_RELOAD_ERROR_2 1116
#define LANG_LOG_DIRSERV_FINGERPRINT_RELOAD_ERROR_3 1117
#define LANG_LOG_DIRSERV_FINGERPRINT_NICKNAME_TOO_LONG 1118
#define LANG_LOG_DIRSERV_FINGERPRINT_NICKNAME_INVALID 1119
#define LANG_LOG_DIRSERV_FINGERPRINT_INVALID 1120
#define LANG_LOG_DIRSERV_AUTHORIZATION_DENIED_NICKNAME 1121
#define LANG_LOG_DIRSERV_AUTHORIZATION_DENIED_NICKNAME_2 1122
#define LANG_LOG_DIRSERV_DUPLICATE_NICKNAME 1123
#define LANG_LOG_DIRSERV_FINGERPRINT_STATS 1124
#define LANG_LOG_DIRSERV_FINGERPRINT_OK 1125
#define LANG_LOG_DIRSERV_FINGERPRINT_MISMATCH 1126
#define LANG_LOG_DIRSERV_BAD_DIRECTORY 1127
#define LANG_LOG_DIRSERV_BAD_EXIT 1128
#define LANG_LOG_DIRSERV_REJECT_BANNED_ADDR 1129
#define LANG_LOG_DIRSERV_ADDR_VALIDATE_DENIED 1130
#define LANG_LOG_DIRSERV_ROUTER_INVALID_ADDR 1131
#define LANG_LOG_DIRSERV_ROUTER_INVALID_ADDR_2 1132
#define LANG_LOG_DIRSERV_ROUTER_TIME_SKEW 1133
#define LANG_LOG_DIRSERV_ROUTER_TIME_SKEW_2 1134
#define LANG_LOG_DIRSERV_ROUTER_INVALID_ADDR_3 1135
#define LANG_LOG_DIRSERV_ROUTER_DESC_INVALID 1136
#define LANG_LOG_DIRSERV_ROUTER_DESC_IGNORED 1137
#define LANG_LOG_DIRSERV_ROUTER_DESC_ALREADY_ADDED 1138
#define LANG_LOG_DIRSERV__NO_MESSAGE 1139
#define LANG_LOG_DIRSERV_ROUTER_DESC_ADDED 1140
#define LANG_LOG_DIRSERV_EXTRAINFO_INVALID 1141
#define LANG_LOG_DIRSERV_ROUTER_INVALID 1142
#define LANG_LOG_DIRSERV_ROUTER_CHANGE 1143
#define LANG_LOG_DIRSERV__NAMED 1144
#define LANG_LOG_DIRSERV__UNNAMED 1145
#define LANG_LOG_DIRSERV__VALID 1146
#define LANG_LOG_DIRSERV__INVALID 1147
#define LANG_LOG_DIRSERV__GOOD_DIR 1148
#define LANG_LOG_DIRSERV__BAD_DIR 1149
#define LANG_LOG_DIRSERV__GOOD_EXIT 1150
#define LANG_LOG_DIRSERV__BAD_EXIT 1151
#define LANG_LOG_DIRSERV_WRITE_IDENTITY_PKEY_FAILED 1152
#define LANG_LOG_DIRSERV_DIGEST_ERROR 1153
#define LANG_LOG_DIRSERV_BUFFER_OVERFLOW 1154
#define LANG_LOG_DIRSERV_DIR_TOO_OLD 1155
#define LANG_LOG_DIRSERV_DIR_IN_FUTURE 1156
#define LANG_LOG_DIRSERV_DIR_CACHED 1157
#define LANG_LOG_DIRSERV_DIR_CACHE_COMPRESSION_ERROR 1158
#define LANG_LOG_DIRSERV_DIR_COMPRESSION_ERROR 1159
#define LANG_LOG_DIRSERV_NETWORKSTATUS_TOO_OLD 1160
#define LANG_LOG_DIRSERV_CACHE_ERROR 1161
#define LANG_LOG_DIRSERV_CACHE_ENTRY_OK 1162
#define LANG_LOG_DIRSERV_DIR_CREATE_ERROR 1163
#define LANG_LOG_DIRSERV_DIR_CREATE_NEW 1164
#define LANG_LOG_DIRSERV_DIR_INFO_NEW 1165
#define LANG_LOG_DIRSERV_INFO_STABILITY 1166
#define LANG_LOG_DIRSERV__WE_HAVE 1167
#define LANG_LOG_DIRSERV__WE_DONT_HAVE 1168
#define LANG_LOG_DIRSERV_BUFFER_TOO_SMALL 1169
#define LANG_LOG_DIRSERV_ROUTER_VERSION_ERROR 1170
#define LANG_LOG_DIRSERV_ROUTER_DESC_MISSING 1171
#define LANG_LOG_DIRSERV_DESC_MISMATCH 1172
#define LANG_LOG_DIRSERV_LOCAL_HOSTNAME_RESOLVE_FAILED 1173
#define LANG_LOG_DIRSERV_DIGEST_ERROR_2 1174
#define LANG_LOG_DIRSERV_DIGEST_ERROR_3 1175
#define LANG_LOG_DIRSERV_VALID_AFTER_FROM_VOTE 1176
#define LANG_LOG_DIRSERV_WRITE_PUBLIC_KEY_FAILED 1177
#define LANG_LOG_DIRSERV_ROUTER_STATUS_ERROR 1178
#define LANG_LOG_DIRSERV_SIGNATURE_LINE_ERROR 1179
#define LANG_LOG_DIRSERV_SIGNATURE_LINE_ERROR_2 1180
#define LANG_LOG_DIRSERV_FINGERPRINT_ERROR 1181
#define LANG_LOG_DIRSERV_NETWORKSTATUS_HASH_FAILED 1182
#define LANG_LOG_DIRSERV_ROUTER_STATUS_ERROR_2 1183
#define LANG_LOG_DIRSERV_NETWORKSTATUS_ERROR 1184
#define LANG_LOG_DIRSERV_NETWORKSTATUS_ERROR_2 1185
#define LANG_LOG_DIRSERV_NETWORKSTATUS_EMPTY 1186
#define LANG_LOG_DIRSERV_FINGERPRINT_NOT_FOUND 1187
#define LANG_LOG_DIRSERV_ROUTER_REACHABLE 1188
#define LANG_LOG_DIRSERV_ROUTER_REACHABILITY_TEST 1189

#define LANG_LOG_DIRVOTE_NETWORKSTATUS_VOTE_ERROR 1190
#define LANG_LOG_DIRVOTE_NO_VOTES 1191
#define LANG_LOG_DIRVOTE_CONSENSUS_NEW 1192
#define LANG_LOG_DIRVOTE_CONSENSUS_METHOD_NOT_SUPPORTED 1193
#define LANG_LOG_DIRVOTE_ROUTER_NAME_CONFLICT 1194
#define LANG_LOG_DIRVOTE_VOTERS_DISAGREED 1195
#define LANG_LOG_DIRVOTE_NO_SUMMARY_FROM_VOTERS 1196
#define LANG_LOG_DIRVOTE_NO_SUMMARY_FROM_VOTERS_2 1197
#define LANG_LOG_DIRVOTE_BUFFER_TOO_SMALL 1198
#define LANG_LOG_DIRVOTE_BUFFER_TOO_SMALL_2 1199
#define LANG_LOG_DIRVOTE_NETWORKSTATUS_SIGNING_FAILED 1200
#define LANG_LOG_DIRVOTE_NETWORKSTATUS_ERROR 1201
#define LANG_LOG_DIRVOTE_SIGNATURE_NEXT 1202
#define LANG_LOG_DIRVOTE_UNKNOWN_VOTER 1203
#define LANG_LOG_DIRVOTE_DUPLICATE_SIGNATURE_FROM_VOTER 1204
#define LANG_LOG_DIRVOTE_ADDING_NEW_SIGNATURE 1205
#define LANG_LOG_DIRVOTE_NOT_ADDING_SIGNATURE 1206
#define LANG_LOG_DIRVOTE_RECALCULATE_TIMING 1207
#define LANG_LOG_DIRVOTE_SCHEDULING_VOTING 1208
#define LANG_LOG_DIRVOTE_TIME_TO_VOTE 1209
#define LANG_LOG_DIRVOTE_FETCHING_MISSING_VOTES 1210
#define LANG_LOG_DIRVOTE_TIME_TO_COMPUTE_CONSENSUS 1211
#define LANG_LOG_DIRVOTE_FETCHING_MISSING_SIGNATURES 1212
#define LANG_LOG_DIRVOTE_PUBLISHING_CONSENSUS 1213
#define LANG_LOG_DIRVOTE_CERT_NOT_FOUND 1214
#define LANG_LOG_DIRVOTE_CERT_EXPIRED 1215
#define LANG_LOG_DIRVOTE_OWN_VOTE_ERROR 1216
#define LANG_LOG_DIRVOTE_VOTE_POSTED 1217
#define LANG_LOG_DIRVOTE_GET_MISSING_VOTES 1218
#define LANG_LOG_DIRVOTE_ERROR_PARSING_VOTE 1219
#define LANG_LOG_DIRVOTE_KEY_ID_NOT_RECOGNIZED 1220
#define LANG_LOG_DIRVOTE_ADDED_CERT_NOT_FOUND 1221
#define LANG_LOG_DIRVOTE_VOTE_REJECTED 1222
#define LANG_LOG_DIRVOTE_DUPLICATE_VOTE 1223
#define LANG_LOG_DIRVOTE_VOTE_NEWER 1224
#define LANG_LOG_DIRVOTE_INSUFFICIENT_VOTES 1225
#define LANG_LOG_DIRVOTE_CONSENSUS_WITHOUT_CERT 1226
#define LANG_LOG_DIRVOTE_CONSENSUS_GENERATE_FAILED 1227
#define LANG_LOG_DIRVOTE_CONSENSUS_ERROR 1228
#define LANG_LOG_DIRVOTE_SIGNATURE_EXTRACTION_FAILED 1229
#define LANG_LOG_DIRVOTE_ERROR_ADDING_SIGNATURE 1230
#define LANG_LOG_DIRVOTE_SIGNATURES_ADDED 1231
#define LANG_LOG_DIRVOTE_CONSENSUS_OK 1232
#define LANG_LOG_DIRVOTE_SIGNATURES_POSTED 1233
#define LANG_LOG_DIRVOTE_SIGNATURES_TO_ADD 1234
#define LANG_LOG_DIRVOTE_SIGNATURES_ADDED_2 1235
#define LANG_LOG_DIRVOTE_SIGNATURE_PENDING 1236
#define LANG_LOG_DIRVOTE_SIGNATURE_QUEUED 1237
#define LANG_LOG_DIRVOTE_CONSENSUS_INSUFFICIENT_INFO 1238
#define LANG_LOG_DIRVOTE_CONSENSUS_PUBLISH_FAILED 1239
#define LANG_LOG_DIRVOTE_CONSENSUS_PUBLISH_OK 1240
#define LANG_LOG_DIRVOTE_SIGNATURE_PARSING_FAILED 1241
#define LANG_LOG_DIRVOTE_NO_SIGNATURES 1242
#define LANG_LOG_DIRVOTE_SIGNATURES_ADDED_3 1243
#define LANG_LOG_DIRVOTE_SIGNATURES_IGNORED 1244
#define LANG_LOG_DIRVOTE_ERROR_ADDING_SIGNATURES 1245

#define LANG_LOG_DLG_VERSION_TOO_OLD 1246
#define LANG_LOG_DLG_ERROR_LOADING_DLL 1247
#define LANG_LOG_DLG_WELCOME 1248
#define LANG_LOG_DLG_ADDRESSMAP_ADDED 1249
#define LANG_LOG_DLG_ADDRESSMAP_REMOVED 1250
#define LANG_LOG_DLG_NO_EXIT_FOUND 1251
#define LANG_LOG_DLG_ADDRESSMAP_ENTRY_NOT_FOUND 1252

#define LANG_LOG_DNS_RESOLVE_REQUESTED 1253
#define LANG_LOG_DNS_RESOLVE_TIMEOUT 1254
#define LANG_LOG_DNS_ENTRY_EXPIRED 1255
#define LANG_LOG_DNS_RESOLVE_TIMEOUT_2 1256
#define LANG_LOG_DNS_REMOVED_SOMETHING_ELSE 1257
#define LANG_LOG_DNS_INVALID_ADDRESS 1258
#define LANG_LOG_DNS_INVALID_ADDRESS_2 1259
#define LANG_LOG_DNS_INVALID_ADDRESS_3 1260
#define LANG_LOG_DNS_RESOLVE_PENDING 1261
#define LANG_LOG_DNS_CACHED_ANSWER_FOUND 1262
#define LANG_LOG_DNS_CACHED_ERROR_FOUND 1263
#define LANG_LOG_DNS_DONE_STILL_IN_CACHE 1264
#define LANG_LOG_DNS_LAUNCHING 1265
#define LANG_LOG_DNS_DROPPING_ADDRESS 1266
#define LANG_LOG_DNS_CONNECTION_REMOVED 1267
#define LANG_LOG_DNS_CONNECTION_REMOVED_2 1268
#define LANG_LOG_DNS_CANCEL_PENDING 1269
#define LANG_LOG_DNS_CANCEL_PENDING_2 1270
#define LANG_LOG_DNS_CANCEL_PENDING_3 1271
#define LANG_LOG_DNS_CANCEL_PENDING_4 1272
#define LANG_LOG_DNS_RESOLVED_UNASKED_ADDRESS 1273
#define LANG_LOG_DNS_RESOLVED_TWICE 1274
#define LANG_LOG_DNS_ERROR_REMOVING_FROM_CACHE 1275
#define LANG_LOG_DNS_ERROR_CONVERTING_OUTBOUNDBIND_TO_SOCKADDR 1276
#define LANG_LOG_DNS_RESOLVER_CONFIG_ERROR 1277
#define LANG_LOG_DNS_NO_CHANGE 1278
#define LANG_LOG_DNS_RESOLVER_CONFIG_PARSE 1279
#define LANG_LOG_DNS_RESOLVER_CONFIG_ERROR_2 1280
#define LANG_LOG_DNS_NAMESERVERS_NOT_FOUND 1281
#define LANG_LOG_DNS_NAMESERVERS_CONFIG_ERROR 1282
#define LANG_LOG_DNS_NAMESERVERS_NOT_FOUND_2 1283
#define LANG_LOG_DNS_ISP_HIJACKED_ADDRESS 1284
#define LANG_LOG_DNS_RESOLVE_OK 1285
#define LANG_LOG_DNS_RESOLVE_NON_IPV4 1286
#define LANG_LOG_DNS_RESOLVE_FAILED 1287
#define LANG_LOG_DNS_RESOLVE_WITHOUT_CONFIG 1288
#define LANG_LOG_DNS_LAUNCHING_REQUEST 1289
#define LANG_LOG_DNS_LAUNCHING_REQUEST_2 1290
#define LANG_LOG_DNS_IN_ADDR_ARPA 1291
#define LANG_LOG_DNS_ADDRESS_REJECTED 1292
#define LANG_LOG_DNS_ISP_IS_HIJACKING 1293
#define LANG_LOG_DNS_BROKEN_DNS 1294
#define LANG_LOG_DNS_ISP_IS_HIJACKING_2 1295
#define LANG_LOG_DNS__BAD_ADDRESS 1296
#define LANG_LOG_DNS__BAD_ADDRESSES 1297
#define LANG_LOG_DNS_TESTING_DNS 1298
#define LANG_LOG_DNS_TESTING_DNS_2 1299
#define LANG_LOG_DNS_TEST_ADDRESS_REJECTED 1300
#define LANG_LOG_DNS_TESTING_DNS_3 1301
#define LANG_LOG_DNS_TEST_TIMER_ERROR 1302
#define LANG_LOG_DNS_BAD_REP 1303

#define LANG_LOG_DNSSERV_REQUEST_NEW 1304
#define LANG_LOG_DNSSERV_REQUEST_GET_FAILED 1305
#define LANG_LOG_DNSSERV_REQUEST_INVALID 1306
#define LANG_LOG_DNSSERV_REQUEST_DIALLOWED 1307
#define LANG_LOG_DNSSERV_REQUEST_EMPTY 1308
#define LANG_LOG_DNSSERV_REQUEST_TOO_MANY_ENTRIES 1309
#define LANG_LOG_DNSSERV_REQUEST_NOT_SUPPORTED 1310
#define LANG_LOG_DNSSERV_SERVER_FAILED 1311
#define LANG_LOG_DNSSERV_REQUEST_PASSING 1312
#define LANG_LOG_DNSSERV_REQUEST_PASSED 1313
#define LANG_LOG_DNSSERV_SERVER_FAILED_2 1314
#define LANG_LOG_DNSSERV_GOT_IPV6 1315

#define LANG_LOG_EVENTDNS_TIMER_ERROR 1316
#define LANG_LOG_EVENTDNS_TIMER_ERROR_2 1317
#define LANG_LOG_EVENTDNS_TIMER_ERROR_3 1318
#define LANG_LOG_EVENTDNS_NS_FAILED 1319
#define LANG_LOG_EVENTDNS_NS_FAILED_2 1320
#define LANG_LOG_EVENTDNS_NS_IS_BACK 1321
#define LANG_LOG_EVENTDNS_REMOVING_TIMEOUT 1322
#define LANG_LOG_EVENTDNS_SERVERFAILED 1323
#define LANG_LOG_EVENTDNS_ADDRESS_MISMATCH 1324
#define LANG_LOG_EVENTDNS_REQUEST_READ_ERROR 1325
#define LANG_LOG_EVENTDNS_RESPONSE_WRITE_ERROR 1326
#define LANG_LOG_EVENTDNS_EVENT_ADD_ERROR 1327
#define LANG_LOG_EVENTDNS_EVENT_ADD_ERROR_2 1328
#define LANG_LOG_EVENTDNS_REQUEST_TIMEOUT 1329
#define LANG_LOG_EVENTDNS_REQUEST_SET_TIMEOUT 1330
#define LANG_LOG_EVENTDNS_SENDING_PROBE 1331
#define LANG_LOG_EVENTDNS_NS_DUPLICATE 1332
#define LANG_LOG_EVENTDNS_ADDRLEN_TOO_LONG 1333
#define LANG_LOG_EVENTDNS_BIND_ERROR 1334
#define LANG_LOG_EVENTDNS_NS_CONNECT_ERROR 1335
#define LANG_LOG_EVENTDNS_NS_EVENT_ERROR 1336
#define LANG_LOG_EVENTDNS_NS_ADDED 1337
#define LANG_LOG_EVENTDNS_NS_NOT_ADDED 1338
#define LANG_LOG_EVENTDNS_NS_NOT_ADDED_2 1339
#define LANG_LOG_EVENTDNS_NS_ADDING 1340
#define LANG_LOG_EVENTDNS_NS_ERROR 1341
#define LANG_LOG_EVENTDNS_NS_BUFFER_TOO_SMALL 1342
#define LANG_LOG_EVENTDNS_NS_BUFFER_TOO_SMALL_2 1343
#define LANG_LOG_EVENTDNS_NS_PORT_OUT_OF_RANGE 1344
#define LANG_LOG_EVENTDNS_INET_PTON_FAILED 1345
#define LANG_LOG_EVENTDNS_RESOLVE_REQUEST 1346
#define LANG_LOG_EVENTDNS_REVDNS_REQUEST 1347
#define LANG_LOG_EVENTDNS_RAW_QUERY 1348
#define LANG_LOG_EVENTDNS_NOW_TRYING 1349
#define LANG_LOG_EVENTDNS_SETTING_NDOTS 1350
#define LANG_LOG_EVENTDNS_SETTING_TIMEOUT 1351
#define LANG_LOG_EVENTDNS_SETTING_TIMEOUT_2 1352
#define LANG_LOG_EVENTDNS_SETTING_INFLIGHT 1353
#define LANG_LOG_EVENTDNS_SETTING_RETRIES 1354
#define LANG_LOG_EVENTDNS_SETTING_RANDOMIZE_CASE 1355
#define LANG_LOG_EVENTDNS_RESOLV_CONF_PARSE 1356
#define LANG_LOG_EVENTDNS_NO_IPHLPAPI_DLL 1357
#define LANG_LOG_EVENTDNS_IPHLPAPI_WITHOUT_API 1358
#define LANG_LOG_EVENTDNS_IPHLPAPI_CALL_FAILED 1359
#define LANG_LOG_EVENTDNS_NO_NS_ADDED 1360
#define LANG_LOG_EVENTDNS_FOUND_NS 1361
#define LANG_LOG_EVENTDNS_NO_NS_FOUND 1362
#define LANG_LOG_EVENTDNS_NO_NS_FOUND_2 1363
#define LANG_LOG_EVENTDNS_REGISTRY_ERROR 1364
#define LANG_LOG_EVENTDNS_REGISTRY_ERROR_2 1365
#define LANG_LOG_EVENTDNS_REGISTRY_ERROR_3 1366

#define LANG_LOG_HIBERNATE_ACCOUNTINGSTART_ERROR 1367
#define LANG_LOG_HIBERNATE_UNRECOGNIZED_UNIT 1368
#define LANG_LOG_HIBERNATE_ACCOUNTING_DAY_ERROR 1369
#define LANG_LOG_HIBERNATE_ACCOUNTING_MONTH_ERROR 1370
#define LANG_LOG_HIBERNATE_ACCOUNTING_UNIT_ERROR 1371
#define LANG_LOG_HIBERNATE__ARGUMENT 1372
#define LANG_LOG_HIBERNATE__ARGUMENTS 1373
#define LANG_LOG_HIBERNATE_ACCOUNTING_HOUR_ERROR 1374
#define LANG_LOG_HIBERNATE_ACCOUNTING_TIME_ERROR 1375
#define LANG_LOG_HIBERNATE_ACCOUNTING_MINUTE_ERROR 1376
#define LANG_LOG_HIBERNATE_ACCOUNTING_START 1377
#define LANG_LOG_HIBERNATE_ACCOUNTING_CONTINUE 1378
#define LANG_LOG_HIBERNATE_ACCOUNTING_MISMATCHED_INTERVAL 1379
#define LANG_LOG_HIBERNATE_BW_HIST_WRITE_ERROR 1380
#define LANG_LOG_HIBERNATE_KEYS_INIT_ERROR 1381
#define LANG_LOG_HIBERNATE_CONFIGURED 1382
#define LANG_LOG_HIBERNATE_CONFIGURED_2 1383
#define LANG_LOG_HIBERNATE__WAKE_UP_TIME_IS 1384
#define LANG_LOG_HIBERNATE__WAKE_UP_TIME_WAS 1385
#define LANG_LOG_HIBERNATE__WE_EXPECT 1386
#define LANG_LOG_HIBERNATE__WE_EXPECTED 1387
#define LANG_LOG_HIBERNATE_BW_HIST_READ 1388
#define LANG_LOG_HIBERNATE_BW_HIST_READ_OK 1389
#define LANG_LOG_HIBERNATE_SIGINT_RECEIVED_A 1390
#define LANG_LOG_HIBERNATE_SIGINT_RECEIVED_B 1391
#define LANG_LOG_HIBERNATE_SIGINT_RECEIVED_C 1392
#define LANG_LOG_HIBERNATE_CLOSING_LISTENER 1393
#define LANG_LOG_HIBERNATE_INTERRUPT 1394
#define LANG_LOG_HIBERNATE_PERIOD_ENDED 1395
#define LANG_LOG_HIBERNATE_PERIOD_STARTED 1396
#define LANG_LOG_HIBERNATE_CLOSING_CONN 1397
#define LANG_LOG_HIBERNATE_ACCOUNTING_PERIOD_ENDED 1398
#define LANG_LOG_HIBERNATE_ACCOUNTING_PERIOD_ENDED_2 1399
#define LANG_LOG_HIBERNATE_CLEAN_SHUTDOWN 1400
#define LANG_LOG_HIBERNATE_BW_LIMIT_REACHED 1401
#define LANG_LOG_HIBERNATE_STARTED 1402

#define LANG_LOG_MAIN_CONNECTION_ADD 1403
#define LANG_LOG_MAIN_CONNECTION_REMOVE 1404
#define LANG_LOG_MAIN_LIBEVENT_ERROR 1405
#define LANG_LOG_MAIN_LIBEVENT_ERROR_2 1406
#define LANG_LOG_MAIN_LIBEVENT_ERROR_3 1407
#define LANG_LOG_MAIN_LIBEVENT_ERROR_4 1408
#define LANG_LOG_MAIN_READ_EVENT 1409
#define LANG_LOG_MAIN_READ_ERROR 1410
#define LANG_LOG_MAIN_WRITE_EVENT 1411
#define LANG_LOG_MAIN_WRITE_ERROR 1412
#define LANG_LOG_MAIN_CONN_CLEANUP 1413
#define LANG_LOG_MAIN_CONN_FLUSH 1414
#define LANG_LOG_MAIN_CONN_FLUSH_2 1415
#define LANG_LOG_MAIN_CONN_FLUSH_3 1416
#define LANG_LOG_MAIN_WE_STALLED_TOO_MUCH 1417
#define LANG_LOG_MAIN_NETDOWN 1418
#define LANG_LOG_MAIN_DIR_INFO 1419
#define LANG_LOG_MAIN_DIR_CONN_EXPIRE 1420
#define LANG_LOG_MAIN_DIR_INFO_FROM_WEDGED_SERVER 1421
#define LANG_LOG_MAIN_EXPIRE_OLD_CONN 1422
#define LANG_LOG_MAIN_EXPIRE_NON_OPEN_CONN 1423
#define LANG_LOG_MAIN_EXPIRE_NON_USED_CONN 1424
#define LANG_LOG_MAIN_EXPIRE_NON_USED_CONN_2 1425
#define LANG_LOG_MAIN_EXPIRE_STUCK_CONN 1426
#define LANG_LOG_MAIN_SEND_KEEPALIVE 1427
#define LANG_LOG_MAIN_NEWNYM 1428
#define LANG_LOG_MAIN_ROTATING_ONION_KEY 1429
#define LANG_LOG_MAIN_ROUTER_DESC_REBUILD_ERROR 1430
#define LANG_LOG_MAIN_ROTATING_TLS_CONTEXT 1431
#define LANG_LOG_MAIN_TLS_REINIT_ERROR 1432
#define LANG_LOG_MAIN_MTBF_WRITE_ERROR 1433
#define LANG_LOG_MAIN_OR_PORT_UNREACHABLE 1434
#define LANG_LOG_MAIN_DIR_PORT_UNREACHABLE 1435
#define LANG_LOG_MAIN_LIBEVENT_TOO_MANY_ERRORS 1436
#define LANG_LOG_MAIN_SIGHUP 1437
#define LANG_LOG_MAIN_CONFIG_READ_ERROR 1438
#define LANG_LOG_MAIN_CONFIG_NOT_RELOADED 1439
#define LANG_LOG_MAIN_FINGERPRINTS_RELOAD_ERROR 1440
#define LANG_LOG_MAIN_UNRECOGNIZED_SIGNAL 1441
#define LANG_LOG_MAIN_SIGTERM 1442
#define LANG_LOG_MAIN_SIGINT 1443
#define LANG_LOG_MAIN_SIGPIPE 1444
#define LANG_LOG_MAIN_SIGUSR2 1445
#define LANG_LOG_MAIN_CONFIG_ERROR 1446
#define LANG_LOG_MAIN_SIGNEWNYM 1447
#define LANG_LOG_MAIN_REPHIST_STATS 1448
#define LANG_LOG_MAIN_DUMPING_STATS 1449
#define LANG_LOG_MAIN_STATS_CONN 1450
#define LANG_LOG_MAIN_STATS_CONN_2 1451
#define LANG_LOG_MAIN_STATS_CONN_3 1452
#define LANG_LOG_MAIN_STATS_CONN_4 1453
#define LANG_LOG_MAIN_STATS_CONN_5 1454
#define LANG_LOG_MAIN_CELL_STATS 1455
#define LANG_LOG_MAIN_CELL_STATS_2 1456
#define LANG_LOG_MAIN_CELL_STATS_3 1457
#define LANG_LOG_MAIN_BW_STATS 1458
#define LANG_LOG_MAIN_BW_STATS_2 1459
#define LANG_LOG_MAIN_MEM_STATS 1460
#define LANG_LOG_MAIN_CLIENT_KEY 1461
#define LANG_LOG_MAIN_INIT_KEYS_ERROR 1462
#define LANG_LOG_MAIN_MISSING_KEY 1463
#define LANG_LOG_MAIN_NET_INIT_ERROR 1464
#define LANG_LOG_MAIN_OPENSSL_INIT_ERROR 1465
#define LANG_LOG_MAIN_RANDOM_OS 1466
#define LANG_LOG_MAIN_NEW_TIMESTAMP_DELTA 1467
#define LANG_LOG_MAIN_DNS_INIT_ERROR 1468
#define LANG_LOG_MAIN_KEYS_INIT_ERROR 1469
#define LANG_LOG_MAIN_LIBEVENT_CALL_FAILED 1470
#define LANG_LOG_MAIN_LIBEVENT_CALL_FAILED_2 1471
#define LANG_LOG_MAIN_LIBEVENT_CALL_FAILED_3 1472

#define LANG_LOG_NETWORKSTATUS_UNEXPECTED_FILE_NAME 1473
#define LANG_LOG_NETWORKSTATUS_LOAD_ERROR 1474
#define LANG_LOG_NETWORKSTATUS_LOAD_ERROR_2 1475
#define LANG_LOG_NETWORKSTATUS_LOADED 1476
#define LANG_LOG_NETWORKSTATUS_BAD_SIGNATURE 1477
#define LANG_LOG_NETWORKSTATUS_UNRECOGNIZED_AUTHORITY 1478
#define LANG_LOG_NETWORKSTATUS_NEED_CERT 1479
#define LANG_LOG_NETWORKSTATUS_CONSENSUS_WITHOUT_AUTHORITY 1480
#define LANG_LOG_NETWORKSTATUS_STATS 1481
#define LANG_LOG_NETWORKSTATUS_ERROR_WRITING_NETWORKSTATUS 1482
#define LANG_LOG_NETWORKSTATUS_ERROR_PARSING_NETWORKSTATUS 1483
#define LANG_LOG_NETWORKSTATUS_INVALID_SIGNATURE 1484
#define LANG_LOG_NETWORKSTATUS_TIME_SKEW 1485
#define LANG_LOG_NETWORKSTATUS_TIME_SKEW_2 1486
#define LANG_LOG_NETWORKSTATUS_UNREQUESTED_FINGERPRINT 1487
#define LANG_LOG_NETWORKSTATUS_UNRECOGNIZED_AUTHORITY_2 1488
#define LANG_LOG_NETWORKSTATUS_ALREADY_HAVE 1489
#define LANG_LOG_NETWORKSTATUS_ALREADY_HAVE_2 1490
#define LANG_LOG_NETWORKSTATUS_ALREADY_HAVE_3 1491
#define LANG_LOG_NETWORKSTATUS_ALREADY_HAVE_4 1492
#define LANG_LOG_NETWORKSTATUS_SETTING_NEW 1493
#define LANG_LOG_NETWORKSTATUS__CACHED_FROM 1494
#define LANG_LOG_NETWORKSTATUS__DOWNLOADED_FROM 1495
#define LANG_LOG_NETWORKSTATUS__GENERATED_FOR 1496
#define LANG_LOG_NETWORKSTATUS_TOO_OLD 1497
#define LANG_LOG_NETWORKSTATUS_UNNAMED_SERVER 1498
#define LANG_LOG_NETWORKSTATUS_MULTIPLE_MATCHES_FOR_NICKNAME 1499
#define LANG_LOG_NETWORKSTATUS_EXIT_TO_NICK 1500
#define LANG_LOG_NETWORKSTATUS_DOWNLOADING 1501
#define LANG_LOG_NETWORKSTATUS_HAVE_LIVE_CONSENSUS 1502
#define LANG_LOG_NETWORKSTATUS__LC_WILL_BE 1503
#define LANG_LOG_NETWORKSTATUS__LC_WAS 1504
#define LANG_LOG_NETWORKSTATUS_NO_LIVE_CONSENSUS 1505
#define LANG_LOG_NETWORKSTATUS_DIR_FETCHES_DELAYED 1506
#define LANG_LOG_NETWORKSTATUS_PARSE_ERROR 1507
#define LANG_LOG_NETWORKSTATUS_OBSOLETE 1508
#define LANG_LOG_NETWORKSTATUS_NOT_ENOUGH_CERTS 1509
#define LANG_LOG_NETWORKSTATUS_NOT_ENOUGH_SIGNATURES 1510
#define LANG_LOG_NETWORKSTATUS_VERSION_OK 1511
#define LANG_LOG_NETWORKSTATUS_NO_VERSIONS 1512
#define LANG_LOG_NETWORKSTATUS_VERSION_TOO_NEW 1513
#define LANG_LOG_NETWORKSTATUS_VERSION_TOO_OLD 1514
#define LANG_LOG_NETWORKSTATUS__OBSOLETE 1515
#define LANG_LOG_NETWORKSTATUS__NOT_RECOMMENDED 1516
#define LANG_LOG_NETWORKSTATUS_UNRECOGNIZED_PURPOSE 1517

#define LANG_LOG_NTMAIN_ADVAPI32_LOAD_ERROR 1518
#define LANG_LOG_NTMAIN_ADVAPI32_WITHOUT_API 1519
#define LANG_LOG_NTMAIN_SHUTDOWN 1520
#define LANG_LOG_NTMAIN_CMDLINE_UNSUPPORTED_COMMAND 1521
#define LANG_LOG_NTMAIN_INTERNAL_ERROR 1522

#define LANG_LOG_ONION_COMPUTER_TOO_SLOW 1523
#define LANG_LOG_ONION_REQUEST_TOO_OLD 1524
#define LANG_LOG_ONION_CIRC_NOT_IN_LIST 1525
#define LANG_LOG_ONION_DECRYPT_FAILED 1526
#define LANG_LOG_ONION_UNEXPECTED_ONIONSKIN_LENGTH 1527
#define LANG_LOG_ONION_CRYPTO_DH_GET_PUBLIC_FAILED 1528
#define LANG_LOG_ONION_CRYPTO_DH_GET_SECRET_FAILED 1529
#define LANG_LOG_ONION_DIGEST_MISMATCH 1530
#define LANG_LOG_ONION_DIGEST_MISMATCH_2 1531

#define LANG_LOG_POLICIES_NEW_ENTRY 1532
#define LANG_LOG_POLICIES_MALFORMED_POLICY 1533
#define LANG_LOG_POLICIES_REACHABLEADDRESSES_PARSE_ERROR 1534
#define LANG_LOG_POLICIES_UNEXPECTED_RESULT 1535
#define LANG_LOG_POLICIES_PARSE_ERROR 1536
#define LANG_LOG_POLICIES_REMOVE_EXIT_POLICY 1537
#define LANG_LOG_POLICIES_REMOVE_EXIT_POLICY_2 1538
#define LANG_LOG_POLICIES_SHUTDOWN 1539

#define LANG_LOG_REASONS_END_CELL_WITH_LENGTH_0 1540
#define LANG_LOG_REASONS_NOT_RECOGNIZED 1541
#define LANG_LOG_REASONS_NOT_RECOGNIZED_2 1542
#define LANG_LOG_REASONS_ERRNO_NOT_RECOGNIZED 1543
#define LANG_LOG_REASONS_NOT_RECOGNIZED_3 1544
#define LANG_LOG_REASONS_ERRNO_NOT_RECOGNIZED_2 1545
#define LANG_LOG_REASONS_NOT_RECOGNIZED_4 1546
#define LANG_LOG_REASONS__MALFORMED 1547
#define LANG_LOG_REASONS__MISC_ERROR 1548
#define LANG_LOG_REASONS__RESOLVE_FAILED 1549
#define LANG_LOG_REASONS__CONNECTION_REFUSED 1550
#define LANG_LOG_REASONS__EXIT_POLICY_FAILED 1551
#define LANG_LOG_REASONS__DESTROYED 1552
#define LANG_LOG_REASONS__CLOSED_NORMALLY 1553
#define LANG_LOG_REASONS__TIMEOUT 1554
#define LANG_LOG_REASONS__HIBERNATING 1555
#define LANG_LOG_REASONS__INTERNAL_ERROR 1556
#define LANG_LOG_REASONS__RESOURCELIMIT 1557
#define LANG_LOG_REASONS__CONNRESET 1558
#define LANG_LOG_REASONS__PROTOCOL 1559
#define LANG_LOG_REASONS__NOTDIRECTORY 1560
#define LANG_LOG_REASONS__UNKNOWN 1561

#define LANG_LOG_RELAY_RELAY_ENCRYPTION_ERROR 1562
#define LANG_LOG_RELAY_RELAY_ENCRYPTION_ERROR_2 1563
#define LANG_LOG_RELAY_SENDING_AWAY_FROM_ORIGIN 1564
#define LANG_LOG_RELAY_SENDING_TO_ORIGIN 1565
#define LANG_LOG_RELAY_CEPRC_FAILED 1566
#define LANG_LOG_RELAY_CEPRC_FAILED_2 1567
#define LANG_LOG_RELAY_UNRECOGNIZED_CELL 1568
#define LANG_LOG_RELAY_REND_ERROR 1569
#define LANG_LOG_RELAY_UNRECOGNIZED_CELL_2 1570
#define LANG_LOG_RELAY_UNRECOGNIZED_CELL_3 1571
#define LANG_LOG_RELAY_RELAY_BEFORE_CREATE 1572
#define LANG_LOG_RELAY_UNRECOGNIZED_CELL_4 1573
#define LANG_LOG_RELAY_N_CONN_NULL 1574
#define LANG_LOG_RELAY_CRYPTING_A_LAYER 1575
#define LANG_LOG_RELAY_INCOMING_AT_ORIGIN 1576
#define LANG_LOG_RELAY_FOUND_CONN 1577
#define LANG_LOG_RELAY_DELIVERING_CELL 1578
#define LANG_LOG_RELAY__FORWARD 1579
#define LANG_LOG_RELAY__BACKWARD 1580
#define LANG_LOG_RELAY_SENDING_RELAY_EARLY 1581
#define LANG_LOG_RELAY_EXTEND_WITHOUT_RELAY_EARLY 1582
#define LANG_LOG_RELAY_CPRC_FAILED 1583
#define LANG_LOG_RELAY_SEND_ON_CONN_MARKED_FOR_CLOSE 1584
#define LANG_LOG_RELAY_NO_CIRC 1585
#define LANG_LOG_RELAY_ADDRESS_REFUSED 1586
#define LANG_LOG_RELAY_RESOLVED_TO_0_0_0_0 1587
#define LANG_LOG_RELAY_RESOLVED_TO_INTERNAL 1588
#define LANG_LOG_RELAY_EXIT_TOO_RESTRICTIVE 1589
#define LANG_LOG_RELAY_TIMEOUT 1590
#define LANG_LOG_RELAY_TOO_MANY_RETRIES 1591
#define LANG_LOG_RELAY_END_BEFORE_CONNECT 1592
#define LANG_LOG_RELAY_CONNECTED_NOT_EXPECTED 1593
#define LANG_LOG_RELAY_CONNECTED_RECEIVED 1594
#define LANG_LOG_RELAY_WRONG_IP 1595
#define LANG_LOG_RELAY_CONSIDERING 1596
#define LANG_LOG_RELAY_IT_IS 1597
#define LANG_LOG_RELAY_RESOLVED_NOT_EXPECTED 1598
#define LANG_LOG_RELAY_MALFORMED_RESOLVED 1599
#define LANG_LOG_RELAY_RESOLVE_WITH_ANSWER 1600
#define LANG_LOG_RELAY_UNEXPECTED_COMMAND 1601
#define LANG_LOG_RELAY_RELAY_CELLS_SEEN 1602
#define LANG_LOG_RELAY_CELL_FIELD_TOO_LONG 1603
#define LANG_LOG_RELAY_REQUEST_UNSUPPORTED_AT_AP 1604
#define LANG_LOG_RELAY_REQUEST_TO_HS_FROM_INTERMEDIARY_NODE 1605
#define LANG_LOG_RELAY_UNKNOWN_STREAM 1606
#define LANG_LOG_RELAY_DELIVER_WINDOW_BELOW_0 1607
#define LANG_LOG_RELAY_DELIVER_WINDOW_BELOW_0_2 1608
#define LANG_LOG_RELAY_DELIVER_WINDOW 1609
#define LANG_LOG_RELAY_DATA_CELL_DROPPED 1610
#define LANG_LOG_RELAY_END_CELL_DROPPED 1611
#define LANG_LOG_RELAY_END_CELL 1612
#define LANG_LOG_RELAY_NO_SOCKS_ANSWER 1613
#define LANG_LOG_RELAY_EXTEND_FOR_NON_ZERO_STREAM 1614
#define LANG_LOG_RELAY_EXTENDED_AT_ORIGIN 1615
#define LANG_LOG_RELAY_EXTENDED_CELL 1616
#define LANG_LOG_RELAY_CIRCUIT_FINISH_HANDSHAKE_FAILED 1617
#define LANG_LOG_RELAY_CIRCUIT_SEND_NEXT_ONION_SKIN_FAILED 1618
#define LANG_LOG_RELAY_TRUNCATE_AT_ORIGIN 1619
#define LANG_LOG_RELAY_TRUNCATE_PROCESSED 1620
#define LANG_LOG_RELAY_TRUNCATED_AT_NON_ORIGIN 1621
#define LANG_LOG_RELAY_CONNECTED_WHILE_OPEN 1622
#define LANG_LOG_RELAY_CONNECTED_WITH_NO_CONN_ATTACHED 1623
#define LANG_LOG_RELAY_CIRC_LEVEL_SENDME_AT_ORIGIN 1624
#define LANG_LOG_RELAY_CIRC_LEVEL_SENDME_AT_NON_ORIGIN 1625
#define LANG_LOG_RELAY_STREAM_LEVEL_SENDME 1626
#define LANG_LOG_RELAY_RESOLVE_UNSUPPORTED_AT_AP 1627
#define LANG_LOG_RELAY_RESOLVE_FOR_KNOWN_STREAM 1628
#define LANG_LOG_RELAY_RESOLVE_DROPPED 1629
#define LANG_LOG_RELAY_RESOLVED_WHILE_OPEN 1630
#define LANG_LOG_RELAY_RESOLVED_WITHOUT_CONN_ATTACHED 1631
#define LANG_LOG_RELAY_UNKNOWN_COMMAND 1632
#define LANG_LOG_RELAY_CONN_ALREADY_MARKED_FOR_CLOSE 1633
#define LANG_LOG_RELAY_CONN_WITHOUT_CIRCUIT 1634
#define LANG_LOG_RELAY_CALLED_WITH_PACKAGE_WINDOW 1635
#define LANG_LOG_RELAY_PACKAGING 1636
#define LANG_LOG_RELAY_PACKAGE_WINDOW_REACHED_0 1637
#define LANG_LOG_RELAY_PACKAGE_WINDOW_IS_NOW 1638
#define LANG_LOG_RELAY_CONN_WITHOUT_CIRC 1639
#define LANG_LOG_RELAY_QUEUING_STREAM_SENDME 1640
#define LANG_LOG_RELAY_CONNECTION_EDGE_SEND_COMMAND_FAILED 1641
#define LANG_LOG_RELAY_RESUMING 1642
#define LANG_LOG_RELAY_CONSIDERING_PACKAGE_WINDOW 1643
#define LANG_LOG_RELAY_NOT_AT_ORIGIN 1644
#define LANG_LOG_RELAY_CONSIDERING_PACKAGE_WINDOW_2 1645
#define LANG_LOG_RELAY_AT_ORIGIN 1646
#define LANG_LOG_RELAY_QUEUING_CIRCUIT_SENDME 1647
#define LANG_LOG_RELAY_RELAY_SEND_COMMAND_FROM_EDGE_FAILED 1648
#define LANG_LOG_RELAY_CELL_USAGE 1649
#define LANG_LOG_RELAY_MADE_A_CIRCUIT_INACTIVE 1650
#define LANG_LOG_RELAY_MADE_A_CIRCUIT_ACTIVE 1651
#define LANG_LOG_RELAY_PRIMED_A_BUFFER 1652

#define LANG_LOG_RENDCLIENT_INTROCIRC_IS_OPEN 1653
#define LANG_LOG_RENDCLIENT_SENDING_ESTABLISH_REND 1654
#define LANG_LOG_RENDCLIENT_INTERNAL_ERROR 1655
#define LANG_LOG_RENDCLIENT_COULDNT_SEND_ESTABLISH_REND 1656
#define LANG_LOG_RENDCLIENT_QUERY_WITHOUT_VALID_REND_DESC 1657
#define LANG_LOG_RENDCLIENT_BOTH_V0_AND_V2 1658
#define LANG_LOG_RENDCLIENT_INTERNAL_ERROR_2 1659
#define LANG_LOG_RENDCLIENT_INTERNAL_ERROR_3 1660
#define LANG_LOG_RENDCLIENT_INTERNAL_ERROR_4 1661
#define LANG_LOG_RENDCLIENT_INTERNAL_ERROR_5 1662
#define LANG_LOG_RENDCLIENT_INTERNAL_ERROR_6 1663
#define LANG_LOG_RENDCLIENT_INTERNAL_ERROR_7 1664
#define LANG_LOG_RENDCLIENT_SENDING_INTRODUCE1 1665
#define LANG_LOG_RENDCLIENT_COULDNT_SEND_INTRODUCE1 1666
#define LANG_LOG_RENDCLIENT_RENDCIRC_IS_OPEN 1667
#define LANG_LOG_RENDCLIENT_REND_INTRODUCE_ACK_UNEXPECTED 1668
#define LANG_LOG_RENDCLIENT_RECEIVED_ACK 1669
#define LANG_LOG_RENDCLIENT_NO_REND_CIRC_FOUND 1670
#define LANG_LOG_RENDCLIENT_NO_INTRO_POINTS_LEFT 1671
#define LANG_LOG_RENDCLIENT_RE_EXTENDING_CIRC 1672
#define LANG_LOG_RENDCLIENT_BUILDING_NEW_INTRO_CIRC 1673
#define LANG_LOG_RENDCLIENT_BUILDING_INTRO_CIRC_FAILED 1674
#define LANG_LOG_RENDCLIENT_NO_HS_DIRS 1675
#define LANG_LOG_RENDCLIENT_ERROR_ENCODING_COOKIE 1676
#define LANG_LOG_RENDCLIENT_FETCHING_V2_DESC 1677
#define LANG_LOG_RENDCLIENT_FETCHING_REND_DESC 1678
#define LANG_LOG_RENDCLIENT_FETCHING_IN_PROGRESS 1679
#define LANG_LOG_RENDCLIENT_UNEXPECTED_ONION_ADDRESS 1680
#define LANG_LOG_RENDCLIENT_ALREADY_HAVE_DESC 1681
#define LANG_LOG_RENDCLIENT_FETCHING_V2_DESC_2 1682
#define LANG_LOG_RENDCLIENT_INTERNAL_ERROR_8 1683
#define LANG_LOG_RENDCLIENT_MALFORMED_SERVICE_ID 1684
#define LANG_LOG_RENDCLIENT_RE_FETCHING_DESC 1685
#define LANG_LOG_RENDCLIENT_RE_FETCHING_DESC_2 1686
#define LANG_LOG_RENDCLIENT_OPTIONS 1687
#define LANG_LOG_RENDCLIENT_UNEXPECTED_REND_ACK 1688
#define LANG_LOG_RENDCLIENT_REND_ACK 1689
#define LANG_LOG_RENDCLIENT_UNEXPECTED_REND2_CELL 1690
#define LANG_LOG_RENDCLIENT_INCORRECT_REND2_CELL_LENGTH 1691
#define LANG_LOG_RENDCLIENT_REND2_FROM_HS 1692
#define LANG_LOG_RENDCLIENT_DH_HANDSHAKE_ERROR 1693
#define LANG_LOG_RENDCLIENT_INCORRECT_DIGEST 1694
#define LANG_LOG_RENDCLIENT_REND_DESC_OK 1695
#define LANG_LOG_RENDCLIENT_REND_FAILED 1696
#define LANG_LOG_RENDCLIENT_HS_UNAVAILABLE 1697
#define LANG_LOG_RENDCLIENT_UNKNOWN_ROUTER 1698
#define LANG_LOG_RENDCLIENT_CONFIG_LINE_ERROR 1699
#define LANG_LOG_RENDCLIENT_WRONG_ONION_ADDR_FORMAT 1700
#define LANG_LOG_RENDCLIENT_WRONG_AUTH_COOKIE_LENGTH 1701
#define LANG_LOG_RENDCLIENT_DECODING_COOKIE_FAILED 1702
#define LANG_LOG_RENDCLIENT_UNKNOWN_AUTH_TYPE 1703
#define LANG_LOG_RENDCLIENT_DUPLICATE_AUTH 1704

#define LANG_LOG_RENDCOMMON_ILLEGAL_SERVICE_ID 1705
#define LANG_LOG_RENDCOMMON_REPLICA_OUT_OF_RANGE 1706
#define LANG_LOG_RENDCOMMON_ILLEGAL_CHARACTERS_IN_SERVICE_ID 1707
#define LANG_LOG_RENDCOMMON_ERROR_WRITING_ONION_KEY 1708
#define LANG_LOG_RENDCOMMON_ERROR_WRITING_INTRO_KEY 1709
#define LANG_LOG_RENDCOMMON_BUFFER_TOO_SMALL 1710
#define LANG_LOG_RENDCOMMON_BUFFER_TOO_SMALL_2 1711
#define LANG_LOG_RENDCOMMON_ERROR_GENERATING_SESSION_KEY 1712
#define LANG_LOG_RENDCOMMON_TOO_MANY_CLIENTS 1713
#define LANG_LOG_RENDCOMMON_ERROR_ENCRYPTING_INTRO_POINT 1714
#define LANG_LOG_RENDCOMMON_ERROR_ENCRYPTING_SESSION_KEY 1715
#define LANG_LOG_RENDCOMMON_ERROR_GENERATING_FAKE_CLIENT_ENTRY 1716
#define LANG_LOG_RENDCOMMON_ERROR_ENCODING_V2_DESCRIPTOR 1717
#define LANG_LOG_RENDCOMMON_ERROR_ENCODING_INTRO_POINTS 1718
#define LANG_LOG_RENDCOMMON_ERROR_ENCRYPTING_INTRO_POINTS 1719
#define LANG_LOG_RENDCOMMON_UNRECOGNIZED_AUTH_TYPE 1720
#define LANG_LOG_RENDCOMMON_ERROR_ENCODING_INTRO_POINTS_2 1721
#define LANG_LOG_RENDCOMMON_ERROR_WRITING_PUBLIC_KEY 1722
#define LANG_LOG_RENDCOMMON_BUFFER_TOO_SMALL_3 1723
#define LANG_LOG_RENDCOMMON_ERROR_WRITING_INTRO_POINTS 1724
#define LANG_LOG_RENDCOMMON_ERROR_CREATING_DIGEST 1725
#define LANG_LOG_RENDCOMMON_ERROR_SIGNING_DESC 1726
#define LANG_LOG_RENDCOMMON_ERROR_FINISHING_DESC 1727
#define LANG_LOG_RENDCOMMON_ERROR_PARSING_OWN_DESCRIPTOR 1728
#define LANG_LOG_RENDCOMMON_V2_DESCRIPTOR_OK 1729
#define LANG_LOG_RENDCOMMON_SIGNATURE_TOO_LONG 1730
#define LANG_LOG_RENDCOMMON_BAD_SIGNATURE 1731
#define LANG_LOG_RENDCOMMON_TRUNCATED_DESCRIPTOR 1732
#define LANG_LOG_RENDCOMMON_REMOVING_DESCRIPTOR 1733
#define LANG_LOG_RENDCOMMON_ILLEGAL_CHARACTERS_IN_DESCRIPTOR 1734
#define LANG_LOG_RENDCOMMON_COULD_NOT_ANSWER_DESCRIPTOR_FETCH 1735
#define LANG_LOG_RENDCOMMON_ERROR_PARSING_SERVICE_DESCRIPTOR 1736
#define LANG_LOG_RENDCOMMON_ERROR_COMPUTING_SERVICE_ID 1737
#define LANG_LOG_RENDCOMMON_DESCRIPTOR_TOO_OLD 1738
#define LANG_LOG_RENDCOMMON_DESCRIPTOR_TOO_NEW 1739
#define LANG_LOG_RENDCOMMON_DESCRIPTOR_ALREADY_HAVE 1740
#define LANG_LOG_RENDCOMMON_DESCRIPTOR_ALREADY_HAVE_2 1741
#define LANG_LOG_RENDCOMMON_DESCRIPTOR_ALREADY_HAVE_3 1742
#define LANG_LOG_RENDCOMMON_DESCRIPTOR_STORED_SUCCESSFULLY 1743
#define LANG_LOG_RENDCOMMON_CANNOT_STORE_DESCS 1744
#define LANG_LOG_RENDCOMMON_DESCRIPTOR_NOT_IN_OUR_INTERVAL 1745
#define LANG_LOG_RENDCOMMON_DESCRIPTOR_STORED_SUCCESSFULLY_2 1746
#define LANG_LOG_RENDCOMMON_COULD_NOT_PARSE_ANY_DESCRIPTOR 1747
#define LANG_LOG_RENDCOMMON_PARSED_AND_ADDED 1748
#define LANG_LOG_RENDCOMMON_FAILED_TO_DECRYPT_INTRO_POINTS 1749
#define LANG_LOG_RENDCOMMON_INTRO_POINTS_DECRYPTED 1750
#define LANG_LOG_RENDCOMMON_FAILED_TO_PARSE_INTRO_POINTS 1751
#define LANG_LOG_RENDCOMMON_DESCRIPTOR_WITHOUT_INTRO_POINTS 1752
#define LANG_LOG_RENDCOMMON_DESCRIPTOR_ALREADY_HAVE_4 1753
#define LANG_LOG_RENDCOMMON_RELAY_CEL_FROM_WRONG_HOP 1754
#define LANG_LOG_RENDCOMMON_CELL_FOR_WRONG_CIRC_TYPE 1755

#define LANG_LOG_RENDMID_ESTABLISH_INTRO 1756
#define LANG_LOG_RENDMID_REJECTING_ESTABLISH_INTRO 1757
#define LANG_LOG_RENDMID_ERROR_DECODING_PUBLIC_KEY 1758
#define LANG_LOG_RENDMID_INTERNAL_ERROR 1759
#define LANG_LOG_RENDMID_UNEXPECTED_HASH 1760
#define LANG_LOG_RENDMID_INCORRECT_SIGNATURE_ON_ESTABLISH_INTRO 1761
#define LANG_LOG_RENDMID_INTERNAL_ERROR_2 1762
#define LANG_LOG_RENDMID_REPLACING_OLD_CIRCUIT 1763
#define LANG_LOG_RENDMID_ERROR_SENDING_INTRO_ESTABLISHED 1764
#define LANG_LOG_RENDMID_INTRO_POINT_ESTABLISHED 1765
#define LANG_LOG_RENDMID_ESTABLISH_INTRO_TRUNCATED 1766
#define LANG_LOG_RENDMID_INTRODUCE1_RECEIVED 1767
#define LANG_LOG_RENDMID_INTRODUCE1_REJECTED 1768
#define LANG_LOG_RENDMID_INTRODUCE1_TOO_SHORT 1769
#define LANG_LOG_RENDMID_NO_INTRO_CIRC_FOR_INTRODUCE1 1770
#define LANG_LOG_RENDMID_SENDING_INTRO_FOR_SERVICE 1771
#define LANG_LOG_RENDMID_ERROR_SENDING_INTRODUCE2 1772
#define LANG_LOG_RENDMID_ERROR_SENDING_INTRODUCE_ACK 1773
#define LANG_LOG_RENDMID_ERROR_SENDING_NAK 1774
#define LANG_LOG_RENDMID_ESTABLISH_RENDEZVOUS 1775
#define LANG_LOG_RENDMID_UNEXPECTED_REND 1776
#define LANG_LOG_RENDMID_ESTABLISH_RENDEZVOUS_INVALID_LENGTH 1777
#define LANG_LOG_RENDMID_ESTABLISH_RENDEZVOUS_DUPLICATE_COOKIE 1778
#define LANG_LOG_RENDMID_ERROR_SENDING_RENDEZVOUS_ESTABLISHED 1779
#define LANG_LOG_RENDMID_REND_ESTABLISHED 1780
#define LANG_LOG_RENDMID_GOT_REND_REQUEST_FROM_CIRC 1781
#define LANG_LOG_RENDMID_UNEXPECTED_REND_2 1782
#define LANG_LOG_RENDMID_RENDEZVOUS1_WITH_BAD_LENGTH 1783
#define LANG_LOG_RENDMID_RENDEZVOUS1_REJECTED 1784
#define LANG_LOG_RENDMID_ERROR_SENDING_RENDEZVOUS2 1785
#define LANG_LOG_RENDMID_COMPLETING_REND 1786

#define LANG_LOG_RENDSERVICE_HS_WITH_AUTH_AND_V0 1787
#define LANG_LOG_RENDSERVICE_HS_WITH_AUTH_AND_NO_CLIENTS 1788
#define LANG_LOG_RENDSERVICE_HS_WITH_NO_PORTS 1789
#define LANG_LOG_RENDSERVICE_CONFIGURING_SERVICE 1790
#define LANG_LOG_RENDSERVICE_SERVICE_MAP 1791
#define LANG_LOG_RENDSERVICE_BAD_SYNTAX_IN_HS_PORT_CONFIG 1792
#define LANG_LOG_RENDSERVICE_INVALID_PORT_IN_PORT_CONFIG 1793
#define LANG_LOG_RENDSERVICE_UNPARSEABLE_ADDRESS_IN_PORT_CONFIG 1794
#define LANG_LOG_RENDSERVICE_INVALID_PORT_IN_PORT_CONFIG_2 1795
#define LANG_LOG_RENDSERVICE_KEY_WITHOUT_HIDDENSERVICEKEY 1796
#define LANG_LOG_RENDSERVICE_MULTIPLE_HSAUTHCLIENT 1797
#define LANG_LOG_RENDSERVICE_HSAUTHCLIENT_WITHOUT_VALUE 1798
#define LANG_LOG_RENDSERVICE_HSAUTHCLIENT_WITH_UNKNOWN_AUTH_TYPE 1799
#define LANG_LOG_RENDSERVICE_HSAUTHCLIENT_WITHOUT_CLIENT_NAMES 1800
#define LANG_LOG_RENDSERVICE_HSAUTHCLIENT_WITH_DUPLICATE_CLIENTS 1801
#define LANG_LOG_RENDSERVICE_HSAUTHCLIENT_WITH_ILLEGAL_CLIENT_NAME 1802
#define LANG_LOG_RENDSERVICE_HSAUTHCLIENT_WITH_ILLEGAL_CLIENT_NAME_2 1803
#define LANG_LOG_RENDSERVICE_ADDING_CLIENT_NAME 1804
#define LANG_LOG_RENDSERVICE_HSAUTHCLIENT_MAX_ENTRIES 1805
#define LANG_LOG_RENDSERVICE_INVALID_HS_VERSION 1806
#define LANG_LOG_RENDSERVICE_CLOSING_INTRO_POINT 1807
#define LANG_LOG_RENDSERVICE_LOADING_HS_KEYS 1808
#define LANG_LOG_RENDSERVICE_DIR_NAME_TOO_LONG 1809
#define LANG_LOG_RENDSERVICE_INTERNAL_ERROR 1810
#define LANG_LOG_RENDSERVICE_ERROR_HASHING_PUBLIC_KEY 1811
#define LANG_LOG_RENDSERVICE_DIR_NAME_TOO_LONG_1 1812
#define LANG_LOG_RENDSERVICE_ERROR_WRITING_ONION_ADDRESS 1813
#define LANG_LOG_RENDSERVICE_DIR_NAME_TOO_LONG_2 1814
#define LANG_LOG_RENDSERVICE_ERROR_PARSING_CLIENT_KEYS 1815
#define LANG_LOG_RENDSERVICE_PARSED_CLIENT_ENTRIES 1816
#define LANG_LOG_RENDSERVICE_ERROR_LOADING_CLIENT_KEYS 1817
#define LANG_LOG_RENDSERVICE_ERROR_OPENING_HOSTNAME_FILE 1818
#define LANG_LOG_RENDSERVICE_ERROR_ENCODING_DESCRIPTOR_COOKIE 1819
#define LANG_LOG_RENDSERVICE_ERROR_CONSTRUCTING_CLIENT_KEY 1820
#define LANG_LOG_RENDSERVICE_ERROR_GENERATING_CLIENT_KEY 1821
#define LANG_LOG_RENDSERVICE_INVALID_CLIENT_KEY 1822
#define LANG_LOG_RENDSERVICE_ERROR_WRITING_CLIENT_ENTRY 1823
#define LANG_LOG_RENDSERVICE_ERROR_WRITING_CLIENT_ENTRY_2 1824
#define LANG_LOG_RENDSERVICE_ERROR_WRITING_HOST_ENTRY 1825
#define LANG_LOG_RENDSERVICE_NO_AUTH 1826
#define LANG_LOG_RENDSERVICE_NO_AUTH_2 1827
#define LANG_LOG_RENDSERVICE_CLIENT_AUTH 1828
#define LANG_LOG_RENDSERVICE_INTRODUCE2_RECEIVED 1829
#define LANG_LOG_RENDSERVICE_INTRODUCE2_FOR_NON_INTRO_CIRC 1830
#define LANG_LOG_RENDSERVICE_INTRODUCE2_TRUNCATED 1831
#define LANG_LOG_RENDSERVICE_INTRODUCE2_FOR_UNRECOGNIZED_SERVICE 1832
#define LANG_LOG_RENDSERVICE_INTRODUCE2_FOR_WRONG_SERVICE 1833
#define LANG_LOG_RENDSERVICE_INTRODUCE2_TRUNCATED_2 1834
#define LANG_LOG_RENDSERVICE_ERROR_DECRYPTING_INTRODUCE2 1835
#define LANG_LOG_RENDSERVICE_WRONG_AUTH_DATA_SIZE 1836
#define LANG_LOG_RENDSERVICE_UNKNOWN_AUTH_TYPE 1837
#define LANG_LOG_RENDSERVICE_INTRODUCE2_TIME 1838
#define LANG_LOG_RENDSERVICE__OLD 1839
#define LANG_LOG_RENDSERVICE__NEW 1840
#define LANG_LOG_RENDSERVICE_INTRODUCE2_BAD_LENGTH 1841
#define LANG_LOG_RENDSERVICE_INTRODUCE2_ERROR_DECODING_KEY 1842
#define LANG_LOG_RENDSERVICE_INTRODUCE2_ERROR 1843
#define LANG_LOG_RENDSERVICE_INTRODUCE2_ERROR_NICKNAME 1844
#define LANG_LOG_RENDSERVICE_INTRODUCE2_ERROR_ROUTER 1845
#define LANG_LOG_RENDSERVICE_INTRODUCE2_BAD_LENGTH_2 1846
#define LANG_LOG_RENDSERVICE_REPLAY_DETECTED 1847
#define LANG_LOG_RENDSERVICE_INTRODUCE2_AUTH_VALID 1848
#define LANG_LOG_RENDSERVICE_INTRODUCE2_AUTH_INVALID 1849
#define LANG_LOG_RENDSERVICE_INTRODUCE2_WITHOUT_AUTH 1850
#define LANG_LOG_RENDSERVICE_INTERNAL_ERROR_2 1851
#define LANG_LOG_RENDSERVICE_INTERNAL_ERROR_3 1852
#define LANG_LOG_RENDSERVICE_NOT_LAUNCHING_FIRST_HOP 1853
#define LANG_LOG_RENDSERVICE_ACCEPTED_INTRO 1854
#define LANG_LOG_RENDSERVICE_CIRC_BUILD_FAILED 1855
#define LANG_LOG_RENDSERVICE_SKIP_RELAUNCH 1856
#define LANG_LOG_RENDSERVICE_REATTEMPTING_REND 1857
#define LANG_LOG_RENDSERVICE_ERROR_RELAUNCHING_CIRC 1858
#define LANG_LOG_RENDSERVICE_LAUNCHING_CIRC_TO_INTRO_POINT 1859
#define LANG_LOG_RENDSERVICE_ERROR_RELAUNCHING_CIRC_2 1860
#define LANG_LOG_RENDSERVICE_UPDATING_SERVICE 1861
#define LANG_LOG_RENDSERVICE_UNRECOGNIZED_SERVICE_ID 1862
#define LANG_LOG_RENDSERVICE_REDEFINING_PURPOSE 1863
#define LANG_LOG_RENDSERVICE_ESTABLISHED_CIRC 1864
#define LANG_LOG_RENDSERVICE_INTERNAL_ERROR_4 1865
#define LANG_LOG_RENDSERVICE_INTERNAL_ERROR_5 1866
#define LANG_LOG_RENDSERVICE_ERROR_SENDING_INTRO_REQUEST 1867
#define LANG_LOG_RENDSERVICE_INTRO_ESTABLISHED_ON_NON_INTRO_CIRC 1868
#define LANG_LOG_RENDSERVICE_UNKNOWN_SERVICE 1869
#define LANG_LOG_RENDSERVICE_INTRO_ESTABLISHED_RECEIVED 1870
#define LANG_LOG_RENDSERVICE_CIRC_BUILT 1871
#define LANG_LOG_RENDSERVICE_INTERNAL_ERROR_6 1872
#define LANG_LOG_RENDSERVICE_ERROR_GETTING_DH_PUBLIC_KEY 1873
#define LANG_LOG_RENDSERVICE_RENDEZVOUS1_SEND_ERROR 1874
#define LANG_LOG_RENDSERVICE_UNKNOWN_HS_DIRS 1875
#define LANG_LOG_RENDSERVICE_QUEUING_DESCRIPTOR 1876
#define LANG_LOG_RENDSERVICE_PUBLISH_REQUEST 1877
#define LANG_LOG_RENDSERVICE_INTERNAL_ERROR_7 1878
#define LANG_LOG_RENDSERVICE_PUBLISH_REQUEST_2 1879
#define LANG_LOG_RENDSERVICE_UPLOAD_SUCCESSFULL 1880
#define LANG_LOG_RENDSERVICE_GIVING_UP_ON_INTRO 1881
#define LANG_LOG_RENDSERVICE_DESC_DIRTY 1882
#define LANG_LOG_RENDSERVICE_CANNOT_ESTABLISH_INTRO 1883
#define LANG_LOG_RENDSERVICE_PICKED_INTRO 1884
#define LANG_LOG_RENDSERVICE_ERROR_LAUNCHING_CIRC 1885
#define LANG_LOG_RENDSERVICE_SERVICE_CONFIGURED 1886
#define LANG_LOG_RENDSERVICE_INTRO_WITHOUT_CIRC 1887
#define LANG_LOG_RENDSERVICE_INTRO_AT_CIRC 1888
#define LANG_LOG_RENDSERVICE_SEARCH_FOR_ADDR_PORT 1889
#define LANG_LOG_RENDSERVICE_NO_SERVICE 1890
#define LANG_LOG_RENDSERVICE_NO_PORT_MAPPING 1891

#define LANG_LOG_REPHIST_ROUTER_NOW_RUNNING 1892
#define LANG_LOG_REPHIST_ALREADY_RUNNING 1893
#define LANG_LOG_REPHIST_STILL_RUNNING 1894
#define LANG_LOG_REPHIST_ROUTER_NOW_RUNNING_2 1895
#define LANG_LOG_REPHIST_ROUTER_NON_RUNNING 1896
#define LANG_LOG_REPHIST_ROUTER_NON_RUNNING_2 1897
#define LANG_LOG_REPHIST_ROUTER_NON_RUNNING_3 1898
#define LANG_LOG_REPHIST_DISCOUNTING_OLD_STABILITY_INFO 1899
#define LANG_LOG_REPHIST_DUMP 1900
#define LANG_LOG_REPHIST_STATS 1901
#define LANG_LOG_REPHIST_RELAY_NOT_IN_ROUTERLIST 1902
#define LANG_LOG_REPHIST_MTBF_FORMAT_ERROR 1903
#define LANG_LOG_REPHIST_MTBF_FORMAT_ERROR_2 1904
#define LANG_LOG_REPHIST_MTBF_FORMAT_ERROR_3 1905
#define LANG_LOG_REPHIST_MTBF_FORMAT_ERROR_4 1906
#define LANG_LOG_REPHIST_NO_STORED_TIME 1907
#define LANG_LOG_REPHIST_COULD_NOT_SCAN_LINE 1908
#define LANG_LOG_REPHIST_COULD_NOT_SCAN_LINE_2 1909
#define LANG_LOG_REPHIST_COULD_NOT_SCAN_LINE_3 1910
#define LANG_LOG_REPHIST_BASE16_ERROR 1911
#define LANG_LOG_REPHIST_MTBF_FORMAT_ERROR_5 1912
#define LANG_LOG_REPHIST_MTBF_TRUNCATED 1913
#define LANG_LOG_REPHIST_PARSE_INT_ERROR 1914
#define LANG_LOG_REPHIST_EXPIRING_PREDICTED_PORT 1915
#define LANG_LOG_REPHIST_UNKNOWN_PK_OPERATION 1916
#define LANG_LOG_REPHIST_PK_OPERATIONS 1917

#define LANG_LOG_ROUTER_ERROR_CONSTRUCTING_KEY 1918
#define LANG_LOG_ROUTER_ERROR_GENERATING_KEY 1919
#define LANG_LOG_ROUTER_ERROR_WRITING_KEY 1920
#define LANG_LOG_ROUTER_ROTATING_ONION_KEY 1921
#define LANG_LOG_ROUTER_ERROR_ROTATING_ONION_KEY 1922
#define LANG_LOG_ROUTER_ERROR_CONSTRUCTING_KEY_2 1923
#define LANG_LOG_ROUTER_ERROR_READING_KEY 1924
#define LANG_LOG_ROUTER_FILE_LOCKED 1925
#define LANG_LOG_ROUTER_GENERATING_NEW_KEY 1926
#define LANG_LOG_ROUTER_INVALID_KEY 1927
#define LANG_LOG_ROUTER_VALID_KEY 1928
#define LANG_LOG_ROUTER_ERROR_WRITING_KEY_2 1929
#define LANG_LOG_ROUTER_NO_KEY_FOUND 1930
#define LANG_LOG_ROUTER_ERROR_LOADING_KEY 1931
#define LANG_LOG_ROUTER_NO_KEY_FOUND_2 1932
#define LANG_LOG_ROUTER_NO_CERT_FOUND 1933
#define LANG_LOG_ROUTER_ERROR_PARSING_CERT 1934
#define LANG_LOG_ROUTER_KEY_MISMATCH 1935
#define LANG_LOG_ROUTER_CERT_EXPIRE 1936
#define LANG_LOG_ROUTER_CERT_EXPIRE_2 1937
#define LANG_LOG_ROUTER_CERT_EXPIRE_3 1938
#define LANG_LOG_ROUTER_TLS_CONTEXT_ERROR 1939
#define LANG_LOG_ROUTER_ERROR_LOADING_KEYS 1940
#define LANG_LOG_ROUTER_READING_KEY 1941
#define LANG_LOG_ROUTER_READING_KEY_2 1942
#define LANG_LOG_ROUTER_TLS_CONTEXT_ERROR_2 1943
#define LANG_LOG_ROUTER_TOR_RUNNING 1944
#define LANG_LOG_ROUTER_ERROR_ADDING_OWN_FINGERPRINT 1945
#define LANG_LOG_ROUTER_ERROR_PARSING_ROUTERINFO 1946
#define LANG_LOG_ROUTER_ERROR_ADDING_OWN_DESCRIPTOR_TO_DIR 1947
#define LANG_LOG_ROUTER_UNKNOWN_ERROR 1948
#define LANG_LOG_ROUTER_DUMPING_FINGERPRINT 1949
#define LANG_LOG_ROUTER_ERROR_WRITING_FINGERPRINT 1950
#define LANG_LOG_ROUTER_ERROR_WRITING_FINGERPRINT_2 1951
#define LANG_LOG_ROUTER_YOUR_SERVERS_FINGERPRINT_IS 1952
#define LANG_LOG_ROUTER_ERROR_LOADING_FINGERPRINTS 1953
#define LANG_LOG_ROUTER_ERROR_UPDATING_AUTHORITY_LIST 1954
#define LANG_LOG_ROUTER_AUTHORITY_TYPE_MISMATCH 1955
#define LANG_LOG_ROUTER_V3_KEY_MISMATCH 1956
#define LANG_LOG_ROUTER_ADDING_OWN_V3_CERT 1957
#define LANG_LOG_ROUTER_ERROR_PARSING_CERT_2 1958
#define LANG_LOG_ROUTER_ADVERTISING_DIRPORT 1959
#define LANG_LOG_ROUTER_NOT_ADVERTISING_DIRPORT 1960
#define LANG_LOG_ROUTER_TESTING_REACHABILITY 1961
#define LANG_LOG_ROUTER_TESTING_BANDWIDTH 1962
#define LANG_LOG_ROUTER_ORPORT_IS_REACHABLE 1963
#define LANG_LOG_ROUTER_PUBLISHING_SERVER_DESC 1964
#define LANG_LOG_ROUTER_ORPORT_IS_REACHABLE_2 1965
#define LANG_LOG_ROUTER_DIRPORT_IS_REACHABLE 1966
#define LANG_LOG_ROUTER_DIRPORT_IS_REACHABLE_2 1967
#define LANG_LOG_ROUTER_BW_TEST_DONE 1968
#define LANG_LOG_ROUTER_NO_DESCRIPTOR 1969
#define LANG_LOG_ROUTER_MY_DESC_IS 1970
#define LANG_LOG_ROUTER_ERROR_GETTING_LOCAL_ADDRESS 1971
#define LANG_LOG_ROUTER_ERROR_GETTING_LOCAL_ADDRESS_2 1972
#define LANG_LOG_ROUTER_FAMILY_ROUTER_DESC_MISSING 1973
#define LANG_LOG_ROUTER_FAMILY_ROUTER_ILLEGAL_NICKNAME 1974
#define LANG_LOG_ROUTER_ERROR_GENERATING_EXTRAINFO 1975
#define LANG_LOG_ROUTER_ERROR_GENERATING_ROUTER_DESC 1976
#define LANG_LOG_ROUTER_REBUILDING_DESC 1977
#define LANG_LOG_ROUTER_REBUILDING_DESC_2 1978
#define LANG_LOG_ROUTER_OUR_IP 1979
#define LANG_LOG_ROUTER_ERROR_RESOLVING_ADDRESS 1980
#define LANG_LOG_ROUTER_MALFORMED_X_YOUR_ADDRESS_IS 1981
#define LANG_LOG_ROUTER_GOT_X_YOUR_ADDRESS_IS 1982
#define LANG_LOG_ROUTER_DIR_REPORTING_OWN_ADDRESS 1983
#define LANG_LOG_ROUTER_KEY_MISMATCH_2 1984
#define LANG_LOG_ROUTER_WRITE_ONION_PKEY_FAILED 1985
#define LANG_LOG_ROUTER_DESC_BUFFER_TOO_SMALL 1986
#define LANG_LOG_ROUTER_DESC_BUFFER_TOO_SMALL_2 1987
#define LANG_LOG_ROUTER_DESC_BUFFER_TOO_SMALL_3 1988
#define LANG_LOG_ROUTER_DESC_BUFFER_TOO_SMALL_4 1989
#define LANG_LOG_ROUTER_DESC_BUFFER_TOO_SMALL_5 1990
#define LANG_LOG_ROUTER_ERROR_SIGNING_DESC 1991
#define LANG_LOG_ROUTER_DESC_BUFFER_TOO_SMALL_6 1992
#define LANG_LOG_ROUTER_ERROR_PARSING_ROUTER_DESC 1993
#define LANG_LOG_ROUTER_ERROR_PARSING_EXTRAINFO 1994

#define LANG_LOG_ROUTERLIST_PARSED_CERT 1995
#define LANG_LOG_ROUTERLIST_UNKNOWN_AUTHORITY 1996
#define LANG_LOG_ROUTERLIST_ALREADY_HAVE 1997
#define LANG_LOG_ROUTERLIST_SKIPPING_CACHED_CERT 1998
#define LANG_LOG_ROUTERLIST_SKIPPING_DOWNLOADED_CERT 1999
#define LANG_LOG_ROUTERLIST_ALREADY_HAVE_2 2000
#define LANG_LOG_ROUTERLIST_ADDING_CERT 2001
#define LANG_LOG_ROUTERLIST_ADDING_CACHED_CERT 2002
#define LANG_LOG_ROUTERLIST_ADDING_DOWNLOADED_CERT 2003
#define LANG_LOG_ROUTERLIST_UNRECOGNIZED_AUTHORITY 2004
#define LANG_LOG_ROUTERLIST__ADDING 2005
#define LANG_LOG_ROUTERLIST__NOT_ADDING 2006
#define LANG_LOG_ROUTERLIST__CACHED_CERT 2007
#define LANG_LOG_ROUTERLIST__DOWNLOADED_CERT 2008
#define LANG_LOG_ROUTERLIST_UPDATING_ADDR_FOR_AUTHORITY 2009
#define LANG_LOG_ROUTERLIST_ERROR_WRITING_CERTS 2010
#define LANG_LOG_ROUTERLIST_MISSING_CERT 2011
#define LANG_LOG_ROUTERLIST_MISSING_CERT_2 2012
#define LANG_LOG_ROUTERLIST_ERROR_WRITING_DESC 2013
#define LANG_LOG_ROUTERLIST_REBUILDING_CACHE 2014
#define LANG_LOG_ROUTERLIST_NO_DESC_AVAILABLE 2015
#define LANG_LOG_ROUTERLIST_ERROR_WRITING_STORE 2016
#define LANG_LOG_ROUTERLIST_ERROR_REPLACING_STORE 2017
#define LANG_LOG_ROUTERLIST_ERROR_WRITING_DESC_2 2018
#define LANG_LOG_ROUTERLIST_REMOVED_ALL_DESCS 2019
#define LANG_LOG_ROUTERLIST_MMAP_ERROR 2020
#define LANG_LOG_ROUTERLIST_RECONSTRUCTING_POINTERS 2021
#define LANG_LOG_ROUTERLIST_ERROR_READING_FILE 2022
#define LANG_LOG_ROUTERLIST_NO_REACHABLE_ROUTERS 2023
#define LANG_LOG_ROUTERLIST_NO_REACHABLE_DIRS 2024
#define LANG_LOG_ROUTERLIST_INVALID_NICKNAME 2025
#define LANG_LOG_ROUTERLIST_INVALID_NICKLIST_ENTRY 2026
#define LANG_LOG_ROUTERLIST_BW_STATS 2027
#define LANG_LOG_ROUTERLIST_ERROR_COMPUTING_BW 2028
#define LANG_LOG_ROUTERLIST_NO_LIVE_ROUTERS 2029
#define LANG_LOG_ROUTERLIST__FAST 2030
#define LANG_LOG_ROUTERLIST__STABLE 2031
#define LANG_LOG_ROUTERLIST__GUARD 2032
#define LANG_LOG_ROUTERLIST_NO_LIVE_ROUTERS_2 2033
#define LANG_LOG_ROUTERLIST_NO_LIVE_ROUTERS_3 2034
#define LANG_LOG_ROUTERLIST_MULTIPLE_NICKNAME_MATCHES 2035
#define LANG_LOG_ROUTERLIST_NICKNAME_GIVEN 2036
#define LANG_LOG_ROUTERLIST_ERROR_READING_DESC 2037
#define LANG_LOG_ROUTERLIST_ERROR_READING_DESC_2 2038
#define LANG_LOG_ROUTERLIST_MEM_STATS 2039
#define LANG_LOG_ROUTERLIST_MEM_STATS_2 2040
#define LANG_LOG_ROUTERLIST_MEM_STATS_3 2041
#define LANG_LOG_ROUTERLIST__IN_V2_NS 2042
#define LANG_LOG_ROUTERLIST__NOT_IN_V2_NS 2043
#define LANG_LOG_ROUTERLIST__IN_V3_CONSENSUS 2044
#define LANG_LOG_ROUTERLIST__NOT_IN_V3_CONSENSUS 2045
#define LANG_LOG_ROUTERLIST_ROUTERLIST_REPLACE_APPEND_ENTRY 2046
#define LANG_LOG_ROUTERLIST_MARKING_ROUTER 2047
#define LANG_LOG_ROUTERLIST__AS_UP 2048
#define LANG_LOG_ROUTERLIST__AS_DOWN 2049
#define LANG_LOG_ROUTERLIST_MARKING_ROUTER_2 2050
#define LANG_LOG_ROUTERLIST_DESC_ALREADY_HAVE 2051
#define LANG_LOG_ROUTERLIST_UNRECOGNIZED_DESC 2052
#define LANG_LOG_ROUTERLIST_DESC_NOT_NEW 2053
#define LANG_LOG_ROUTERLIST_REPLACING_ENTRY 2054
#define LANG_LOG_ROUTERLIST_ROUTERINFO_TOO_OLD 2055
#define LANG_LOG_ROUTERLIST_ROUTER_STATS 2056
#define LANG_LOG_ROUTERLIST_ERROR_PARSING_DESC 2057
#define LANG_LOG_ROUTERLIST_KEY_MISMATCH 2058
#define LANG_LOG_ROUTERLIST_ERROR_ADDING_ROUTER 2059
#define LANG_LOG_ROUTERLIST__DESC_NOT_NEW 2060
#define LANG_LOG_ROUTERLIST__DESC_NOT_IN_NS 2061
#define LANG_LOG_ROUTERLIST__DESC_NOT_IN_CONSENSUS 2062
#define LANG_LOG_ROUTERLIST__VALID_SERVER 2063
#define LANG_LOG_ROUTERLIST__INVALID_SERVER 2064
#define LANG_LOG_ROUTERLIST__DESC_TOO_OLD 2065
#define LANG_LOG_ROUTERLIST__TIME_SKEW 2066
#define LANG_LOG_ROUTERLIST__TIME_SKEW_2 2067
#define LANG_LOG_ROUTERLIST__INVALID_IP 2068
#define LANG_LOG_ROUTERLIST__ERROR_COMPUTING_FINGERPRINT 2069
#define LANG_LOG_ROUTERLIST__VERSION_TOO_OLD 2070
#define LANG_LOG_ROUTERLIST__DUPLICATE_SERVER 2071
#define LANG_LOG_ROUTERLIST__REJECTED_FINGERPRINT 2072
#define LANG_LOG_ROUTERLIST__INVALID_FINGERPRINT 2073
#define LANG_LOG_ROUTERLIST__RANGE_REJECTED 2074
#define LANG_LOG_ROUTERLIST__UNKNOWN_ROUTER_REJECTED 2075
#define LANG_LOG_ROUTERLIST_ROUTER_ADDED 2076
#define LANG_LOG_ROUTERLIST_TO_ADD 2077
#define LANG_LOG_ROUTERLIST_UNREQUESTED_DESC 2078
#define LANG_LOG_ROUTERLIST_MARKING_ROUTER_3 2079
#define LANG_LOG_ROUTERLIST_RESOLVE_ERROR 2080
#define LANG_LOG_ROUTERLIST_RESOLVE_ERROR_2 2081
#define LANG_LOG_ROUTERLIST_ENOUGH_ROUTERDESCS_FOR_REQUESTS 2082
#define LANG_LOG_ROUTERLIST_DOWNLOAD_DESCS 2083
#define LANG_LOG_ROUTERLIST_DOWNLOAD_DESCS_2 2084
#define LANG_LOG_ROUTERLIST_DOWNLOAD_DESCS_3 2085
#define LANG_LOG_ROUTERLIST_WRONG_DIR_MIRROR 2086
#define LANG_LOG_ROUTERLIST_NEED_TO_MIRROR 2087
#define LANG_LOG_ROUTERLIST_NS_WITHOUT_AUTHORITY 2088
#define LANG_LOG_ROUTERLIST_DOWNLOAD_DESCS_4 2089
#define LANG_LOG_ROUTERLIST_MARKING_ROUTER_4 2090
#define LANG_LOG_ROUTERLIST_REPARSE_ERROR 2091
#define LANG_LOG_ROUTERLIST_REPARSE_ERROR_2 2092
#define LANG_LOG_ROUTERLIST_ROUTER_STATS_2 2093
#define LANG_LOG_ROUTERLIST_DOWNLOAD_STATS 2094
#define LANG_LOG_ROUTERLIST_ROUTER_STATS_3 2095
#define LANG_LOG_ROUTERLIST_NO_BRIDGES 2096
#define LANG_LOG_ROUTERLIST_DIR_INFO 2097
#define LANG_LOG_ROUTERLIST_DIR_INFO_TOO_OLD 2098
#define LANG_LOG_ROUTERLIST_INVALID_COUNTRY_CODE 2099
#define LANG_LOG_ROUTERLIST_INVALID_COUNTRY_CODE_2 2100
#define LANG_LOG_ROUTERLIST_ADDING_IDENTITY 2101
#define LANG_LOG_ROUTERLIST_ADDING_NICKNAME 2102
#define LANG_LOG_ROUTERLIST_ADDING_COUNTRY 2103
#define LANG_LOG_ROUTERLIST_ADDING_ADDRESS 2104
#define LANG_LOG_ROUTERLIST_INVALID_ENTRY 2105
#define LANG_LOG_ROUTERLIST_NO_CONSENSUS 2106
#define LANG_LOG_ROUTERLIST_UNREACHABLE_ROUTER 2107
#define LANG_LOG_ROUTERLIST_NOT_HS_DIR 2108
#define LANG_LOG_ROUTERLIST_NO_CONSENSUS_2 2109
#define LANG_LOG_ROUTERLIST_NOT_HS_DIR_2 2110
#define LANG_LOG_ROUTERLIST_NOT_HS_DIR_3 2111

#define LANG_LOG_ROUTERPARSE_DUMP_AREA 2112
#define LANG_LOG_ROUTERPARSE_ERROR_SIGNING_DIGEST 2113
#define LANG_LOG_ROUTERPARSE_ERROR_ENCODING_SIGNATURE 2114
#define LANG_LOG_ROUTERPARSE_CHECKING_VERSION 2115
#define LANG_LOG_ROUTERPARSE_ERROR_PARSING_VERSION 2116
#define LANG_LOG_ROUTERPARSE_RANDOM_VERSION 2117
#define LANG_LOG_ROUTERPARSE_ERROR_COMPUTING_DIGEST 2118
#define LANG_LOG_ROUTERPARSE_RECEIVED_HASHES 2119
#define LANG_LOG_ROUTERPARSE_NO_SIGNATURE_FOUND 2120
#define LANG_LOG_ROUTERPARSE_ERROR_TOKENIZING_SIGNATURE 2121
#define LANG_LOG_ROUTERPARSE_SIGNATURE_ERROR 2122
#define LANG_LOG_ROUTERPARSE_SIGNATURE_ERROR_2 2123
#define LANG_LOG_ROUTERPARSE_ERROR_TOKENIZING_DIR 2124
#define LANG_LOG_ROUTERPARSE_ERROR_COMPUTING_DIGEST_2 2125
#define LANG_LOG_ROUTERPARSE_ERROR_TOKENIZING_ROUTERS 2126
#define LANG_LOG_ROUTERPARSE_WRONG_NS_TOKEN 2127
#define LANG_LOG_ROUTERPARSE_MISSING_SIGNATURE 2128
#define LANG_LOG_ROUTERPARSE_UNPARSEABLE_KEY 2129
#define LANG_LOG_ROUTERPARSE_UNPARSEABLE_KEY_2 2130
#define LANG_LOG_ROUTERPARSE_DIR_SIGNING_KEY_TOKEN_WITHOUT_KEY 2131
#define LANG_LOG_ROUTERPARSE_ERROR_COMPUTING_DIGEST_3 2132
#define LANG_LOG_ROUTERPARSE_UNTRUSTED_KEY 2133
#define LANG_LOG_ROUTERPARSE_UNTRUSTED_KEY_2 2134
#define LANG_LOG_ROUTERPARSE_SIGNATURE_ERROR_3 2135
#define LANG_LOG_ROUTERPARSE_SIGNATURE_ERROR_4 2136
#define LANG_LOG_ROUTERPARSE_SIGNATURE_MISMATCH 2137
#define LANG_LOG_ROUTERPARSE_ROUTER_PARSED 2138
#define LANG_LOG_ROUTERPARSE_VERIFIED_DIGESTS 2139
#define LANG_LOG_ROUTERPARSE_ERROR_TOKENIZING_DESC 2140
#define LANG_LOG_ROUTERPARSE_NO_ROUTER_KEYWORD 2141
#define LANG_LOG_ROUTERPARSE_ERROR_COMPUTING_DIGEST_4 2142
#define LANG_LOG_ROUTERPARSE_ERROR_TOKENIZING_DESC_2 2143
#define LANG_LOG_ROUTERPARSE_DESC_TOO_SHORT 2144
#define LANG_LOG_ROUTERPARSE_INVALID_NICKNAME 2145
#define LANG_LOG_ROUTERPARSE_INVALID_ADDRESS 2146
#define LANG_LOG_ROUTERPARSE_INVALID_PORT 2147
#define LANG_LOG_ROUTERPARSE_INVALID_PORT_2 2148
#define LANG_LOG_ROUTERPARSE_INVALID_BW 2149
#define LANG_LOG_ROUTERPARSE_INVALID_BW_2 2150
#define LANG_LOG_ROUTERPARSE_INVALID_BW_3 2151
#define LANG_LOG_ROUTERPARSE_INVALID_UPTIME 2152
#define LANG_LOG_ROUTERPARSE_ERROR_COMPUTING_DIGEST_5 2153
#define LANG_LOG_ROUTERPARSE_ERROR_DECODING_FINGERPRINT 2154
#define LANG_LOG_ROUTERPARSE_FINGERPRINT_MISMATCH 2155
#define LANG_LOG_ROUTERPARSE_NO_EXIT_POLICY 2156
#define LANG_LOG_ROUTERPARSE_INVALID_EXIT_POLICY 2157
#define LANG_LOG_ROUTERPARSE_INVALID_NICKNAME_2 2158
#define LANG_LOG_ROUTERPARSE_INVALID_EXTRAINFO 2159
#define LANG_LOG_ROUTERPARSE_INVALID_PORT_3 2160
#define LANG_LOG_ROUTERPARSE_ERROR_TOKENIZING_EXTRAINFO 2161
#define LANG_LOG_ROUTERPARSE_EXTRAINFO_TOO_SHORT 2162
#define LANG_LOG_ROUTERPARSE_INVALID_EXTRAINFO_2 2163
#define LANG_LOG_ROUTERPARSE_INVALID_NICKNAME_3 2164
#define LANG_LOG_ROUTERPARSE_INVALID_FINGERPRINT 2165
#define LANG_LOG_ROUTERPARSE_INVALID_TIME 2166
#define LANG_LOG_ROUTERPARSE_INVALID_EXTRAINFO_3 2167
#define LANG_LOG_ROUTERPARSE_NO_SIGNATURE_FOUND_2 2168
#define LANG_LOG_ROUTERPARSE_NO_END_OF_SIGNATURE 2169
#define LANG_LOG_ROUTERPARSE_ERROR_TOKENIZING_KEY 2170
#define LANG_LOG_ROUTERPARSE_INVALID_VERSION 2171
#define LANG_LOG_ROUTERPARSE_ERROR_DECODING_KEY 2172
#define LANG_LOG_ROUTERPARSE_DIGEST_MISMATCH 2173
#define LANG_LOG_ROUTERPARSE_INVALID_ADDRESS_2 2174
#define LANG_LOG_ROUTERPARSE_CERT_ERROR 2175
#define LANG_LOG_ROUTERPARSE_ALREADY_CHECKED 2176
#define LANG_LOG_ROUTERPARSE_ERROR_TOKENIZING_ROUTER_STATUS 2177
#define LANG_LOG_ROUTERPARSE_ROUTER_STATUS_TOO_SHORT 2178
#define LANG_LOG_ROUTERPARSE_INVALID_NICKNAME_4 2179
#define LANG_LOG_ROUTERPARSE_ERROR_DECODING_DIGEST 2180
#define LANG_LOG_ROUTERPARSE_ERROR_DECODING_DIGEST_2 2181
#define LANG_LOG_ROUTERPARSE_INVALID_TIME_2 2182
#define LANG_LOG_ROUTERPARSE_INVALID_ADDRESS_3 2183
#define LANG_LOG_ROUTERPARSE_UNKNOWN_FLAG 2184
#define LANG_LOG_ROUTERPARSE_INVALID_BW_4 2185
#define LANG_LOG_ROUTERPARSE_INVALID_EXIT_POLICY_SUMMARY 2186
#define LANG_LOG_ROUTERPARSE_DUPLICATE_ROUTER_STATUS 2187
#define LANG_LOG_ROUTERPARSE_ERROR_COMPUTING_DIGEST_6 2188
#define LANG_LOG_ROUTERPARSE_ERROR_TOKENIZING_NS 2189
#define LANG_LOG_ROUTERPARSE_NON_V2_NS 2190
#define LANG_LOG_ROUTERPARSE_INVALID_ADDRESS_4 2191
#define LANG_LOG_ROUTERPARSE_INVALID_PORT_4 2192
#define LANG_LOG_ROUTERPARSE_ERROR_DECODING_FINGERPRINT_2 2193
#define LANG_LOG_ROUTERPARSE_ERROR_COMPUTING_DIGEST_7 2194
#define LANG_LOG_ROUTERPARSE_FINGERPRINT_MISMATCH_2 2195
#define LANG_LOG_ROUTERPARSE_MISSING_CLIENT_VERSIONS 2196
#define LANG_LOG_ROUTERPARSE_MISSING_SERVER_VERSIONS 2197
#define LANG_LOG_ROUTERPARSE_ERROR_TOKENIZING_NS_2 2198
#define LANG_LOG_ROUTERPARSE_NS_ERROR 2199
#define LANG_LOG_ROUTERPARSE_NS_ERROR_2 2200
#define LANG_LOG_ROUTERPARSE_ERROR_TOKENIZING_NS_3 2201
#define LANG_LOG_ROUTERPARSE_INVALID_VOTE 2202
#define LANG_LOG_ROUTERPARSE_INVALID_NS 2203
#define LANG_LOG_ROUTERPARSE_VOTE_INTERVAL_TOO_SHORT 2204
#define LANG_LOG_ROUTERPARSE_VOTE_INTERVAL_TOO_SHORT_2 2205
#define LANG_LOG_ROUTERPARSE_VOTE_SECONDS_TOO_SHORT 2206
#define LANG_LOG_ROUTERPARSE_DIST_SECONDS_TOO_SHORT 2207
#define LANG_LOG_ROUTERPARSE_WRONG_FLAGS_ORDER 2208
#define LANG_LOG_ROUTERPARSE_BAD_ELEMENT_IN_PARAMS 2209
#define LANG_LOG_ROUTERPARSE_BAD_ELEMENT_IN_PARAMS_2 2210
#define LANG_LOG_ROUTERPARSE_WRONG_PARAMS_ORDER 2211
#define LANG_LOG_ROUTERPARSE_ERROR_DECODING_DIGEST_3 2212
#define LANG_LOG_ROUTERPARSE_DIGEST_MISMATCH_2 2213
#define LANG_LOG_ROUTERPARSE_INVALID_ADDRESS_5 2214
#define LANG_LOG_ROUTERPARSE_CONTACT_OUT_OF_PLACE 2215
#define LANG_LOG_ROUTERPARSE_VOTE_DIGEST_OUT_OF_PLACE 2216
#define LANG_LOG_ROUTERPARSE_ERROR_DECODING_DIGEST_4 2217
#define LANG_LOG_ROUTERPARSE_MISSING_DIR_SOURCE_ELEMENTS 2218
#define LANG_LOG_ROUTERPARSE_TOO_MANY_DIR_SOURCE_ELEMENTS 2219
#define LANG_LOG_ROUTERPARSE_INVALID_DIGEST 2220
#define LANG_LOG_ROUTERPARSE_VOTES_NOT_SORTED 2221
#define LANG_LOG_ROUTERPARSE_ERROR_TOKENIZING_NS_4 2222
#define LANG_LOG_ROUTERPARSE_BAD_OBJECT_TYPE 2223
#define LANG_LOG_ROUTERPARSE_ERROR_DECODING_DIGEST_5 2224
#define LANG_LOG_ROUTERPARSE_ID_MISMATCH 2225
#define LANG_LOG_ROUTERPARSE_ERROR_DECODING_DIGEST_6 2226
#define LANG_LOG_ROUTERPARSE_DIGEST_MISMATCH_3 2227
#define LANG_LOG_ROUTERPARSE_DUPLICATE_VOTES 2228
#define LANG_LOG_ROUTERPARSE_MISSING_SIGNATURES 2229
#define LANG_LOG_ROUTERPARSE_ERROR_TOKENIZING_NS_5 2230
#define LANG_LOG_ROUTERPARSE_INVALID_DIGEST_2 2231
#define LANG_LOG_ROUTERPARSE_INVALID_DIGEST_3 2232
#define LANG_LOG_ROUTERPARSE_INVALID_TIME_3 2233
#define LANG_LOG_ROUTERPARSE_INVALID_TIME_4 2234
#define LANG_LOG_ROUTERPARSE_INVALID_TIME_5 2235
#define LANG_LOG_ROUTERPARSE_INVALID_POLICY 2236
#define LANG_LOG_ROUTERPARSE_INVALID_POLICY_2 2237
#define LANG_LOG_ROUTERPARSE_INVALID_POLICY_3 2238
#define LANG_LOG_ROUTERPARSE_INVALID_POLICY_4 2239
#define LANG_LOG_ROUTERPARSE_ERROR_PARSING_LINE 2240
#define LANG_LOG_ROUTERPARSE_PARSE_ERROR 2241
#define LANG_LOG_ROUTERPARSE_PARSE_ERROR_2 2242
#define LANG_LOG_ROUTERPARSE_PARSE_ERROR_3 2243
#define LANG_LOG_ROUTERPARSE_PARSE_ERROR_4 2244
#define LANG_LOG_ROUTERPARSE_PARSE_ERROR_5 2245
#define LANG_LOG_ROUTERPARSE_PARSE_ERROR_6 2246
#define LANG_LOG_ROUTERPARSE_PARSE_ERROR_7 2247
#define LANG_LOG_ROUTERPARSE_PARSE_ERROR_8 2248
#define LANG_LOG_ROUTERPARSE_PARSE_ERROR_9 2249
#define LANG_LOG_ROUTERPARSE_INTERNAL_ERROR 2250
#define LANG_LOG_ROUTERPARSE_DIGEST_ERROR 2251
#define LANG_LOG_ROUTERPARSE_DIGEST_ERROR_2 2252
#define LANG_LOG_ROUTERPARSE_DIGEST_ERROR_3 2253
#define LANG_LOG_ROUTERPARSE_COULD_NOT_FIND_EOL 2254
#define LANG_LOG_ROUTERPARSE_CUTOFF_VERSION_UNPARSEABLE 2255
#define LANG_LOG_ROUTERPARSE_ROUTER_VERSION_UNPARSEABLE 2256
#define LANG_LOG_ROUTERPARSE_DESCR_ERROR 2257
#define LANG_LOG_ROUTERPARSE_ERROR_COMPUTING_DIGEST_8 2258
#define LANG_LOG_ROUTERPARSE_DIGEST_ERROR_4 2259
#define LANG_LOG_ROUTERPARSE_ERROR_TOKENIZING_DESC_3 2260
#define LANG_LOG_ROUTERPARSE_INVALID_DESC_ID 2261
#define LANG_LOG_ROUTERPARSE_INVALID_DESC_ID_2 2262
#define LANG_LOG_ROUTERPARSE_INVALID_DESC_VERSION 2263
#define LANG_LOG_ROUTERPARSE_INVALID_SECRED_ID 2264
#define LANG_LOG_ROUTERPARSE_INVALID_SECRED_ID_2 2265
#define LANG_LOG_ROUTERPARSE_INVALID_TIME_6 2266
#define LANG_LOG_ROUTERPARSE_BAD_OBJECT_TYPE_2 2267
#define LANG_LOG_ROUTERPARSE_DESC_ID_MISMATCH 2268
#define LANG_LOG_ROUTERPARSE_ENCRYPTED_INTRO_POINTS_TOO_SMALL 2269
#define LANG_LOG_ROUTERPARSE_ERROR_ENCRYPTING_SESSION_KEY 2270
#define LANG_LOG_ROUTERPARSE_ERROR_DECRYPTING_INTRO_POINT_STRING 2271
#define LANG_LOG_ROUTERPARSE_UNPARSEABLE_INTRO_POINTS 2272
#define LANG_LOG_ROUTERPARSE_ERROR_DECRYPTING_INTRO_POINTS 2273
#define LANG_LOG_ROUTERPARSE_ERROR_DECRYPTING_INTRO_POINTS_2 2274
#define LANG_LOG_ROUTERPARSE_ERROR_TOKENIZING_INTRO_POINT 2275
#define LANG_LOG_ROUTERPARSE_INTRO_POINT_TOO_SHORT 2276
#define LANG_LOG_ROUTERPARSE_INVALID_DIGEST_4 2277
#define LANG_LOG_ROUTERPARSE_INVALID_ADDRESS_6 2278
#define LANG_LOG_ROUTERPARSE_INTRO_POINT_NOT_IPV4 2279
#define LANG_LOG_ROUTERPARSE_INVALID_ONION_PORT 2280
#define LANG_LOG_ROUTERPARSE_ERROR_TOKENIZING_CLIENT_KEYS 2281
#define LANG_LOG_ROUTERPARSE_CLIENT_KEY_TOO_SHORT 2282
#define LANG_LOG_ROUTERPARSE_INVALID_CLIENT_NAME 2283
#define LANG_LOG_ROUTERPARSE_DUPLICATE_CLIENT_NAME 2284
#define LANG_LOG_ROUTERPARSE_INVALID_DESC_COOKIE 2285
#define LANG_LOG_ROUTERPARSE_INVALID_DESC_COOKIE_2 2286

#define LANG_LOG_ADDRESS_TOR_ADDR_IS_INTERNAL_CALLED_WITH_NON_IP 2287
#define LANG_LOG_ADDRESS_IP_TOO_LONG 2288
#define LANG_LOG_ADDRESS_INVALID_IPV6 2289
#define LANG_LOG_ADDRESS_INVALID_IP 2290
#define LANG_LOG_ADDRESS_INVALID_BIT_MASK 2291
#define LANG_LOG_ADDRESS_INVALID_IPV4_MASK 2292
#define LANG_LOG_ADDRESS_INVALID_MASK 2293
#define LANG_LOG_ADDRESS_INVALID_MASK_2 2294
#define LANG_LOG_ADDRESS_INVALID_MASK_3 2295
#define LANG_LOG_ADDRESS_INVALID_MASK_4 2296
#define LANG_LOG_ADDRESS_INVALID_PORT 2297
#define LANG_LOG_ADDRESS_INVALID_AF 2298
#define LANG_LOG_ADDRESS_ERROR_CREATING_SOCKET 2299
#define LANG_LOG_ADDRESS_CONNECT_FAILED 2300
#define LANG_LOG_ADDRESS_GETSOCKNAME_FAILED 2301
#define LANG_LOG_ADDRESS_INVALID_PORT_2 2302
#define LANG_LOG_ADDRESS_UNEXPECTED_PORT 2303
#define LANG_LOG_ADDRESS_LOOKUP_ERROR 2304
#define LANG_LOG_ADDRESS_INVALID_PORT_3 2305
#define LANG_LOG_ADDRESS_INVALID_PORT_RANGE 2306
#define LANG_LOG_ADDRESS_INVALID_BIT_MASK_2 2307
#define LANG_LOG_ADDRESS_INVALID_MASK_5 2308
#define LANG_LOG_ADDRESS_INVALID_MASK_6 2309

#define LANG_LOG_COMPAT_ERROR_OPENING_FILE 2310
#define LANG_LOG_COMPAT_FILE_IS_EMPTY 2311
#define LANG_LOG_COMPAT_COULD_NOT_MMAP_FILE 2312
#define LANG_LOG_COMPAT_UNEXPECTED_SOCKET 2313
#define LANG_LOG_COMPAT_ERROR_CLOSING_SOCKET 2314
#define LANG_LOG_COMPAT_SOCKET_COUNT_BELOW_ZERO 2315
#define LANG_LOG_COMPAT_DUPLICATE_HANDLE 2316
#define LANG_LOG_COMPAT_NO_GETRLIMIT 2317
#define LANG_LOG_COMPAT_TOO_MANY_FILE_DESCRIPTORS 2318
#define LANG_LOG_COMPAT_GETRLIMIT_ERROR 2319
#define LANG_LOG_COMPAT_TOO_MANY_FILE_DESCRIPTORS_2 2320
#define LANG_LOG_COMPAT_RAISING_MAX_FILE_DESCRIPTORS 2321
#define LANG_LOG_COMPAT_CHANGING_CONNLIMIT 2322
#define LANG_LOG_COMPAT_DROPPED_CONNECTION_LIMIT 2323
#define LANG_LOG_COMPAT_ERROR_SETTING_MAX_FILE_DESCRIPTORS 2324
#define LANG_LOG_COMPAT_CONNLIMIT_TOO_LOW 2325
#define LANG_LOG_COMPAT_SWITCHING_USERS 2326
#define LANG_LOG_COMPAT_USER_NOT_FOUND 2327
#define LANG_LOG_COMPAT_SYSTEM_TIME_ERROR 2328
#define LANG_LOG_COMPAT_GETTIMEOFDAY_FAILED 2329
#define LANG_LOG_COMPAT_ERROR_CREATING_MUTEX 2330
#define LANG_LOG_COMPAT_ERROR_LOCKING_MUTEX 2331
#define LANG_LOG_COMPAT_ERROR_UNLOCKING_MUTEX 2332
#define LANG_LOG_COMPAT_ERROR_DESTROYING_MUTEX 2333
#define LANG_LOG_COMPAT_ERROR_FREEING_CONDITION 2334
#define LANG_LOG_COMPAT_ERROR_ACQUIRING_MUTEX 2335
#define LANG_LOG_COMPAT_WSASTARTUP_ERROR 2336

#define LANG_LOG_CRYPTO_ERROR 2337
#define LANG_LOG_CRYPTO_ERROR_2 2338
#define LANG_LOG_CRYPTO_USING_OPENSSL 2339
#define LANG_LOG_CRYPTO_USING_OPENSSL_2 2340
#define LANG_LOG_CRYPTO_ALLOCATION_ERROR 2341
#define LANG_LOG_CRYPTO_SETTING_SYMMETRIC_KEY 2342
#define LANG_LOG_CRYPTO_GENERATING_RSA_KEY 2343
#define LANG_LOG_CRYPTO_ERROR_PARSING_PRIVATE_KEY 2344
#define LANG_LOG_CRYPTO_ERROR_READING_PRIVATE_KEY 2345
#define LANG_LOG_CRYPTO_WRITING_RSA_KEY 2346
#define LANG_LOG_CRYPTO_READING_PUBLIC_KEY 2347
#define LANG_LOG_CRYPTO_WRITING_PRIVATE_KEY 2348
#define LANG_LOG_CRYPTO_CHECKING_RSA_KEY 2349
#define LANG_LOG_CRYPTO_RSA_ENCRYPTION 2350
#define LANG_LOG_CRYPTO_CHECKING_RSA_SIGNATURE 2351
#define LANG_LOG_CRYPTO_INVALID_SIGNATURE 2352
#define LANG_LOG_CRYPTO_SIGNATURE_MISMATCH 2353
#define LANG_LOG_CRYPTO_GENERATING_RSA_SIGNATURE 2354
#define LANG_LOG_CRYPTO_ERROR_DECRYPTING_PUBLIC_KEY 2355
#define LANG_LOG_CRYPTO_NO_ROOM_FOR_SYMMETRIC_KEY 2356
#define LANG_LOG_CRYPTO_ENCODING_PUBLIC_KEY 2357
#define LANG_LOG_CRYPTO_DECODING_PUBLIC_KEY 2358
#define LANG_LOG_CRYPTO_CREATING_DH_OBJECT 2359
#define LANG_LOG_CRYPTO_GENERATING_DH_KEY 2360
#define LANG_LOG_CRYPTO_INVALID_DH_KEY 2361
#define LANG_LOG_CRYPTO_INVALID_DH_KEY_2 2362
#define LANG_LOG_CRYPTO_INVALID_DH_KEY_3 2363
#define LANG_LOG_CRYPTO_INVALID_DH_KEY_4 2364
#define LANG_LOG_CRYPTO_INSECURE_DH_KEY 2365
#define LANG_LOG_CRYPTO_INVALID_KEY 2366
#define LANG_LOG_CRYPTO_ERROR_CREATING_DH_KEY 2367
#define LANG_LOG_CRYPTO_COMPLETING_DH_HANDSHAKE 2368
#define LANG_LOG_CRYPTO_RAND_POLL_FAILED 2369
#define LANG_LOG_CRYPTO_CRYPTACQUIRECONTEXT_FAILED 2370
#define LANG_LOG_CRYPTO_ERROR_GETTING_ENTROPY 2371
#define LANG_LOG_CRYPTO_SEEDING_RNG 2372
#define LANG_LOG_CRYPTO_ERROR_READING_ENTROPY_SOURCE 2373
#define LANG_LOG_CRYPTO_ERROR_SEEDING_RNG 2374
#define LANG_LOG_CRYPTO_GENERATING_RANDOM_DATA 2375
#define LANG_LOG_CRYPTO_BASE32_ERROR 2376

#define LANG_LOG_LOG__DEBUG 2377
#define LANG_LOG_LOG__PROXY 2378
#define LANG_LOG_LOG__INFO 2379
#define LANG_LOG_LOG__NOTICE 2380
#define LANG_LOG_LOG__WARN 2381
#define LANG_LOG_LOG__ERROR 2382
#define LANG_LOG_LOG__UNKNOWN 2383
#define LANG_LOG_LOG_LIBEVENT 2384
#define LANG_LOG_LOG_LIBEVENT_2 2385
#define LANG_LOG_LOG_LIBEVENT_3 2386
#define LANG_LOG_LOG_LIBEVENT_4 2387

#define LANG_LOG_MEMPOOL_STATS 2388
#define LANG_LOG_MEMPOOL_STATS_2 2389
#define LANG_LOG_MEMPOOL_STATS_3 2390
#define LANG_LOG_MEMPOOL_STATS_4 2391
#define LANG_LOG_MEMPOOL_STATS_5 2392
#define LANG_LOG_MEMPOOL_STATS_6 2393
#define LANG_LOG_MEMPOOL_STATS_7 2394

#define LANG_LOG_GZIP_NOT_SUPPORTED 2395
#define LANG_LOG_GZIP_DEFLATEINIT2_ERROR 2396
#define LANG_LOG_GZIP__NO_MESSAGE 2397
#define LANG_LOG_GZIP_SIZE_OVERFLOW 2398
#define LANG_LOG_GZIP_SIZE_OVERFLOW_2 2399
#define LANG_LOG_GZIP_UNFINISHED 2400
#define LANG_LOG_GZIP_ERROR_FREEING_GZIP_STRUCTURES 2401
#define LANG_LOG_GZIP_INFLATEINIT2_ERROR 2402
#define LANG_LOG_GZIP_INFLATEINIT2_ERROR_2 2403
#define LANG_LOG_GZIP_CORRUPT_ZLIB_DATA 2404
#define LANG_LOG_GZIP_DECOMPRESSION_ERROR 2405
#define LANG_LOG_GZIP_ERROR 2406

#define LANG_LOG_TLS_ERROR 2407
#define LANG_LOG_TLS__WITH 2408
#define LANG_LOG_TLS_ERROR_2 2409
#define LANG_LOG_TLS_UNEXPECTED_CLOSE 2410
#define LANG_LOG_TLS_SYSCALL_ERROR 2411
#define LANG_LOG_TLS_CONNECTION_CLOSED 2412
#define LANG_LOG_TLS_OPENSSL 2413
#define LANG_LOG_TLS_OPENSSL_2 2414
#define LANG_LOG_TLS_OPENSSL_3 2415
#define LANG_LOG_TLS_TLSMAP 2416
#define LANG_LOG_TLS_GENERATING_CERT 2417
#define LANG_LOG_TLS_ERROR_CREATING_CERT 2418
#define LANG_LOG_TLS_CREATING_TLS_CONTEXT 2419
#define LANG_LOG_TLS_NO_SESSION 2420
#define LANG_LOG_TLS_NO_CIPHERS_ON_SESSION 2421
#define LANG_LOG_TLS_NON_V1_CIPHER 2422
#define LANG_LOG_TLS_NON_V1_CIPHER_2 2423
#define LANG_LOG_TLS_LOOKUP_ERROR 2424
#define LANG_LOG_TLS_LIST_WAS 2425
#define LANG_LOG_TLS_CIPHER 2426
#define LANG_LOG_TLS_SKIPPING_V2_CIPHER 2427
#define LANG_LOG_TLS_FOUND_CIPHER 2428
#define LANG_LOG_TLS_INSERTING_FAKE 2429
#define LANG_LOG_TLS_GENERATING_TLS_CONTEXT 2430
#define LANG_LOG_TLS_SETTING_CIPHERS 2431
#define LANG_LOG_TLS_OPENING_BIO 2432
#define LANG_LOG_TLS_BIO_STATS 2433
#define LANG_LOG_TLS_FREEING_TLS 2434
#define LANG_LOG_TLS_TLS_RENEGOTIATION 2435
#define LANG_LOG_TLS_TLS_CLOSED 2436
#define LANG_LOG_TLS_TLS_CLOSED_2 2437
#define LANG_LOG_TLS_RESUME 2438
#define LANG_LOG_TLS_WASV2HANDSHAKE_NOT_SET 2439
#define LANG_LOG_TLS_COMPLETED_V2_HANDSHAKE 2440
#define LANG_LOG_TLS_SINGLE_CERT 2441
#define LANG_LOG_TLS_RESETTING_CIPHERS 2442
#define LANG_LOG_TLS_READING_TO_SHUT_DOWN 2443
#define LANG_LOG_TLS_HALF_CLOSED 2444
#define LANG_LOG_TLS_GETTING_PEER_CERT 2445
#define LANG_LOG_TLS_TIME_SKEW 2446
#define LANG_LOG_TLS_BIO_ALLOCATION_ERROR 2447
#define LANG_LOG_TLS_CERT_LIFETIME 2448
#define LANG_LOG_TLS_CERT_LIFETIME_2 2449
#define LANG_LOG_TLS_GETTING_CERT_LIFETIME 2450
#define LANG_LOG_TLS_UNEXPECTED_NUMBER_OF_CERTS 2451
#define LANG_LOG_TLS_NO_CERT_FOUND 2452
#define LANG_LOG_TLS_CERT_ERROR 2453
#define LANG_LOG_TLS_FINISHING_TOR_TLS_VERIFY 2454
#define LANG_LOG_TLS__NOT_YET_VALID 2455
#define LANG_LOG_TLS__ALREADY_EXPIRED 2456
#define LANG_LOG_TLS_CHECKING_CERT_LIFETIME 2457
#define LANG_LOG_TLS_TOR_TLS_GET_N_RAW_BYTES 2458
#define LANG_LOG_TLS_OPENSSL_ERROR 2459

#define LANG_LOG_UTIL_OUT_OF_MEMORY 2460
#define LANG_LOG_UTIL_OUT_OF_MEMORY_2 2461
#define LANG_LOG_UTIL_OUT_OF_MEMORY_3 2462
#define LANG_LOG_UTIL_MALLINFO 2463
#define LANG_LOG_UTIL_TV_UDIFF 2464
#define LANG_LOG_UTIL_TIMEGM 2465
#define LANG_LOG_UTIL_INVALID_TIME 2466
#define LANG_LOG_UTIL_INVALID_TIME_2 2467
#define LANG_LOG_UTIL_INVALID_TIME_3 2468
#define LANG_LOG_UTIL_INVALID_TIME_4 2469
#define LANG_LOG_UTIL_INVALID_TIME_5 2470
#define LANG_LOG_UTIL_INVALID_TIME_6 2471
#define LANG_LOG_UTIL_ERROR_READING_DIR 2472
#define LANG_LOG_UTIL_ERROR_READING_DIR_2 2473
#define LANG_LOG_UTIL_CREATING_DIR 2474
#define LANG_LOG_UTIL_ERROR_CREATING_DIR 2475
#define LANG_LOG_UTIL_ERROR_READING_DIR_3 2476
#define LANG_LOG_UTIL_DUPLICATE_CR 2477
#define LANG_LOG_UTIL_ERROR_CREATING_FILE 2478
#define LANG_LOG_UTIL_ERROR_OPENING_FILE 2479
#define LANG_LOG_UTIL_SEEK_ERROR 2480
#define LANG_LOG_UTIL_ERROR_OPENING_FILE_2 2481
#define LANG_LOG_UTIL_ERROR_CLOSING_FILE 2482
#define LANG_LOG_UTIL_ERROR_FLUSHING_FILE 2483
#define LANG_LOG_UTIL_ERROR_REPLACING_FILE 2484
#define LANG_LOG_UTIL_ERROR_WRITING_FILE 2485
#define LANG_LOG_UTIL_ERROR_OPENING_FILE_3 2486
#define LANG_LOG_UTIL_FSTAT_ERROR 2487
#define LANG_LOG_UTIL_ERROR_READING_FILE 2488
#define LANG_LOG_UTIL_ERROR_CONVERTING_CRLF 2489
#define LANG_LOG_UTIL_ERROR_READING_FILE_2 2490
#define LANG_LOG_UTIL_ERROR_FINDING_HOME 2491
#define LANG_LOG_UTIL_ERROR_FINDING_HOME_2 2492
#define LANG_LOG_UTIL_PWD_H 2493
#define LANG_LOG_UTIL_PIPE_FAILED 2494
#define LANG_LOG_UTIL_FORK_FAILED 2495
#define LANG_LOG_UTIL_CHDIR_FAILED 2496
#define LANG_LOG_UTIL_DEV_NULL 2497
#define LANG_LOG_UTIL_DUP2_FAILED 2498
#define LANG_LOG_UTIL_WRITE_FAILED 2499
#define LANG_LOG_UTIL_ERROR_OPENING_FILE_4 2500
#define LANG_LOG_ROUTERLIST_NO_NS_CONSENSUS 2501
#define LANG_LOG_ROUTERLIST_NO_RECENT_NS_CONSENSUS 2502
#define LANG_LOG_ROUTERLIST_NO_LIVE_BRIDGE_DESCS 2503
#define LANG_LOG_ROUTERLIST_WE_HAVE_ONLY 2504
#define LANG_LOG_ROUTERLIST_REACHABLE_DESCS 2505
#define LANG_LOG_RSVD_01 2506
#define LANG_LOG_RSVD_02 2507
#define LANG_LOG_RSVD_03 2508
#define LANG_LOG_RSVD_04 2509
#define LANG_LOG_RSVD_05 2510

#define LANG_DLL_ERROR_1 2511
#define LANG_DLL_ERROR_2 2512
#define LANG_DLL_ERROR_3 2513
#define LANG_DLL_ERROR_4 2514
#define LANG_DLL_ERROR_5 2515
#define LANG_DLL_ERROR_6 2516
#define LANG_DLL_RESTRICTED_PROCESS 2517
#define LANG_DLL_CREATED_A_NEW_PROCESS 2518
#define LANG_DLL_RESOLVE 2519
#define LANG_DLL_REVDNS 2520
#define LANG_DLL_WPAD 2521
#define LANG_DLL_NON_TCP 2522
#define LANG_DLL_NON_TCP_2 2523
#define LANG_DLL_REDIRECTING 2524
#define LANG_DLL_PROC_COL1 2525
#define LANG_DLL_PROC_COL2 2526
#define LANG_DLL_PROTECTING 2527
#define LANG_DLL_UNPROTECTING 2528
#define LANG_DLL_PIPEINUSE 2529

#define LANG_MNU_FILTER 2530
#define LANG_MNU_TRACK_EXIT 2531
#define LANG_MNU_TRACK_EXIT_1 2532
#define LANG_MNU_REMEMBER_EXIT 2533
#define LANG_MNU_FORGET_EXIT 2534
#define LANG_MNU_BAN_HOST 2535

#define LANG_BRIDGES_MSG_ENABLE 2536
#define LANG_BRIDGES_GET_NEW 2537
#define LANG_BRIDGES_USE_BRIDGES 2538
#define LANG_BRIDGES_TUNNEL_DIR_CONNS 2539
#define LANG_BRIDGES_AVOID_DIRS 2540
#define LANG_BRIDGES_HTTP_PROXY 2541
#define LANG_BRIDGES_HTTPS_PROXY 2542
#define LANG_BRIDGES_PROXY_ACCOUNT 2543
#define LANG_BRIDGES_WININET 2544
#define LANG_BRIDGES_DOWNLOAD_OK 2545
#define LANG_BRIDGES_DOWNLOAD 2546
#define LANG_BRIDGES_NO_BRIDGES 2547

#define LANG_DLG_HS_SELECT_A_SERVICE 2548
#define LANG_DLG_HS_SELECT_PROCESS 2549
#define LANG_DLG_HS_SELECT_PORT_ 2550
#define LANG_DLG_HS_CANCEL 2551
#define LANG_DLG_HS_APPLICATION 2552
#define LANG_DLG_HS_LOCAL_ADDRESS 2553
#define LANG_DLG_HS_LOCAL_PORT 2554

#define LANG_LOG_CONNECTION_BANNED_EXIT 2555

#define LANG_MNU_DUMP_STATS 2556

#define LANG_NETINFO_CIRCUIT_LIST 2557
#define LANG_NETINFO_SELECTION_DETAILS 2558
#define LANG_NETINFO_DESTROY_CIRCUIT 2559
#define LANG_NETINFO_NEW_CIRCUIT 2560
#define LANG_NETINFO_CLOSE_CONNECTION 2561
#define LANG_NETINFO_KILL_PROCESS 2562
#define LANG_NETINFO_TRAFFIC 2563
#define LANG_NETINFO_TRAFFIC_DOWNLOAD 2564
#define LANG_NETINFO_TRAFFIC_UPLOAD 2565
#define LANG_NETINFO_TOTALS 2566
#define LANG_NETINFO_TOTALS_DOWNLOAD 2567
#define LANG_NETINFO_TOTALS_UPLOAD 2568
#define LANG_NETINFO_BUILD_CIRCUIT 2569
#define LANG_NETINFO_ESTIMATED_LIST 2570
#define LANG_NETINFO_CIRCUIT_LENGTH 2571
#define LANG_NETINFO_ESTIMATE_NEW 2572
#define LANG_NETINFO_BUILD_OK 2573
#define LANG_NETINFO_BUILD_CANCEL 2574
#define LANG_NETINFO_CIRCUIT_DUMP 2575
#define LANG_NETINFO_CIRCUIT_DUMP_2 2576
#define LANG_NETINFO_HOP_STATE 2577
#define LANG_NETINFO_HOP_STATE_CLOSED 2578
#define LANG_NETINFO_HOP_STATE_AWAITING_KEYS 2579
#define LANG_NETINFO_HOP_STATE_OPEN 2580
#define LANG_NETINFO_HOP_STATE_UNKNOWN 2581
#define LANG_NETINFO_HOP_ADDRESS 2582
#define LANG_NETINFO_HOP_DIGEST 2583
#define LANG_NETINFO_ROUTER_NAME 2584
#define LANG_NETINFO_ROUTER_FAMILY 2585
#define LANG_NETINFO_ROUTER_PURPOSE 2586
#define LANG_NETINFO_ROUTER_PUBLISHED 2587
#define LANG_NETINFO_ROUTER_PLATFORM 2588
#define LANG_NETINFO_ROUTER_BW_RATE 2589
#define LANG_NETINFO_ROUTER_BW_BURST 2590
#define LANG_NETINFO_ROUTER_BW_CAPACITY 2591
#define LANG_NETINFO_ROUTER_UPTIME 2592
#define LANG_NETINFO_ROUTER_UPTIME_DAYS 2593
#define LANG_NETINFO_ROUTER_UPTIME_HOURS 2594
#define LANG_NETINFO_ROUTER_UPTIME_MINUTES 2595
#define LANG_NETINFO_ROUTER_UPTIME_SECONDS 2596
#define LANG_NETINFO_ROUTER_LOW_UPTIME 2597
#define LANG_NETINFO_ROUTER_LAST_TIME_REACHED 2598
#define LANG_NETINFO_ROUTER_REACHABILITY_TEST_SINCE 2599
#define LANG_NETINFO_ROUTER_CONTACT_INFO 2600
#define LANG_NETINFO_ROUTER_IS_HIBERNATING 2601
#define LANG_NETINFO_ROUTER_SERVES_EXTRAINFO 2602
#define LANG_NETINFO_ROUTER_ALLOWS_SINGLE_HOP_EXIT 2603
#define LANG_NETINFO_ROUTER_IS_RUNNING 2604
#define LANG_NETINFO_ROUTER_VALIDATED 2605
#define LANG_NETINFO_ROUTER_NOT_VALIDATED 2606
#define LANG_NETINFO_ROUTER_INVALID_NICKNAME 2607
#define LANG_NETINFO_ROUTER_IS_FAST 2608
#define LANG_NETINFO_ROUTER_IS_STABLE 2609
#define LANG_NETINFO_ROUTER_CAN_BE_ENTRY_GUARD 2610
#define LANG_NETINFO_ROUTER_CAN_BE_EXIT 2611
#define LANG_NETINFO_ROUTER_IS_BAD_EXIT 2612
#define LANG_NETINFO_ROUTER_IS_BAD_DIR 2613
#define LANG_NETINFO_ROUTER_HS_DIR 2614
#define LANG_NETINFO_ROUTER_HS_DIR_OK 2615
#define LANG_NETINFO_ROUTER_NOT_HS_DIR 2616
#define LANG_NETINFO_ROUTER_IS_HS_DIR 2617
#define LANG_NETINFO_ROUTER_POLICY_REJECTS_EVERYTHING 2618
#define LANG_NETINFO_ROUTER_EXIT_POLICY 2619
#define LANG_NETINFO_CONNECTION_TYPE 2620
#define LANG_NETINFO_CONNECTION_TYPE_BASE 2621
#define LANG_NETINFO_CONNECTION_TYPE_OR 2622
#define LANG_NETINFO_CONNECTION_TYPE_EDGE 2623
#define LANG_NETINFO_CONNECTION_TYPE_DIR 2624
#define LANG_NETINFO_CONNECTION_TYPE_CONTROL 2625
#define LANG_NETINFO_CONNECTION_TYPE_UNKNOWN 2626
#define LANG_NETINFO_CONNECTION_STATE 2627
#define LANG_NETINFO_CONNECTION_PURPOSE 2628
#define LANG_NETINFO_CONNECTION_PURPOSE_CONNECT 2629
#define LANG_NETINFO_CONNECTION_PURPOSE_RESOLVE 2630
#define LANG_NETINFO_CONNECTION_TIME_CREATED 2631
#define LANG_NETINFO_CONNECTION_LAST_READ_TIME 2632
#define LANG_NETINFO_CONNECTION_LAST_WRITE_TIME 2633
#define LANG_NETINFO_CONNECTION_ADDRESS 2634
#define LANG_NETINFO_CONNECTION_TIME_CLIENT 2635
#define LANG_NETINFO_CONNECTION_ACTUAL_ADDRESS 2636
#define LANG_NETINFO_CONNECTION_TOO_OLD 2637
#define LANG_NETINFO_CONNECTION_CHOSEN_EXIT 2638
#define LANG_NETINFO_CONNECTION_PID 2639
#define LANG_NETINFO_SOCKS_ADDRESS 2640
#define LANG_NETINFO_SOCKS_FINAL_ADDRESS 2641
#define LANG_NETINFO_SOCKS_LAST_REQUEST 2642
#define LANG_NETINFO_SOCKS_REQUEST_CONNECT 2643
#define LANG_NETINFO_SOCKS_REQUEST_RESOLVE 2644
#define LANG_NETINFO_SOCKS_REQUEST_NAME 2645
#define LANG_NETINFO_SOCKS_REQUEST_SELECT 2646
#define LANG_NETINFO_SOCKS_REQUEST_UNKNOWN 2647
#define LANG_NETINFO_CONNECTION_BYTES_READ 2648
#define LANG_NETINFO_CONNECTION_BYTES_WRITTEN 2649
#define LANG_NETINFO_CONNECTION_ONE_HOP 2650
#define LANG_NETINFO_CONNECTION_OPTIONAL_EXIT 2651
#define LANG_NETINFO_CONNECTION_TRACKED_EXIT 2652
#define LANG_NETINFO_DIR_REQUEST 2653
#define LANG_NETINFO_DIR_CONNECTED_VIA_TOR 2654
#define LANG_NETINFO_ROUTER_PURPOSE_2 2655
#define LANG_NETINFO_BUILD_ESTIMATE_FAILED 2656
#define LANG_NETINFO_BUILD_ESTIMATE_PATH 2657
#define LANG_NETINFO_BANNED_ROUTER 2658
#define LANG_NETINFO_ROUTER_IN_BANLIST 2659
#define LANG_NETINFO_ROUTER_NOT_FOUND 2660
#define LANG_NETINFO_ROUTER_NOT_FOUND_TITLE 2661
#define LANG_NETINFO_ERROR_OPENING_PROCESS 2662
#define LANG_NETINFO_PID_NOT_FOUND 2663

#define LANG_HS_USE_EXISTING 2664
#define LANG_HS_ADDRESS 2665
#define LANG_HS_PRIVATE_KEY 2666
#define LANG_HS_OK 2667
#define LANG_HS_CANCEL 2668

#define LANG_DLG_MAXIMUM_PREDICTED_CIRCS 2669
#define LANG_LOG_CONTROL_BS_STARTED 2670
#define LANG_MNU_STOP_TOR 2671

#define LANG_LOG_SELECT_ROUTER 2672
#define LANG_LOG_SELECT_RANDOM_ROUTER 2673
#define LANG_LOG_SELECT_NOEXIT 2674
#define LANG_LOG_SELECT_COUNTRY 2675
#define LANG_LOG_SELECT_RANDOM_COUNTRY 2676

#define LANG_DLG_PRIORITY 2677

#define LANG_MNU_BAN_ENTRY 2678
#define LANG_MNU_BAN_EXIT 2679
#define LANG_MNU_MARK_INVALID 2680
#define LANG_MNU_FAV_ENTRY 2681
#define LANG_MNU_FAV_EXIT 2682
#define LANG_MNU_KILL_PROCESS 2683
#define LANG_MB_INVD_TITLE 2684
#define LANG_MB_ALREADY_INVALID 2685
#define LANG_MB_SET_INVALID 2686

#define LANG_LOG_REASONS__NOROUTE 2687

#define LANG_DLL_REINTERCEPT 2688
#define LANG_DLL_JUNKDATA 2689
#define LANG_DLL_CONNECTIONS_1 2690
#define LANG_DLL_CONNECTIONS_2 2691
#define LANG_LOG_BUFFERS_FROM_HTTP_HOST 2692

#define LANG_NETINFO_EXCL_KEY 2693

#define LANG_EXIT_DLG_CLOSE_CONN 2694
#define LANG_EXIT_DLG_EXPIRE_HOSTS 2695

#define LANG_PLUGINS_RESCAN 2696
#define LANG_PLUGINS_REMOVE 2697
#define LANG_PLUGINS_RELOAD 2698
#define LANG_PLUGINS_UNLOAD 2699
#define LANG_PLUGINS_RIGHTS 2700
#define LANG_PLUGINS_LIST_DLL 2701
#define LANG_PLUGINS_LIST_STATUS 2702
#define LANG_PLUGINS_LIST_DESCRIPTION 2703
#define LANG_PLUGINS_LOAD_ERROR 2704
#define LANG_PLUGINS_INIT_ERROR_1 2705
#define LANG_PLUGINS_INIT_ERROR_2 2706
#define LANG_PLUGINS_STATUS_LOADED 2707
#define LANG_PLUGINS_STATUS_ERROR 2708
#define LANG_PLUGINS_STATUS_DISABLED 2709
#define LANG_PLUGINS_STATUS_UNKNOWN 2710
#define LANG_PLUGINS_NO_DIR 2711
#define LANG_PLUGINS_NO_DIR_2 2712
#define LANG_PLUGINS_UNLOADING 2713
#define LANG_PLUGINS_PLUGIN 2714
#define LANG_PLUGINS_BANNED 2715
#define LANG_PLUGINS_RIGHTS_TITLE 2716
#define LANG_PLUGINS_RIGHTS_CONFIG 2717
#define LANG_PLUGINS_RIGHTS_SETTINGS 2718
#define LANG_PLUGINS_RIGHTS_TRAFFIC 2719
#define LANG_PLUGINS_RIGHTS_ADDRMAP 2720
#define LANG_PLUGINS_RIGHTS_CONNECTIONS 2721
#define LANG_PLUGINS_RIGHTS_ACCEPT 2722
#define LANG_PLUGINS_RIGHTS_HS 2723
#define LANG_PLUGINS_RIGHTS_INTERCEPT 2724
#define LANG_PLUGINS_RIGHTS_OK 2725
#define LANG_PLUGINS_RIGHTS_CANCEL 2726

#define LANG_COLUMN_EXIT_5 2727

#define LANG_NETINFO_NEW_ENTRY 2728
#define LANG_NETINFO_INSERT_NODE 2729
#define LANG_NETINFO_NEW_EXIT 2730

#define LANG_LOG_GZIP_ZLIB_BOMB 2731
#define LANG_LOG_GZIP_SIZE_T_CEILING 2732
#define LANG_LOG_GZIP_ZLIB_LIMIT 2733
#define LANG_LOG_GZIP_POSSIBLE_ZLIB_BOMB 2734
#define LANG_LOG_EDGE_UNABLE_TO_AUTOMAP 2735

#define LANG_PLUGINS_EXCLUSIVITY_RESERVED 2736
#define LANG_FILTERS_TITLE 2737

#define LANG_EXIT_DLG_CONSECUTIVE_EXITS 2738
#define LANG_DLG_SYSTEM_HOTKEYS 2739
#define LANG_DLG_SYSTEM_HOTKEY_RESTORE 2740
#define LANG_DLG_SYSTEM_HOTKEY_NEW_IDENTITY 2741
#define LANG_DLG_SYSTEM_HOTKEY_INTERCEPT 2742
#define LANG_DLG_SYSTEM_HOTKEY_RELEASE 2743

#define LANG_LOG_DLG_HOTKEY_RESTORE_UNREGISTER 2744
#define LANG_LOG_DLG_HOTKEY_NEW_IDENTITY_UNREGISTER 2745
#define LANG_LOG_DLG_HOTKEY_INTERCEPT_UNREGISTER 2746
#define LANG_LOG_DLG_HOTKEY_RELEASE_UNREGISTER 2747
#define LANG_LOG_DLG_HOTKEY_RESTORE_UNREGISTER_FAIL 2748
#define LANG_LOG_DLG_HOTKEY_NEW_IDENTITY_UNREGISTER_FAIL 2749
#define LANG_LOG_DLG_HOTKEY_INTERCEPT_UNREGISTER_FAIL 2750
#define LANG_LOG_DLG_HOTKEY_RELEASE_UNREGISTER_FAIL 2751
#define LANG_LOG_DLG_HOTKEY_RESTORE_SUCCESS 2752
#define LANG_LOG_DLG_HOTKEY_NEW_IDENTITY_SUCCESS 2753
#define LANG_LOG_DLG_HOTKEY_INTERCEPT_SUCCESS 2754
#define LANG_LOG_DLG_HOTKEY_RELEASE_SUCCESS 2755
#define LANG_LOG_DLG_HOTKEY_RESTORE_FAIL 2756
#define LANG_LOG_DLG_HOTKEY_NEW_IDENTITY_FAIL 2757
#define LANG_LOG_DLG_HOTKEY_INTERCEPT_FAIL 2758
#define LANG_LOG_DLG_HOTKEY_RELEASE_FAIL 2759

#define LANG_MB_ALREADY_INTERCEPTED 2760
#define LANG_MB_INTERCEPT_SUCCESS 2761
#define LANG_MB_INTERCEPT_FAIL 2762

#define LANG_LOG_DIR_CERT_TOO_BIG 2763

#define LANG_NETINFO_AS_PATH 2764
#define LANG_DLG_ESTIMATE_AS_PATHS 2765
#define LANG_LOG_ASPATH_FAIL 2766

#define LANG_DLG_CONFIRM_CONNECTIONS 2767
#define LANG_DLG_CONFIRM_EXIT 2768
#define LANG_DLG_CONFIRM_EXIT_RELEASE 2769

#define LANG_DLG_CONFIRM_EXIT_1 2770
#define LANG_DLG_CONFIRM_EXIT_2 2771
#define LANG_DLG_CONFIRM_EXIT_3 2772
#define LANG_DLG_CONFIRM_ALWAYS 2773
#define LANG_DLG_CONFIRM_YES 2774
#define LANG_DLG_CONFIRM_NO 2775

#define LANG_DLG_CIRCUIT_BUILD_BANDWIDTH 2776
#define LANG_DLG_NOT_CONNECTED 2777

#define LANG_NETINFO_CIRC_PRIORITY 2778
#define LANG_NETINFO_CIRC_PRIORITY_HIGH 2779
#define LANG_NETINFO_CIRC_PRIORITY_NORMAL 2780
#define LANG_NETINFO_CIRC_PRIORITY_LOW 2781
#define LANG_NETINFO_CIRC_AVAILABILITY 2782
#define LANG_NETINFO_CIRC_AVAILABILITY_ALWAYS 2783
#define LANG_NETINFO_CIRC_AVAILABILITY_NORMAL 2784
#define LANG_NETINFO_CIRC_AVAILABILITY_EXPIRED 2785
#define LANG_NETINFO_CIRC_AVAILABILITY_NOT_SET 2786

#define LANG_SYSTEM_ENCRYPT 2787
#define LANG_SYSTEM_NEW_PASS 2788
#define LANG_SYSTEM_PASS_PROMPT 2789
#define LANG_SYSTEM_PASSWORD 2790
#define LANG_SYSTEM_ENTER_PASSWORD 2791
#define LANG_SYSTEM_USE_PASSWORD 2792
#define LANG_SYSTEM_REENTER 2793
#define LANG_SYSTEM_KEYFILE 2794
#define LANG_SYSTEM_FILE_OFFSET 2795
#define LANG_SYSTEM_PASSWORD_OK 2796
#define LANG_SYSTEM_PASSWORD_CANCEL 2797
#define LANG_SYSTEM_REENTER_ERROR 2798

#define LANG_LB_ADVANCED_PROXY_SETTINGS 2799
#define LANG_LB_BANNED_ROUTERS 2800
#define LANG_LB_FAVORITE_ROUTERS 2801
#define LANG_LB_CIRCUIT_BUILD 2802
#define LANG_LB_TRACKED_HOSTS 2803
#define LANG_LB_PRIVATE_IDENTITY 2804
#define LANG_LB_INTERCEPT 2805
#define LANG_LB_QUICK_START 2806
#define LANG_LB_PROCESSES 2807
#define LANG_LB_SANDBOXING 2808
#define LANG_LB_FILTERS 2809

#define LANG_DLG_PROXY_SETTINGS 2810
#define LANG_DLG_PROXY_PROTOCOLS 2811
#define LANG_DLG_PROXY_PROTOCOLS_LIST 2812
#define LANG_DLG_PROXY_WARN 2813
#define LANG_DLG_PROXY_RUN 2814
#define LANG_DLG_PROXY_RUN_BTN 2815
#define LANG_DLG_PROXY_SELECT_WINDOW 2816
#define LANG_DLG_PROXY_START 2817

#define LANG_DLG_ADDRMAP_FORMAT 2818
#define LANG_DLG_TRACKED_HOSTS_HINT 2819

#define LANG_DLG_HOSTED_SERVICES 2820

#define LANG_DLG_IDENTITY_EVENTS 2821
#define LANG_DLG_IDENTITY_SEEDS 2822
#define LANG_DLG_IDENTITY_SEEDS_HINT 2823
#define LANG_DLG_IDENTITY_CLOSE_CONNECTIONS 2824
#define LANG_DLG_IDENTITY_CLOSE_CONNECTIONS_HINT 2825
#define LANG_DLG_IDENTITY_EXPIRE_CIRCUITS 2826
#define LANG_DLG_IDENTITY_EXPIRE_CIRCUITS_HINT 2827
#define LANG_DLG_IDENTITY_EXPIRE_ADDRESSMAPS 2828
#define LANG_DLG_IDENTITY_EXPIRE_ADDRESSMAPS_HINT 2829
#define LANG_DLG_IDENTITY_EXPIRE_HTTP_COOKIES 2830
#define LANG_DLG_IDENTITY_EXPIRE_HTTP_COOKIES_HINT 2831
#define LANG_DLG_IDENTITY_DELETE_FLASH_COOKIES 2832
#define LANG_DLG_IDENTITY_DELETE_FLASH_COOKIES_HINT 2833
#define LANG_DLG_IDENTITY_CLEAR_SILVERLIGHT_COOKIES 2834
#define LANG_DLG_IDENTITY_CLEAR_SILVERLIGHT_COOKIES_HINT 2835
#define LANG_DLG_IDENTITY_RANDOMIZE_WMPLAYER_ID 2836
#define LANG_DLG_IDENTITY_RANDOMIZE_WMPLAYER_ID_HINT 2837

#define LANG_DLG_INTERCEPT 2838
#define LANG_DLG_PROCESSES 2839

#define LANG_DLG_QUICKSTART_HINT 2840
#define LANG_DLG_QUICKSTART_ADD 2841
#define LANG_DLG_QUICKSTART_RUN 2842
#define LANG_DLG_QUICKSTART_MODIFY 2843
#define LANG_DLG_QUICKSTART_MOVE_UP 2844
#define LANG_DLG_QUICKSTART_MOVE_DOWN 2845
#define LANG_DLG_QUICKSTART_DELETE 2846

#define LANG_DLG_SANDBOXING_HINT 2847
#define LANG_DLG_SANDBOXING_LOCAL_ADDRESS_HINT 2848
#define LANG_DLG_SANDBOXING_LOCAL_TIME_HINT 2849
#define LANG_DLG_SANDBOXING_FAKE_IPS_HINT 2850
#define LANG_DLG_SANDBOXING_NON_TCP_HINT 2851
#define LANG_DLG_SANDBOXING_EXCLUSIVE_EXIT_HINT 2852
#define LANG_DLG_SANDBOXING_PROCESS_ICON_HINT 2853

#define LANG_COLUMN_INTERCEPT_1 2854
#define LANG_COLUMN_INTERCEPT_2 2855
#define LANG_MB_NO_SELECTION 2856

#define LANG_IDENTITY_REGISTRY_ERROR 2857
#define LANG_IDENTITY_WMPLAYER_ID 2858
#define LANG_IDENTITY_WMPLAYER_ID_SAVED 2859
#define LANG_IDENTITY_WMPLAYER_ID_CHANGED 2860
#define LANG_IDENTITY_DELETING_FILE 2861
#define LANG_IDENTITY_INTERFACE 2862
#define LANG_IDENTITY_FLASH_COOKIES_DELETED 2863
#define LANG_IDENTITY_FLASH_WEBSITES_DELETED 2864
#define LANG_IDENTITY_FLASH_HISTORY_DELETED 2865
#define LANG_IDENTITY_FLASH_CACHED_ITEMS_DELETED 2866
#define LANG_IDENTITY_COOKIES_DELETED 2867
#define LANG_IDENTITY_DOM_COOKIES_DELETED 2868
#define LANG_IDENTITY_COOKIE_DBS_DELETED 2869
#define LANG_IDENTITY_SILVERLIGHT_COOKIES_DELETED 2870
#define LANG_IDENTITY_IE_COOKIES_DELETED_1 2871
#define LANG_IDENTITY_OPERA_COOKIES_DELETED_1 2872
#define LANG_IDENTITY_FIREFOX_COOKIES_DELETED_1 2873
#define LANG_IDENTITY_SAFARI_COOKIES_DELETED_1 2874

#define LANG_BRIDGES_ALLOW_INVALID_CA 2875

#define LANG_DLG_HTTP_BROWSER_TYPE 2876
#define LANG_DLG_HTTP_BROWSER_VERSION 2877
#define LANG_DLG_HTTP_BROWSER_OS 2878
#define LANG_DLG_HTTP_BROWSER_EXTENSIONS 2879
#define LANG_DLG_HTTP_REGIONAL_SETTINGS 2880
#define LANG_DLG_HTTP_REFERERS_SAME_DOMAIN 2881
#define LANG_DLG_HTTP_REJECT_EXITNAME 2882
#define LANG_DLG_HTTP_REJECT_ONION 2883
#define LANG_DLG_HTTP_REMOVE_ETAGS 2884
#define LANG_DLG_HTTP_REMOVE_IFS 2885
#define LANG_DLG_HTTP_REMOVE_DANGEROUS_HEADERS 2886
#define LANG_DLG_HTTP_REMOVE_UNKNOWN_HEADERS 2887
#define LANG_DLG_HTTP_REMOVE_HEADERS 2888
#define LANG_DLG_HTTP_DEBUG_MESSAGES 2889
#define LANG_DLG_HTTP_LOG_REQUESTS 2890
#define LANG_DLG_HTTP_LOG_REQUEST_HEADERS 2891
#define LANG_DLG_HTTP_LOG_RESPONSE_STATUS 2892
#define LANG_DLG_HTTP_LOG_RESPONSE_TRAFFIC 2893

#define LANG_DLG_HTTP_BROWSER_TYPE_ORIGINAL 2894
#define LANG_DLG_HTTP_BROWSER_TYPE_IDENTITY 2895
#define LANG_DLG_HTTP_BROWSER_TYPE_CHROME 2896
#define LANG_DLG_HTTP_BROWSER_TYPE_FIREFOX 2897
#define LANG_DLG_HTTP_BROWSER_TYPE_IE 2898
#define LANG_DLG_HTTP_BROWSER_TYPE_OPERA 2899
#define LANG_DLG_HTTP_BROWSER_TYPE_SAFARI 2900
#define LANG_DLG_HTTP_BROWSER_TYPE_BING 2901
#define LANG_DLG_HTTP_BROWSER_TYPE_GOOGLE 2902
#define LANG_DLG_HTTP_BROWSER_TYPE_YAHOO 2903
#define LANG_DLG_HTTP_BROWSER_TYPE_YANDEX 2904

#define LANG_DLG_HTTP_BROWSER_VERSION_ORIGINAL 2905
#define LANG_DLG_HTTP_BROWSER_VERSION_IDENTITY_MINOR 2906
#define LANG_DLG_HTTP_BROWSER_VERSION_IDENTITY_MAJOR 2907

#define LANG_DLG_HTTP_BROWSER_OS_ORIGINAL 2908
#define LANG_DLG_HTTP_BROWSER_OS_ANY 2909
#define LANG_DLG_HTTP_BROWSER_OS_WINDOWS 2910
#define LANG_DLG_HTTP_BROWSER_OS_LINUX 2911
#define LANG_DLG_HTTP_BROWSER_OS_OSX 2912

#define LANG_DLG_HTTP_BROWSER_EXTENSIONS_EXISTING 2913
#define LANG_DLG_HTTP_BROWSER_EXTENSIONS_HIDE_ALL 2914
#define LANG_DLG_HTTP_BROWSER_EXTENSIONS_IDENTITY 2915

#define LANG_DLG_HTTP_REGIONAL_SETTINGS_ORIGINAL 2916
#define LANG_DLG_HTTP_REGIONAL_SETTINGS_US_ENGLISH 2917
#define LANG_DLG_HTTP_REGIONAL_SETTINGS_IDENTITY 2918

#define LANG_LOG_HTTP_REQUEST_HEADERS 2919
#define LANG_LOG_HTTP_REQUEST_MODIFIED 2920
#define LANG_LOG_HTTP_REQUEST_RESOURCE 2921
#define LANG_LOG_HTTP_RESPONSE_TRAFFIC 2922
#define LANG_LOG_HTTP_RESPONSE_HEADERS 2923
#define LANG_LOG_HTTP_RESPONSE_STATUS 2924
#define LANG_LOG_HTTP_UNRECOGNIZED_HEADERS 2925
#define LANG_LOG_HTTP_DANGEROUS_HEADERS 2926
#define LANG_LOG_HTTP_SENT_TRAFFIC 2927

#define LANG_DLG_IDENTITY_EXPIRE_COOKIES 2928
#define LANG_DLG_IDENTITY_EXPIRE_COOKIES_HINT 2929

#define LANG_DLG_HTTP_BROWSER_TYPE_UTORRENT 2930

#define LANG_LOG_COMPAT_ASPRINTF_ERROR 2931
#define LANG_LOG_COMPAT_INCORRECT_TM_ROUND_UP_TO_1970 2932
#define LANG_LOG_COMPAT_INCORRECT_TM_ROUND_DOWN_TO_2037 2933
#define LANG_LOG_COMPAT_INCORRECT_TM_CANT_RECOVER 2934
#define LANG_LOG_CRYPTO_ERROR_DUPLICATING_KEY 2935
#define LANG_LOG_CRYPTO_UNKNOWN_DIGEST_ALGORITHM 2936
#define LANG_LOG_GZIP_HIGH_COMPRESSION 2937
#define LANG_LOG_BUFFERS_SKIP_CHUNKS 2938
#define LANG_LOG_BUFFERS_FREELIST_LENGTH 2939
#define LANG_LOG_CIRCUITBUILD_LEARNED_BRIDGE_FINGERPRINT 2940
#define LANG_LOG_CIRCUITBUILD_BRIDGE_EXCLUDED 2941
#define LANG_LOG_CIRCUITBUILD_BRIDGE_ADJUSTED 2942
#define LANG_LOG_CIRCUITBUILD_BUILDTIME_DISABLED 2943
#define LANG_LOG_CIRCUITBUILD_CBTCLOSEQUANTILE_TOO_SMALL 2944
#define LANG_LOG_CIRCUITBUILD_CBTINITIALTIMEOUT_TOO_SMALL 2945
#define LANG_LOG_CIRCUITBUILD_BUILDTIME_CONSENSUS_CHANGED 2946
#define LANG_LOG_CIRCUITBUILD_TIMEOUT_TOO_LOW 2947
#define LANG_LOG_CIRCUITBUILD_REWOUND_HISTORY 2948
#define LANG_LOG_CIRCUITBUILD_BUILD_TIME_TOO_LARGE 2949
#define LANG_LOG_CIRCUITBUILD_ADDING_BUILD_TIME 2950
#define LANG_LOG_CIRCUITBUILD_NO_TIMES_LESS_THAN_MAX 2951
#define LANG_LOG_CIRCUITBUILD_XM_MODE 2952
#define LANG_LOG_CIRCUITBUILD_TIMES_COUNT_1 2953
#define LANG_LOG_CIRCUITBUILD_TIMES_COUNT_2 2954
#define LANG_LOG_CIRCUITBUILD_REPLACED_TIMEOUT 2955
#define LANG_LOG_CIRCUITBUILD_TIMEOUTS_FILTERED 2956
#define LANG_LOG_CIRCUITBUILD_PARSE_ERROR_1 2957
#define LANG_LOG_CIRCUITBUILD_PARSE_ERROR_2 2958
#define LANG_LOG_CIRCUITBUILD_PARSE_ERROR_3 2959
#define LANG_LOG_CIRCUITBUILD_PARSE_ERROR_4 2960
#define LANG_LOG_CIRCUITBUILD_PARSE_SUCCESS 2961
#define LANG_LOG_CIRCUITBUILD_CORRUPT_STATE_FILE_1 2962
#define LANG_LOG_CIRCUITBUILD_CORRUPT_STATE_FILE_2 2963
#define LANG_LOG_CIRCUITBUILD_HISTOGRAM_LOADED 2964
#define LANG_LOG_CIRCUITBUILD_DISCREPANCY 2965
#define LANG_LOG_CIRCUITBUILD_NO_LARGEST_BUILD_TIME 2966
#define LANG_LOG_CIRCUITBUILD_RESTORING_RECORDING 2967
#define LANG_LOG_CIRCUITBUILD_HOP_COMPLETED 2968
#define LANG_LOG_CIRCUITBUILD_DISABLING_RECORDING 2969
#define LANG_LOG_CIRCUITBUILD_NON_LIVE_TIMEOUT 2970
#define LANG_LOG_CIRCUITBUILD_TIMEOUT_TOO_LARGE_1 2971
#define LANG_LOG_CIRCUITBUILD_TIMEOUT_TOO_LARGE_2 2972
#define LANG_LOG_CIRCUITBUILD_CONNECTION_SPEED_CHANGED 2973
#define LANG_LOG_CIRCUITBUILD_MEASUREMENT_PERIOD_TOO_LARGE 2974
#define LANG_LOG_CIRCUITBUILD_SET_BUILDTIMEOUT_TO_LOW_VALUE 2975
#define LANG_LOG_CIRCUITBUILD_TIMEOUT_DATA_1 2976
#define LANG_LOG_CIRCUITBUILD_TIMEOUT_DATA_2 2977
#define LANG_LOG_CIRCUITBUILD_TIMEOUT_SET 2978
#define LANG_LOG_CIRCUITUSE_CIRC_TIMEOUT_WITH_STREAMS 2979
#define LANG_LOG_CIRCUITUSE_CLOCK_JUMP 2980
#define LANG_LOG_CIRCUITUSE_BUILDING_NEW_TEST_CIRC 2981
#define LANG_LOG_CIRCUITUSE_ANCIENT_CIRCUIT 2982
#define LANG_LOG_CIRCUITUSE_CIRCUIT_DIED 2983
#define LANG_LOG_CIRCUITUSE_APPLICATION_REQUEST_FAILED 2984
#define LANG_LOG_CONFIG_STARTING_GEOIP_STATS_INTERVAL_1 2985
#define LANG_LOG_CONFIG_STARTING_GEOIP_STATS_INTERVAL_2 2986
#define LANG_LOG_CONFIG_MEASURE_STATISTICS 2987
#define LANG_LOG_CONFIG_OPTION_SEEN 2988
#define LANG_LOG_CONFIG_REFUSEUNKNOWNEXITS 2989
#define LANG_LOG_CONFIG_DISABLING_DIRPORT 2990
#define LANG_LOG_CONFIG_SOCKS4_PARSE_ERROR 2991
#define LANG_LOG_CONFIG_SOCKS5_PARSE_ERROR 2992
#define LANG_LOG_CONFIG_SOCKS4_AND_SOCKS5 2993
#define LANG_LOG_CONFIG_SOCKS5_USERNAME_LENGTH_ERROR 2994
#define LANG_LOG_CONFIG_SOCKS5_PASSWORD_LENGTH_ERROR 2995
#define LANG_LOG_CONFIG_SOCKS5_USER_WITHOUT_PASS 2996
#define LANG_LOG_CONFIG_BAD_OWNINGCONTROLLERPROCESS 2997
#define LANG_LOG_CONFIG_SOCKS_WITHOUT_TUNNEL 2998
#define LANG_LOG_CONNECTION_NEW_CONTROL_CONN 2999
#define LANG_LOG_CONNECTION_UNIX_SOCKET_PATH_TOO_LONG 3000
#define LANG_LOG_CONNECTION_GETSOCKNAME 3001
#define LANG_LOG_CONNECTION_ENCODING_HTTPS_AUTH_FAILED 3002
#define LANG_LOG_CONNECTION_SOCKS4_IPV6 3003
#define LANG_LOG_CONNECTION_INVALID_PROXY_PROTOCOL 3004
#define LANG_LOG_CONNECTION_SET_STATE 3005
#define LANG_LOG_CONNECTION_OVERSIZED_HTTPS_RESPONSE 3006
#define LANG_LOG_CONNECTION_INCOMPLETE_HTTPS_RESPONSE 3007
#define LANG_LOG_CONNECTION_UNPARSEABLE_PROXY_HEADERS 3008
#define LANG_LOG_CONNECTION_HTTPS_CONNECT_SUCCESS 3009
#define LANG_LOG_CONNECTION_HTTPS_PROXY_REFUSE 3010
#define LANG_LOG_CONNECTION_UNEXPECTED_HTTPS_STATUS 3011
#define LANG_LOG_CONNECTION_ENTER_STATE 3012
#define LANG_LOG_CONNECTION_INVALID_PROXY_STATE 3013
#define LANG_LOG_CONNECTION_LEAVING_STATE 3014
#define LANG_LOG_CONNECTION_UNABLE_TO_CONNECT_1 3015
#define LANG_LOG_CONNECTION_UNABLE_TO_CONNECT_2 3016
#define LANG_LOG_CONNECTION_CONN_SUCCESSFULL 3017
#define LANG_LOG_CONNECTION_EDGE_REJECT_PRIVATE_ADDRESS_1 3018
#define LANG_LOG_CONNECTION_EDGE_REJECT_PRIVATE_ADDRESS_2 3019
#define LANG_LOG_CONNECTION_EDGE_NO_DOT_EXIT 3020
#define LANG_LOG_CONNECTION_OR_RENEGOTIATE_1 3021
#define LANG_LOG_CONNECTION_OR_RENEGOTIATE_2 3022
#define LANG_LOG_CONTROL_WRITE_FAILED 3023
#define LANG_LOG_CONTROL_TAKE_OWNERSHIP 3024
#define LANG_LOG_CONTROL_SHUTDOWN_1 3025
#define LANG_LOG_CONTROL_SHUTDOWN_2 3026
#define LANG_LOG_CONTROL_ERROR_MONITORING_PROCESS 3027
#define LANG_LOG_DIRECTORY_AUTHORITY_BANNED 3028
#define LANG_LOG_DIRECTORY_MIRROR_BANNED 3029
#define LANG_LOG_DIRECTORY_MALFORMED_BRIDGE_FINGERPRINT 3030
#define LANG_LOG_DIRECTORY_CONNECT_THROUGH_SOCKS 3031
#define LANG_LOG_DIRECTORY_REJECT_VOTE 3032
#define LANG_LOG_DIRECTORY_INVALID_BW_FILE_1 3033
#define LANG_LOG_DIRECTORY_INVALID_BW_FILE_2 3034
#define LANG_LOG_DIRECTORY_INVALID_BW_FILE_3 3035
#define LANG_LOG_DIRECTORY_INVALID_BW_FILE_4 3036
#define LANG_LOG_DIRECTORY_INVALID_BW_FILE_5 3037
#define LANG_LOG_DIRECTORY_INVALID_BW_FILE_6 3038
#define LANG_LOG_DIRECTORY_NODE_ID_NOT_FOUND 3039
#define LANG_LOG_DIRECTORY_BW_FILE_ERROR_1 3040
#define LANG_LOG_DIRECTORY_BW_FILE_ERROR_2 3041
#define LANG_LOG_DIRECTORY_BW_FILE_ERROR_3 3042
#define LANG_LOG_DIRECTORY_BW_FILE_ERROR_4 3043
#define LANG_LOG_DIRECTORY_BW_FILE_READ 3044
#define LANG_LOG_DIRECTORY_DIGEST_ERROR 3045
#define LANG_LOG_DIRECTORY_ERROR_PARSING_IP 3046
#define LANG_LOG_DIRVOTE_INSUFFICIENT_MEMORY_1 3047
#define LANG_LOG_DIRVOTE_INSUFFICIENT_MEMORY_2 3048
#define LANG_LOG_DIRVOTE_INSUFFICIENT_MEMORY_3 3049
#define LANG_LOG_DIRVOTE_INSUFFICIENT_MEMORY_4 3050
#define LANG_LOG_DIRVOTE_INSUFFICIENT_MEMORY_5 3051
#define LANG_LOG_DIRVOTE_NO_MICRODESC_LINE_IN_VOTE 3052
#define LANG_LOG_DIRVOTE_BW_WEIGHT_MISMATCH 3053
#define LANG_LOG_DIRVOTE_CONSENSUS_WITH_EMPTY_BW 3054
#define LANG_LOG_DIRVOTE_BW_WEIGHTS_ERROR 3055
#define LANG_LOG_DIRVOTE_BW_WEIGHTS_ERROR_2 3056
#define LANG_LOG_DIRVOTE_BW_WEIGHTS_ERROR_3 3057
#define LANG_LOG_DIRVOTE_TOO_MUCH_MIDDLE_BW 3058
#define LANG_LOG_DIRVOTE_BW_WEIGHTS_CASE_3_ERROR 3059
#define LANG_LOG_DIRVOTE_BW_WEIGHTS_CASE_3_ERROR_2 3060
#define LANG_LOG_DIRVOTE_COMPUTED_BW_WEIGHTS 3061
#define LANG_LOG_DIRVOTE_COMPUTED_BW_WEIGHTS_2 3062
#define LANG_LOG_DIRVOTE_BAD_ELEMENT_IN_BW_WEIGHT 3063
#define LANG_LOG_DIRVOTE_NO_NS_CONSENSUS 3064
#define LANG_LOG_DIRVOTE_COULDNT_FORMAT_SIGNATURES 3065
#define LANG_LOG_DIRVOTE_NO_VOTES_FOR_RUNNING 3066
#define LANG_LOG_DIRVOTE_COULDNT_GENERATE_CONSENSUS 3067
#define LANG_LOG_DIRVOTE_ERROR_PARSING_CONSENSUS 3068
#define LANG_LOG_DIRVOTE_ERROR_PARSING_MICRODESC 3069
#define LANG_LOG_DNS_NO_EVDNS_BASE 3070
#define LANG_LOG_DNS_MEM_USAGE 3071
#define LANG_LOG_GEOIP_DUPLICATE_REQUEST_ID 3072
#define LANG_LOG_HIBERNATE_ACC_INTERVAL_MOVED 3073
#define LANG_LOG_HIBERNATE_ACC_ELAPSED 3074
#define LANG_LOG_MAIN_ERROR_REMOVING_EVENT_1 3075
#define LANG_LOG_MAIN_ERROR_REMOVING_EVENT_2 3076
#define LANG_LOG_MAIN_ERROR_ROTATING_KEYS 3077
#define LANG_LOG_MAIN_ERROR_LOADING_V3_CERTS 3078
#define LANG_LOG_MICRODESC_ERROR_DUMPING_MICRODESC 3079
#define LANG_LOG_MICRODESC_RELOADED_MICRODESCS 3080
#define LANG_LOG_MICRODESC_REMOVED_MICRODESCS 3081
#define LANG_LOG_MICRODESC_REBUILD 3082
#define LANG_LOG_MICRODESC_ERROR_MAPPING_FILE 3083
#define LANG_LOG_MICRODESC_DONE_REBUILDING 3084
#define LANG_LOG_NETWORKSTATUS_BAD_SIGNATURE_2 3085
#define LANG_LOG_NETWORKSTATUS_UNVERIFIABLE_SIGNATURE 3086
#define LANG_LOG_NETWORKSTATUS_UNRECOGNIZED_AUTHORITIES 3087
#define LANG_LOG_NETWORKSTATUS_INVALID_SIGNATURE_2 3088
#define LANG_LOG_NETWORKSTATUS_MISSING_KEYS 3089
#define LANG_LOG_NETWORKSTATUS_UNRECOGNIZED_FLAVOR 3090
#define LANG_LOG_NETWORKSTATUS_UNEXPECTED_FLAVOR 3091
#define LANG_LOG_NETWORKSTATUS_PARAMETER_TOO_SMALL 3092
#define LANG_LOG_NETWORKSTATUS_PARAMETER_TOO_LARGE 3093
#define LANG_LOG_NETWORKSTATUS_WEIGHT_TOO_LARGE 3094
#define LANG_LOG_RELAY_NOT_RESUMING 3095
#define LANG_LOG_RELAY_DISABLED_CELL_EWMA 3096
#define LANG_LOG_RELAY_ENABLED_CELL_EWMA 3097
#define LANG_LOG_RELAY_ERROR_DETERMINING_INSERTION_TIME 3098
#define LANG_LOG_RENDCLIENT_NO_USABLE_INTRO_POINTS 3099
#define LANG_LOG_RENDCLIENT_REEXTEND_CIRCUIT 3100
#define LANG_LOG_RENDCLIENT_CLOSING_INTRO_CIRC 3101
#define LANG_LOG_RENDCLIENT_PURGING_REQUEST_TABLE 3102
#define LANG_LOG_RENDCLIENT_UNKNOWN_SERVICE 3103
#define LANG_LOG_RENDCLIENT_CLOSING_DIR_CONN 3104
#define LANG_LOG_RENDCLIENT_EXLUDED_INTRO_NODES 3105
#define LANG_LOG_RENDCOMMON_PURGING_DESCRIPTOR_CACHE 3106
#define LANG_LOG_RENDCOMMON_RECEIVED_DIFFERENT_DESCRIPTOR 3107
#define LANG_LOG_RENDSERVICE_DUPLICATE_HS 3108
#define LANG_LOG_RENDSERVICE_ONLY_V2 3109
#define LANG_LOG_RENDSERVICE_REPLAY_DETECTED_2 3110
#define LANG_LOG_RENDSERVICE_EXCLUDED_NODE 3111
#define LANG_LOG_RENDSERVICE_ENOUGH_INTRO_CIRCS 3112
#define LANG_LOG_REPHIST_ROUTER_ADDRESS_CHANGED 3113
#define LANG_LOG_REPHIST_ERROR_PARSING_VALUE 3114
#define LANG_LOG_REPHIST_ERROR_PARSING_MAXIMUM 3115
#define LANG_LOG_REPHIST_WRITING_EXIT_STATS 3116
#define LANG_LOG_REPHIST_ERROR_WRITING_EXIT_STATS 3117
#define LANG_LOG_REPHIST_NOTE_EXIT_BYTES 3118
#define LANG_LOG_REPHIST_OPENED_EXIT_STREAM 3119
#define LANG_LOG_REPHIST_WRITING_CELL_STATISTICS_FAILED 3120
#define LANG_LOG_ROUTER_CANT_SELF_TEST 3121
#define LANG_LOG_ROUTER_ADDRESS_CHOSEN 3122
#define LANG_LOG_ROUTER_DESCRIPTOR_DIRTY 3123
#define LANG_LOG_ROUTER_ADDING_STATS 3124
#define LANG_LOG_ROUTER_EXTRAINFO_STATS_TOO_BIG 3125
#define LANG_LOG_ROUTER_EXTRAINFO_TOO_BIG 3126
#define LANG_LOG_ROUTER_ERROR_APPENDING_SIGNATURE 3127
#define LANG_LOG_ROUTER_ERROR_GENERATING_EXTRAINFO_DESC 3128
#define LANG_LOG_ROUTERLIST_EMPTY_ROUTERLIST 3129
#define LANG_LOG_ROUTERLIST_EMPTY_ROUTERLIST_2 3130
#define LANG_LOG_ROUTERLIST_NEGATIVE_BW_WEIGHTS 3131
#define LANG_LOG_ROUTERLIST_CONSENSUS_NOT_LISTING_BW 3132
#define LANG_LOG_ROUTERLIST_CHOOSING_NODE 3133
#define LANG_LOG_ROUTERLIST_WEIGHTED_BW 3134
#define LANG_LOG_ROUTERLIST_ROUND_OFF_ERROR 3135
#define LANG_LOG_ROUTERLIST_REPLACING_NON_BRIDGE_DESC 3136
#define LANG_LOG_ROUTERLIST_DROPPING_BRIDGE_DESC 3137
#define LANG_LOG_ROUTERLIST_DESC_NOT_A_BRIDGE 3138
#define LANG_LOG_ROUTERLIST_NO_SOURCE_FROM_VOTE 3139
#define LANG_LOG_ROUTERLIST_LEARNED_FROM_VOTE 3140
#define LANG_LOG_ROUTERPARSE_UNABLE_TO_PARSE_DESC 3141
#define LANG_LOG_ROUTERPARSE_INVALID_EXPONENT_IN_ONION_KEY 3142
#define LANG_LOG_ROUTERPARSE_TOO_FEW_ARGUMENTS_TO_R 3143
#define LANG_LOG_ROUTERPARSE_INVALID_MEASURED_BW 3144
#define LANG_LOG_ROUTERPARSE_NO_BW_WEIGHTS_IN_CONSENSUS 3145
#define LANG_LOG_ROUTERPARSE_UNEXPECTED_WMM 3146
#define LANG_LOG_ROUTERPARSE_UNEXPECTED_WEM 3147
#define LANG_LOG_ROUTERPARSE_UNEXPECTED_WGM 3148
#define LANG_LOG_ROUTERPARSE_UNEXPECTED_WED 3149
#define LANG_LOG_ROUTERPARSE_UNEXPECTED_WGG 3150
#define LANG_LOG_ROUTERPARSE_UNEXPECTED_WEE 3151
#define LANG_LOG_ROUTERPARSE_UNEXPECTED_WGD 3152
#define LANG_LOG_ROUTERPARSE_BW_WEIGHT_FAILURE_1 3153
#define LANG_LOG_ROUTERPARSE_BW_WEIGHT_FAILURE_2 3154
#define LANG_LOG_ROUTERPARSE_BW_WEIGHT_FAILURE_3 3155
#define LANG_LOG_ROUTERPARSE_BW_WEIGHT_FAILURE_4 3156
#define LANG_LOG_ROUTERPARSE_BW_WEIGHT_FAILURE_5 3157
#define LANG_LOG_ROUTERPARSE_BW_WEIGHT_FAILURE_6 3158
#define LANG_LOG_ROUTERPARSE_BW_WEIGHT_FAILURE_7 3159
#define LANG_LOG_ROUTERPARSE_BW_WEIGHT_FAILURE_8 3160
#define LANG_LOG_ROUTERPARSE_BW_WEIGHT_FAILURE_9 3161
#define LANG_LOG_ROUTERPARSE_BW_WEIGHT_INVALID 3162
#define LANG_LOG_ROUTERPARSE_UNKNOWN_FLAVOR 3163
#define LANG_LOG_ROUTERPARSE_INVALID_FLAVOR 3164
#define LANG_LOG_ROUTERPARSE_EXTRANEOUS_TOKEN 3165
#define LANG_LOG_ROUTERPARSE_MISPLACED_TOKEN 3166
#define LANG_LOG_ROUTERPARSE_BAD_ELEMENT_IN_PARAMS_3 3167
#define LANG_LOG_ROUTERPARSE_ERROR_DECODING_SIGNING_KEY 3168
#define LANG_LOG_ROUTERPARSE_MULTIPLE_SIGNATURES_ON_VOTE 3169
#define LANG_LOG_ROUTERPARSE_UNRECOGNIZED_ALGORITHM_NAME 3170
#define LANG_LOG_ROUTERPARSE_MULTIPLE_DIGESTS 3171
#define LANG_LOG_ROUTERPARSE_BAD_ENCODING 3172
#define LANG_LOG_ROUTERPARSE_DUPLICATE_SIGNATURES 3173
#define LANG_LOG_ROUTERPARSE_UNPARSEABLE_MICRODESC 3174
#define LANG_LOG_ROUTERPARSE_ERROR_PARSING_MICRODESC_1 3175
#define LANG_LOG_BUFFERS_SOCKS5_WITHOUT_AUTHENTICATION 3176
#define LANG_LOG_BUFFERS_SOCKS5_NO_AUTHENTICATION 3177
#define LANG_LOG_BUFFERS_SOCKS5_NEED_AUTHENTICATION 3178
#define LANG_LOG_BUFFERS_SOCKS5_AUTHENTICATION_SUCCESSFULL 3179
#define LANG_LOG_CIRCUITBUILD_STRANGE_BUILD_TIME 3180
#define LANG_LOG_CONNECTION_EDGE_NO_DOT_ONION 3181

#define LANG_DLG_PER_CONN_BW_RATE 3182
#define LANG_DLG_PER_CONN_BW_BURST 3183
#define LANG_DLG_LEARN_CIRC_BUILD_TIMEOUT 3184
#define LANG_DLG_CIRC_STREAM_TIMEOUT 3185
#define LANG_DLG_CELL_SCALE_FACTOR 3186
#define LANG_DLG_REFUSE_UNKNOWN_EXITS 3187
#define LANG_DLG_IDENTITY_REINIT_KEYS 3188
#define LANG_DLG_IDENTITY_REINIT_KEYS_HINT 3189

#define LANG_BRIDGES_INVALID_CA 3190

#define LANG_LOG_CONFIG_NTLMPROXY_PARSE_FAILED 3191
#define LANG_LOG_CONFIG_NTLMPROXYAUTHENTICATOR_TOO_LONG 3192
#define LANG_LOG_CONNECTION_NTLM_CONNECT_SUCCESS 3193
#define LANG_LOG_CONNECTION_UNEXPECTED_NTLM_STATUS 3194
#define LANG_LOG_NTLM_MESSAGE_TYPE_1 3195
#define LANG_LOG_NTLM_CHALLENGE 3196
#define LANG_LOG_NTLM_UNSUPPORTED_AUTH 3197

#define LANG_DLG_BRIDGES_NTLM_PROXY 3198
#define LANG_DLG_BRIDGES_NTLM_DOMAIN 3199
#define LANG_DLG_BRIDGES_NTLM_ACCOUNT 3200
#define LANG_LOG_NO_LIBEVENT 3201
#define LANG_LOG_ROUTERPARSE_INTRO_POINT_TOO_SMALL 3202
#define LANG_LOG_PROXY_INVALID_CHUNK_SIZE_1 3203
#define LANG_LOG_PROXY_INVALID_CHUNK_SIZE_2 3204

#define LANG_LOG_CONFIG_ERROR_ALLOCATING_BRIDGEPASSWORD 3205
#define LANG_LOG_CONTROL_SAFE_COOKIE_WITH_WRONG_LENGTH 3206
#define LANG_LOG_CONTROL_INCORRECT_SAFE_COOKIE_AUTH_RESPONSE 3207
#define LANG_LOG_ROUTERLIST_NOT_ENOUGH_EXIT_DESCS 3208
#define LANG_LOG_CONNECTION_OR_TOO_MUCH_DATA_1 3209
#define LANG_LOG_CONNECTION_OR_TOO_MUCH_DATA_2 3210

#define LANG_DLG_SYSTEM_HOTKEY_HIDEALL 3211
#define LANG_DLG_SYSTEM_HOTKEY_PAUSEALL 3212
#define LANG_DLG_SYSTEM_HOTKEY_RESUMEALL 3213
#define LANG_LOG_DLG_HOTKEY_HIDEALL_UNREGISTER 3214
#define LANG_LOG_DLG_HOTKEY_RESTOREALL_UNREGISTER 3215
#define LANG_LOG_DLG_HOTKEY_HIDEALL_UNREGISTER_FAIL 3216
#define LANG_LOG_DLG_HOTKEY_RESTOREALL_UNREGISTER_FAIL 3217
#define LANG_LOG_DLG_HOTKEY_HIDEALL_SUCCESS 3218
#define LANG_LOG_DLG_HOTKEY_RESTOREALL_SUCCESS 3219
#define LANG_LOG_DLG_HOTKEY_HIDEALL_FAIL 3220
#define LANG_LOG_DLG_HOTKEY_RESTOREALL_FAIL 3221

#define LANG_LOG_DIRVOTE_INVALID_TIME 3222
#define LANG_LOG_POLICIES_REJECTING_NULL_ADDRESS 3223
#define LANG_DLG_PROXY_USER_PASS 3224
#define LANG_HS_GEN_TITLE 3225
#define LANG_HS_GEN_HINT 3226
#define LANG_HS_GEN_PREFIX 3227
#define LANG_HS_GEN_ADDRESS 3228
#define LANG_HS_GEN_RETRY 3229
#define LANG_HS_GEN_CANCEL 3230
#define LANG_HS_GEN_CLOSE 3231

#define LANG_NETINFO_BLACKLISTED 3232
#define LANG_DLG_GEOIP_BLACKLIST 3233
#define LANG_MB_ERROR_UPDATING_TREE 3234

#define LANG_DLG_HTTP_BROWSER_TYPE_NOCHANGE 3235

#define LANG_LB_BYPASSBL 3236
#define LANG_DLG_BYPASSBL_RECENT_EXITS 3237
#define LANG_DLG_BYPASSBL_RECENT_EXITS_HINT 3238
#define LANG_DLG_BYPASSBL_MAX_UPTIME 3239
#define LANG_DLG_BYPASSBL_MAX_BLACKLISTED_TIME 3240
#define LANG_DLG_BYPASSBL_MAX_BLACKLISTED_TIME_UNIT 3241
#define LANG_DLG_BYPASSBL_SAVE_NODE_STATS 3242
#define LANG_DLG_BYPASSBL_EXCLUDE_GEOIP_BANS 3243
#define LANG_DLG_BYPASSBL_RESERVED 3244
#define LANG_DLG_BYPASSBL_RESERVED_HINT 3245
#define LANG_EXIT_DLG_RECENT_EXITS 3246

#define LANG_DLG_IDENTITY_MESSAGEBOX 3247
#define LANG_DLG_IDENTITY_MESSAGEBOX_HINT 3248
#define LANG_DLG_IDENTITY_EVERY_TIME 3249
#define LANG_DLG_IDENTITY_AUTOMATIC_IP_CHANGE 3250
#define LANG_DLG_IDENTITY_AUTOMATIC_IDENTITY_CHANGE 3251
#define LANG_DLG_IDENTITY_AUTOMATIC_CHANGE_HINT 3252

#define LANG_DLG_TIME_UNIT_SECONDS 3253
#define LANG_DLG_TIME_UNIT_MINUTES 3254
#define LANG_DLG_TIME_UNIT_HOURS 3255
#define LANG_DLG_TIME_UNIT_DAYS 3256
#define LANG_DLG_TIME_UNIT_WEEKS 3257
#define LANG_DLG_TIME_UNIT_MONTHS 3258
#define LANG_DLG_TIME_UNIT_YEARS 3259

#define LANG_LOG_RENDSERVICE_ENABLING 3260
#define LANG_LOG_RENDSERVICE_DISABLING 3261

#define LANG_MAX 3262

#endif
